using System;
using System.ComponentModel.DataAnnotations;
using System.Web.Script.Serialization;
namespace Social.Entity.Tik
{
    [Serializable]
    public class UserFamily
    {
        private JavaScriptSerializer jss = new JavaScriptSerializer();

		public Guid ID { get; set; }
		public Guid UserID { get; set; }
		public String FamilyWith { get; set; }
		public Byte FamilyType { get; set; }
		public Byte Status { get; set; }
        [NotMapped]
        public string FamilyUserName
        {
            get
            {
                if (string.IsNullOrEmpty(FamilyWith)) return string.Empty;
                if (string.IsNullOrEmpty(FamilyWith.Trim()))
                {
                    return string.Empty;
                }
                else
                {
                    var dict = jss.Deserialize<dynamic>(FamilyWith.Trim());
                    return dict["Name"];
                }
            }
        }

        [NotMapped]
        public string FamilyUserAvatar
        {
            get
            {
                if (string.IsNullOrEmpty(FamilyWith)) return string.Empty;
                if (string.IsNullOrEmpty(FamilyWith.Trim()))
                {
                    return string.Empty;
                }
                else
                {
                    var dict = jss.Deserialize<dynamic>(FamilyWith.Trim());
                    return string.IsNullOrEmpty(dict["SmallAvatar"]) ? "/Content/Images/avatar_32x32.jpg" : dict["SmallAvatar"];
                }
            }
        }

        [NotMapped]
        public string FamilyUserID
        {
            get
            {
                if (string.IsNullOrEmpty(FamilyWith)) return string.Empty;
                if (string.IsNullOrEmpty(FamilyWith.Trim()))
                {
                    return string.Empty;
                }
                else
                {
                    var dict = jss.Deserialize<dynamic>(FamilyWith.Trim());
                    return dict["ID"];
                }
            }
        }
    }
}
