﻿using System;
using System.ComponentModel.DataAnnotations;
using Social.Lib;
using System.Configuration;
using System.Web.Script.Serialization;

namespace Social.Entity.Tik
{
    [Serializable]
    public class UserProfile
    {
        public Guid ID { get; set; }
        public string Email { get; set; }
        public string FirstName { get; set; }
        public string LastName { get; set; }
        public string UserName { get; set; }
        public bool IsActive { get; set; }
        public byte Gender { get; set; }
        public DateTime BirthDay { get; set; }
        public string AboutMe { get; set; }
        public string Mobile { get; set; }
        public string InterestedIn { get; set; }
        private string _homeAddress { get; set; }
        public string HomeAddress
        {
            get { return _homeAddress; }
            set { _homeAddress = value; }
        }

        private JavaScriptSerializer jss = new JavaScriptSerializer();

        [NotMapped]
        public string HomeAddressName
        {
            get
            {
                if (string.IsNullOrEmpty(_homeAddress)) return string.Empty;
                if (string.IsNullOrEmpty(_homeAddress.Trim()))
                {
                    return string.Empty;
                }
                else
                {
                    try
                    {
                        var dict = jss.Deserialize<dynamic>(_homeAddress.Trim());
                        return dict["Name"];
                    }
                    catch { return string.Empty; }
                }
            }
        }
        private string _currentAddress { get; set; }
        public string CurrentAddress
        {
            get { return _currentAddress; }
            set { _currentAddress = value; }
        }
        [NotMapped]
        public string CurrentAddressName
        {
            get
            {
                if (string.IsNullOrEmpty(_currentAddress)) return string.Empty;
                if (string.IsNullOrEmpty(_currentAddress.Trim()))
                {
                    return string.Empty;
                }
                else
                {
                    try
                    {
                        var dict = jss.Deserialize<dynamic>(_currentAddress.Trim());
                        return dict["Name"];
                    }
                    catch { return string.Empty; }
                }
            }
        }
        public byte MaritalStatus { get; set; }
        public string MaritialWith { get; set; }
        public DateTime LastLoginDate { get; set; }
        public DateTime RegisterDate { get; set; }

        private string _smallAvatarUrl = string.Empty;
        [Column("SmallAvatarUrl")]
        public string SmallAvatarUrlMap
        {
            get { return _smallAvatarUrl; }
            set { _smallAvatarUrl = value; }
        }
        [NotMapped]
        public string SmallAvatarUrl
        {
            get
            {
                if (String.IsNullOrWhiteSpace(_smallAvatarUrl))
                    return Gender == 1 ? ConfigManager.StaticServer + "/Content/Images/male.gif" : ConfigManager.StaticServer + "/Content/Images/female.gif";
                else
                {
                    if (!_smallAvatarUrl.Contains("http://"))
                        return string.Concat(ConfigurationManager.AppSettings["AvatarServerUrl"], _smallAvatarUrl);
                    return _smallAvatarUrl;
                }
            }
        }

        private string _mediumAvatarUrl = string.Empty;
        [Column("MediumAvatarUrl")]
        public string MediumAvatarUrlMap
        {
            get { return _mediumAvatarUrl; }
            set { _mediumAvatarUrl = value; }
        }
        [NotMapped]
        public string MediumAvatarUrl
        {
            get
            {
                if (String.IsNullOrWhiteSpace(_mediumAvatarUrl))
                    return Gender == 1 ? ConfigManager.StaticServer + "/Content/Images/male.gif" : ConfigManager.StaticServer + "/Content/Images/female.gif";
                else
                {
                    if (!_mediumAvatarUrl.Contains("http://"))
                        return string.Concat(ConfigurationManager.AppSettings["AvatarServerUrl"], _mediumAvatarUrl);
                    return _mediumAvatarUrl;
                }
            }
        }

        public string LargeAvatarUrl { get; set; }
        public string Password { get; set; }
        [NotMapped]
        public virtual string FullName { get { return LastName + " " + FirstName; } }
        [NotMapped]
        public virtual string ProfileLink
        {
            get
            {
                if (String.IsNullOrWhiteSpace(UserName))
                    return ConfigManager.MainDomain + "/" + ID;
                return ConfigManager.MainDomain + "/" + UserName;

            }
        }
    }
}
