﻿using System;
using System.ComponentModel.DataAnnotations;
using Social.Lib;
using System.Configuration;

namespace Social.Entity.Tik
{
    [Serializable]
    public class UserProfileAndCountUserFriend
    {
        public Guid ID { get; set; }
        [Required]
        public string Email { get; set; }
        [Required]
        public string FirstName { get; set; }
        [Required]
        public string LastName { get; set; }
        public string UserName { get; set; }

        public bool IsActive { get; set; }

        public byte Gender { get; set; }

        
        public DateTime BirthDay { get; set; }
        public string AboutMe { get; set; }
        public string Mobile { get; set; }
        public string InterestedIn { get; set; }
        public string HomeAddress { get; set; }
        public string CurrentAddress { get; set; }
        public byte MaritalStatus { get; set; }
        public string MaritialWith { get; set; }
        public DateTime LastLoginDate { get; set; }
        public string SmallAvatarUrl { get; set; }
        public string LargeAvatarUrl { get; set; }
        public string MediumAvatarUrl { get; set; }
        public string Password { get; set; }
        public int UserCount { get; set; }
        [NotMapped]
        public virtual string FullName { get { return LastName + " " + FirstName; } }
        [NotMapped]
        public virtual string ProfileLink
        {
            get
            {
                if (String.IsNullOrWhiteSpace(UserName))
                    return ConfigManager.MainDomain + "/" + ID;
                return ConfigManager.MainDomain + "/" + UserName;

            }
        }
    }
    
    
}
