using System;
using System.ComponentModel.DataAnnotations;
namespace Social.Entity.TikApplication
{
    [Serializable]
    public class Note
    {
		public Guid ID { get; set; }
		public Guid UserID { get; set; }
		public String Title { get; set; }
		public String Body { get; set; }
		public String Tags { get; set; }
		public String Photo { get; set; }
		public Byte PrivacyType { get; set; }
		public String PrivacyPeople { get; set; }
		public Byte Status { get; set; }
		public Int32 ViewCount { get; set; }
		public DateTime CreatedDate { get; set; }
		public DateTime ModifiedDate { get; set; }
		public Int32 LikeCount { get; set; }
		public Int32 CommentCount { get; set; }
		public Boolean IsUserLike { get; set; }

        [NotMapped]
        public string ShortDescription
        {
            get
            {
                return Social.Lib.Utility.Utility.RemoveHtmlTagAndSubString(this.Body, 20);
            }
        }

        [NotMapped]
        public string PhotoUrl
        {
            get
            {
                return string.IsNullOrEmpty(this.Photo) ? string.Empty : Social.Lib.Utility.Utility.UrlThumbAlbumOrPhoto(this.Photo);
            }
        }

        [NotMapped]
        public string Url
        {
            get
            {
                return "/Note/View/Index/" + this.ID;
            }
        }
    }
}
