using System;
using System.ComponentModel.DataAnnotations;
using Social.Lib;
using System.Configuration;
namespace Social.Entity.TikFriend
{
    [Serializable]
    public class FriendRequestAndUserProfile
    {
		public Guid ID { get; set; }
		public Guid FromUserID { get; set; }
		public Guid ToUserID { get; set; }
		public Guid SuggestByUserID { get; set; }
		public DateTime CreatedDate { get; set; }
		public DateTime UpdatedDate { get; set; }
		public Boolean Status { get; set; }
		public Guid FriendListID { get; set; }
		public String Message { get; set; }
        public string FirstName{get;set;}
        public string LastName{get;set;}
        private string _smallAvatarUrl;
        public byte Gender { get; set; }
        public string UserName { get; set; }

        public string SmallAvatarUrl
        {
            get
            {
                if (String.IsNullOrWhiteSpace(_smallAvatarUrl))
                    return Gender == 1 ? ConfigManager.StaticServer + "/Content/Images/male.gif" : ConfigManager.StaticServer + "/Content/Images/female.gif";
                else
                {
                    if (!_smallAvatarUrl.Contains("http://"))
                        return string.Concat(ConfigurationManager.AppSettings["AvatarServerUrl"], _smallAvatarUrl);
                    return _smallAvatarUrl;
                }
            }
            set { _smallAvatarUrl = value; }
        }

        [NotMapped]
        public virtual string FullName { get { return LastName + " " + FirstName; } }
        [NotMapped]
        public virtual string ProfileLink
        {
            get
            {
                if (String.IsNullOrWhiteSpace(UserName))
                    return ConfigManager.MainDomain + "/" + ID;
                return ConfigManager.MainDomain + "/" + UserName;

            }
        }
        [NotMapped]
        public virtual int CountFriend { get; set; }
       
    }
}
