using System;
using System.ComponentModel.DataAnnotations;
using System.Configuration;
namespace Social.Entity.TikFriend
{
    [Serializable]
    public class FriendRequestDTO
    {
		public Guid ID { get; set; }
		public Guid FromUserID { get; set; }
		public Guid ToUserID { get; set; }
		public Guid SuggestByUserID { get; set; }
		public DateTime CreatedDate { get; set; }
		public DateTime UpdatedDate { get; set; }
		public Boolean Status { get; set; }
		public Guid FriendListID { get; set; }
		public String Message { get; set; }
        public string FullName { get; set; }
        public string SmallAvatar { get; set; }
        public string ProfileLink { get; set; }

        private string _smallavatar;

        public string FriendSmallAvatarUrl
        {
            get
            {

                if (!_smallavatar.Contains("http://"))
                    return string.Concat(ConfigurationManager.AppSettings["AvatarServerUrl"], _smallavatar);
                return _smallavatar;

            }
            set { _smallavatar = value; }
        }
    }
}
