using System;
using System.ComponentModel.DataAnnotations;
using System.Configuration;
namespace Social.Entity.TikFriend
{
    [Serializable]
    public class UserFriend
    {
        public Guid ID { get; set; }
        public Guid OwnerID { get; set; }
        public Guid FriendID { get; set; }
        public String FriendUserName { get; set; }
        public String FriendFullName { get; set; }
        //public String FriendSmallAvatarUrl { get; set; }
        public Boolean Status { get; set; }
        public Guid SuggestedBy { get; set; }
        public DateTime CreatedDate { get; set; }
        public DateTime UpdatedDate { get; set; }
        public Int32 Impression { get; set; }

        private string _friendsmallavatarurl;

        public string FriendSmallAvatarUrl
        {
            get
            {
                if (string.IsNullOrEmpty(_friendsmallavatarurl))
                    return _friendsmallavatarurl;

                if (!_friendsmallavatarurl.Contains("http://"))
                    return string.Concat(ConfigurationManager.AppSettings["AvatarServerUrl"], _friendsmallavatarurl);

                return _friendsmallavatarurl;
            }
            set { _friendsmallavatarurl = value; }
        }
    }
}
