using System;
using System.ComponentModel.DataAnnotations;
using Social.Lib;
using System.Configuration;
namespace Social.Entity.TikMessage
{
    [Serializable]
    public class MessageCommentView
    {
		public Guid ID { get; set; }
		public Guid FromID { get; set; }
        public Guid MessageID { get; set; }
		public String MessageContent { get; set; }
		public DateTime CreatedDate { get; set; }
        public String FirstName { get; set; }
        public String LastName { get; set; }
        public String UserName { get; set; }
        [NotMapped]
        public virtual string FullName { get { return LastName + " " + FirstName; } }
        [NotMapped]
        public virtual string ProfileLink
        {
            get
            {
                if (String.IsNullOrWhiteSpace(UserName))
                    return ConfigManager.MainDomain + "/" + ID;
                return ConfigManager.MainDomain + "/" + UserName;

            }
        }
        public byte Gender { get; set; }
        private string _smallAvatarUrl;
        public string SmallAvatarUrl
        {
            get
            {
                if (String.IsNullOrWhiteSpace(_smallAvatarUrl))
                    return Gender == 1 ? ConfigManager.StaticServer + "/Content/Images/male.gif" : ConfigManager.StaticServer + "/Content/Images/female.gif";
                else
                {
                    if (!_smallAvatarUrl.Contains("http://"))
                        return string.Concat(ConfigurationManager.AppSettings["AvatarServerUrl"], _smallAvatarUrl);
                    return _smallAvatarUrl;
                }

            }
            set { _smallAvatarUrl = value; }
        }
    }
}
