using System;
using System.ComponentModel.DataAnnotations;
using Social.Lib;
namespace Social.Entity.TikMessage
{
    [Serializable]
    public class MessageRecipientView
    {
		public Guid ID { get; set; }
        public Guid RecipientID { get; set; }
        public Guid MessageID { get; set; }
        public bool UnRead { get; set; }
        public bool IsArchived { get; set; }
        public bool IsSpam { get; set; }
        public bool IsSender { get; set; }
        public String FirstName { get; set; }
        public String LastName { get; set; }
        public String UserName { get; set; }
        
        [NotMapped]
        public virtual string FullName { get { return LastName + " " + FirstName; } }
        [NotMapped]
        public virtual string ProfileLink
        {
            get
            {
                if (String.IsNullOrWhiteSpace(UserName))
                    return ConfigManager.MainDomain + "/" + ID;
                return ConfigManager.MainDomain + "/" + UserName;

            }
        }


    }
}
