using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
namespace Social.Entity.TikPhoto
{
    [Serializable]
    public class Album
    {
        [Key]
		public Guid ID { get; set; }
		public Guid UserID { get; set; }
		public String AlbumName { get; set; }
        public String Description { get; set; }
		public String Location { get; set; }
        public Guid CoverPhotoID { get; set; }
        public String SourceUrlCoverPhoto { get; set; }
        public Byte PrivacyType { get; set; }
        public String PrivacyPeopleShowHide { get; set; }
        public Byte Type { get; set; }
		public Int16 SortOrder { get; set; }
        public Int32 PhotoCount { get; set; }
		public Int32 ViewCount { get; set; }
		public Int32 LikeCount { get; set; }
		public Int32 CommentCount { get; set; }
        public DateTime CreatedDate { get; set; }
        public DateTime ModifiedDate { get; set; }

        public virtual ICollection<Photo> Photos { get; set; }

        [NotMapped]
        public string AlbumUrl
        {
            get
            {
                return "/Photo/AlbumDetail/" + this.ID;
            }
        }
    }
}
