using System;
using System.ComponentModel.DataAnnotations;
using System.Web.Script.Serialization;

namespace Social.Entity.TikPhoto
{
    [Serializable]
    public class Photo
    {
        [Key]        
		public Guid ID { get; set; }
        public Guid AlbumID { get; set; }
        public Guid UserID { get; set; }
		public String Caption { get; set; }
        public String SourceUrl { get; set; }
        public Int16 SortOrder { get; set; }
        public String WxH { get; set; }
		public Int32 ViewCount { get; set; }
		public Int32 LikeCount { get; set; }
		public Int32 CommentCount { get; set; }
        public Byte Status { get; set; }
        public Byte PrivacyType { get; set; }
        public String PrivacyPeopleShowHide { get; set; } 
        public DateTime CreatedDate { get; set; }
        public DateTime ModifiedDate { get; set; }

        [ForeignKey("AlbumID")]

        public virtual Album Album { get; set; }
        
        public string PhotoUrl
        {
            get
            {
                return "/Photo/PhotoDetail/" + this.ID;;
            }
        }
    }
}
