﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Social.Lib.Activity
{
    public class Constants
    {
        public class Activity
        {
            public enum ActivityType
            {
                Status = 1,
                Post = 2,
                Comment = 3,
                Like = 4,
                Friend = 5,
                Tag = 6,
                Profile = 7
            }

            public enum TargetType
            {
                None = 0,
                User = 1,
                Post = 2,
                Comment = 3,
                Like = 4
            }
            public enum ObjectType
            {
                Feed = 1,
                Image = 2,
                Album = 3,
                Comment = 4,
                Music = 5,
                Status = 6,
                Post = 7, 
                Note = 8,
                Link = 9,
                AlbumMusic = 10
            }
        }

        public class Feed
        {
            public enum FeedType
            {
                Status = 1,
                Post = 2,
                Comment = 3,
                Friend = 4
            }

            public enum TargetType
            {
                User = 1
            }

            public enum ObjectType
            {
                None = 0,
                Status = 1,
                Post = 2,
                Comment = 3,
                Image = 4,
                Album = 5,
                Video = 6,
                Link = 7,
                Audio = 8,
                Note = 9, 
                Music = 10,
                AlbumMusic = 11
            }

            public enum AttachmentType
            {
                None = 0,
                Image = 1,
                Album = 2,
                Video = 3,
                Link = 4,
                Music = 5,
                Status = 6,
                Note = 7
            }
        }
    
        public class Comment
        {
            public enum ObjectType
            {
                Feed = 1,
                Image = 2,
                Album = 3,
                Music = 4,
                AlbumMusic = 5,
                Status = 6,
                Post = 7,
                Note = 8,
                Link = 9
            }
        }

        public class Like
        {
            public enum ObjectType
            {
                Feed = 1,
                Image = 2,
                Album = 3,
                Music = 4,
                AlbumMusic = 5,
                Status = 6,
                Post = 7,
                Note = 8,
                Link = 9,
                Comment = 10
            }
        }
    
        public class FeedActivity
        {
            public enum Type
            {
                Post = 1,
                Link = 2,
                Image = 3,
                Album = 4,
                Friend = 5,
                Music = 6
            }
        }
        public class Tag
        {
            public enum Type
            {
                Post = 1,
                Link = 2,
                Image = 3,
                Album = 4,
                Friend = 5
            }

            public enum AttachmentType
            {
                None = 0,
                Image = 1,
                Album = 2,
                Video = 3,
                Link = 4,
                Audio = 5,
                Status = 6,
                Note = 7
            }
        }

        public class Notification
        {
            public enum NotificationType
            {
                Status = 1,
                Post = 2,
                Comment = 3,
                Like = 4,
                Friend = 5,
                Tag = 6,
                Profile = 7,
                TagPost = 8
            }

            public enum TargetType
            {
                None = 0,
                User = 1,
                Post = 2,
                Comment = 3,
                Like = 4
            }
            public enum ObjectType
            {
                Feed = 1,
                Image = 2,
                Album = 3,
                Comment = 4,
                Music = 5,
                Status = 6,
                Post = 7,
                Note = 8,
                Link = 9,
                AlbumMusic = 10,
                User = 11
            }
        }

        public class Profile
        {
            public enum Type
            {
                Avatar = 1,
                Relationship = 2
            }
        }

        public const string SUBJECT_MAIL = "Thư mời tham gia mạng cộng đồng Tik.vn";
        public const string CONTENT_MAIL = @"chào bạn";
        public const string MAIL_ACCOUNT = @"thuandv@ftc.vn";
        public const string MAIL_PASSWORD = @"dinhvanthuan129";
    }
}
