﻿using System;
using System.Text;

namespace Social.Lib
{
    public static class Base64String
    {
        /// <summary>
        /// Mã hóa 64 bit
        /// </summary>
        public static String Encode(String str)
        {
            if (String.IsNullOrEmpty(str))
                return str;

            try
            {
                var buffer = Encoding.UTF8.GetBytes(str);
                return Convert.ToBase64String(buffer);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }

        /// <summary>
        /// Dịch mã 64 bit
        /// </summary>
        public static String Decode(String str)
        {
            if (String.IsNullOrEmpty(str))
                return str;
            str = str.Replace(" ", "+");
            try
            {
                var encoder = new UTF8Encoding();
                var decoder = encoder.GetDecoder();

                var buffer = Convert.FromBase64String(str);
                var counter = decoder.GetCharCount(buffer, 0, buffer.Length);
                var decodedChars = new Char[counter];
                decoder.GetChars(buffer, 0, buffer.Length, decodedChars, 0);
                return new String(decodedChars);
            }
            catch (Exception ex)
            {
                throw new Exception(ex.Message);
            }
        }
    }
}