﻿using System.IO;
using System.Threading;

namespace Social.Lib.Photo
{
    public class MultiUpload
    {
        Thread _mainThread;
        private readonly string _despath;
        private readonly byte[] _data;
        private readonly int _width;
        private readonly int _height;
        private readonly bool _crop;
        private readonly long _quality;

        public MultiUpload(byte[] data, string despath, int width, int height, long quality, bool crop)
        {
            _data = data;
            _despath = despath;
            _width = width;
            _height = height;
            _quality = quality;
            _crop = crop;
        }

        public void Start()
        {
            _mainThread = new Thread(Upload);
            _mainThread.Start();
        }

        public void Join()
        {
            _mainThread.Join();
        }

        private void Upload()
        {
            ResizeImage.Process(_data, _despath, _width, _height, _quality, _crop);
        }
    }
}