﻿using System;
using System.IO;
using System.Security.Cryptography;
using System.Text;
using System.Text.RegularExpressions;

namespace Social.Lib.Photo
{
    public class Utility
    {
        public static bool IsInt(string Value)
        {
            try
            {
                Convert.ToInt32(Value);
                return true;
            }
            catch
            {
                return false;
            }
        }  
    
        public static string StripWordFomat(string text)
        {
            Regex rScript = new Regex(@"<!--(.|\n)*?-->", RegexOptions.IgnoreCase | RegexOptions.Singleline);
            if (rScript.IsMatch(text))
                return rScript.Replace(text, String.Empty);
            return text;
        }

        public static string EncryptMd5(string YourString)
        {
            byte[] MyByte = new byte[16];
            MyByte = MD5.Create().ComputeHash(Encoding.Default.GetBytes(YourString));
            string MyEncryptString = string.Empty;
            for (int i = 0; i < 16; i++)
            {
                MyEncryptString += MyByte[i].ToString("x2");
            }
            return MyEncryptString;
        }

        public static bool EmailValidate(string email)
        {
            Regex emailReg = new Regex(@"([a-zA-Z_0-9.-]+\@[a-zA-Z_0-9.-]+\.\w+)", RegexOptions.IgnoreCase | RegexOptions.Compiled);
            return emailReg.IsMatch(email);
        }


        public static bool UserValidate(string username)
        {
            Regex uNameReg = new Regex("[^a-zA-Z0-9_]");
            return uNameReg.IsMatch(username);
        }

        public static void DeleteFile(string fileName)
        {
            try { if (File.Exists(fileName)) { File.Delete(fileName); } }
            catch { }
        } 
         
        public static string StrInitFlashPlayer(string flashUrl, int width, int height)
        {
            var sb = new StringBuilder();
            sb.AppendFormat("<object height='{0}' width='{1}' align='middle' codebase='http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=8,0,0,0' classid='clsid:d27cdb6e-ae6d-11cf-96b8-444553540000'>", height, width);
            sb.Append("<param value='' name='FlashVars'>");
            sb.AppendFormat("<param value='{0}' name='movie'>", flashUrl);
            sb.Append("<param value='high' name='quality'>");
            sb.Append("<param value='always' name='allowScriptAccess'>");
            sb.Append("<param value='transparent' name='wmode'>");
            sb.AppendFormat("<embed height='{1}' width='{2}' align='middle' flashvars='' pluginspage='http://www.macromedia.com/go/getflashplayer' wmode='transparent' allowscriptaccess='always' type='application/x-shockwave-flash' quality='high' src='{0}'>", flashUrl, height, width);
            sb.Append("</object>");
            return sb.ToString();
        }


        /// <summary>
        /// Function to get byte array from a file
        /// </summary>
        /// <param name="_FileName">File name to get byte array</param>
        /// <returns>Byte Array</returns>
        public static byte[] FileToByteArray(string _FileName)
        {
            byte[] _Buffer = null;

            try
            {
                // Open file for reading
                var _FileStream = new FileStream(_FileName, FileMode.Open, FileAccess.Read);

                // attach filestream to binary reader
                var _BinaryReader = new BinaryReader(_FileStream);

                // get total byte length of the file
                var _TotalBytes = new FileInfo(_FileName).Length;

                // read entire file into buffer
                _Buffer = _BinaryReader.ReadBytes((Int32)_TotalBytes);

                // close file reader
                _FileStream.Close();
                _FileStream.Dispose();
                _BinaryReader.Close();
            }
            catch (Exception _Exception)
            {
                // Error
                Console.WriteLine("Exception caught in process: {0}", _Exception);
            }

            return _Buffer;
        }
    }
}
