﻿using System;
using Social.Entity.Tik;
using System.Collections.Generic;
using Webdiyer.WebControls.Mvc;

namespace Social.Service.Interface.Tik
{
    public interface IUserProfileService:IService<UserProfile>
    {
        bool CheckMail(string email);
        UserProfile GetUserByUsername(string username);
        List<UserProfile> GetListUserByCharacter(string character);

        int CountListUserByCharacter(string character);

        UserProfile GetUserByCharacterAndIndex(string character, int index);
        void RegisterUser(UserProfile u);
        List<UserProfileAndCountUserFriend> GetUserProfileCountFriend();
        UserProfile GetByEmail(string email);

        //List<UserProfileRemoveVN> GetUserByKeyWord();

        UserProfile GetByID(Guid guidid);

        UserProfile CurrentUser();
        PagedList<UserProfile> GetByIDPage(Guid guid, int pageIndex = 0, int pageSize = 10);
        List<UserProfile> GetAllUserID(List<Guid> userID);


    }
}
