﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Social.Entity.Tik;
using Social.Entity.TikActivity;
using Social.Lib.Activity;

namespace Social.Service.Interface.TikActivity
{
    public interface IUserActivityService: IService<UserActivity>
    {
        UserActivity GetByID(Guid activityid);
        UserActivity GetByTarget(Constants.Activity.TargetType type, Guid targetid);

        List<UserActivity> GetActivity(Guid ownerid, DateTime BeginDate);

        List<UserActivity> GetWallActivity(Guid userid);

        List<UserActivity> GetWallActivity(Guid userid, DateTime beginTime, int top = 0);

        List<UserActivity> GetFeedActivity(Guid userid, List<Guid> listFriend, DateTime beginTime, int top = 0);

        List<UserActivity> GetSpecialFeedActivity(Guid userid, List<Guid> listFriend, DateTime beginTime, int top = 0);

        bool Comment(UserProfile currentUser, Constants.Comment.ObjectType type, Guid objectid, string comment, DateTime created, Guid commentid = new Guid());
        bool DeleteComment(Guid commentid);

        bool Like(UserProfile currentUser, Constants.Like.ObjectType type, Guid objectid, DateTime created);
        bool DisLike(UserProfile currentUser, Constants.Like.ObjectType type, Guid objectid);

        bool DeleteFeed(Guid feedid);

        bool DeleteObject(Guid objectid);

        bool MakeFriend(Guid ownerid, Guid friendid, DateTime dateTime);

        //bool TagFriend(Guid ownerid, Guid friendID, Constants.Activity.ObjectType type, Guid objectid, DateTime created);

        bool TagFriend(Guid ownerid, List<Guid> friendids, Constants.Activity.ObjectType type, Guid objectid, DateTime created, bool removeIfNotExist = false);
        bool DeleteTagFriend(Guid ownerid, List<Guid> friendids, Constants.Activity.ObjectType type, Guid objectid);
        bool DeleteTagFriend(List<Guid> friendids, Constants.Activity.ObjectType type, Guid objectid);

        bool Post(Guid ownerid, Guid toUserID, string message, DateTime created, Guid feedid = new Guid(), Attachment.Link link = null, Attachment.Video video = null);
        
        bool PostNote(Guid ownerid, Guid objectid, string message, string title, string description, string url, string image);

        bool PostMusic(Guid ownerid, Guid objectid, string message, string title, string description, string url, string image, string embedurl, int width = 440, int height = 0);

        bool PostImage(Guid ownerid, Guid objectid, string message, string albumtitle, string imagedescription, string urlalbum, string[] image, string[] urlimage, bool isAlbum = false, int totalImage = 1, Guid feedid = new Guid());

        bool PostImage(Guid ownerid, Guid touserid, Guid objectid, string message, string albumtitle, string imagedescription, string urlalbum, string[] image, string[] urlimage, bool isAlbum = false, int totalImage = 1, Guid feedid = new Guid());
        
        bool UpdateAvatar(Guid userid, Guid avatarid, DateTime created);
    }
}
