using Social.Entity.TikFriend;
using Social.DAL.Interface;
using System.Collections.Generic;
using System;
using Webdiyer.WebControls.Mvc;

namespace Social.Service.Interface.TikFriend
{
    public interface IFriendRequestService : IService<FriendRequest>
    {
        List<FriendRequest> GetTop3();
        List<FriendRequestDTO> Get(Guid id);

        PagedList<FriendRequestDTO> GetPage(Guid id, int pageIndex = 0, int pageSize = 10);
        List<FriendRequest> GetByFromUserIDAndToUserID(Guid fromuserid, Guid touserid);
        int GetCountByFromUserIDAndToUserID(Guid fromuserid, Guid touserid);
        List<FriendRequestDTO> GetByFromUserID(Guid id);
        //page
        Webdiyer.WebControls.Mvc.PagedList<FriendRequestDTO> GetByFromUserIDPage(Guid id, int pageIndex = 0, int pageSize = 10);

        List<FriendRequest> GetByFromToUserIDAndTop(Guid touserid, int top);
        int GetCountByToUserID(Guid touserID);
        List<FriendRequestAndUserProfile> GetBy_FromToUserIDAndTop(Guid touserid, int top);
        FriendRequest GetByID(Guid id);
        bool CheckRequestFriend(Guid friendID, Guid ownerID);
    }
}
