﻿using System;
using System.Collections.Generic;
using Social.Entity.TikMusic;

namespace Social.Service.Interface.TikMusic
{
    public interface IAlbumService : IService<Album>
    {
        /// <summary>
        /// Lấy toàn bộ album của user bao gồm cả các album mặc định
        /// </summary>
        /// <param name="userId"></param>
        /// <returns></returns>
        List<Album> GetListAlbumByUserId(Guid userId);

        /// <summary>
        /// Lấy theo trang toàn bộ album của user bao gồm cả các album mặc định
        /// </summary>
        /// <param name="userId"></param>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <returns></returns>
        List<Album> GetPageListAlbumByUserId(Guid userId, int pageIndex, int pageSize, out int totalRow, bool isMyMusic = false);
        /// <summary>
        /// Lấy abum mặc định như
        /// </summary>
        /// <param name="userId"></param>
        /// <returns></returns>
        List<Album> GetListAlbumDefaultByUserId(Guid userId);
        List<Album> GetByAlbumIdUserId(Guid albumId, Guid userId);
    }
}
