﻿using System;
using System.Collections.Generic;
using Social.Entity.TikPhoto;

namespace Social.Service.Interface.TikPhoto
{
    public interface IAlbumService : IService<Album>
    {
        /// <summary>
        /// Lấy toàn bộ album của user bao gồm cả các album mặc định (Wall,Profile,Mobile)
        /// </summary>
        /// <param name="userId"></param>
        /// <returns></returns>
        List<Album> GetListAlbumByUserId(Guid userId);
        /// <summary>
        /// Lấy theo trang toàn bộ album của user bao gồm cả các album mặc định (Wall,Profile,Mobile)
        /// </summary>
        /// <param name="userId"></param>
        /// <param name="pageIndex"></param>
        /// <param name="pageSize"></param>
        /// <returns></returns>
        List<Album> GetPageListAlbumByUserId(Guid userId, int pageIndex, int pageSize, out int totalRow, bool isMyPhoto = false);
        /// <summary>
        /// Lấy abum mặc định như Wall,Profile,Mobile
        /// </summary>
        /// <param name="userId"></param>
        /// <returns></returns>
        List<Album> GetListAlbumDefaultByUserId(Guid userId);
        List<Album> GetByAlbumIdUserId(Guid albumId, Guid userId);
        List<Album> GetByUserIdTypeAlbum(Guid userId, int type);
    }
}
