using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;

namespace Social.Service.Tik
{
    public class CompanyService : ServiceBase<Company>, ICompanyService
    { 
        IRepository _re;
        public CompanyService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public IList<Company> Search(string input, int top = 0)
        {
            var x = from c in _re.All<Company>()
                    where c.Name.StartsWith(input) || c.Name.Contains(input)
                    select c;
            if (top > 0) return x.Take(top).ToList();
            return x.ToList();
        }

        
    }
}
