using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;

namespace Social.Service.Tik
{
    public class ProvinceService : ServiceBase<Province>, IProvinceService
    { 
        IRepository _re;
        public ProvinceService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public IList<Province> Search(string input, int top = 0)
        {
            var x = from p in _re.All<Province>()
                    where p.Name.StartsWith(input) || p.Name.Contains(input)
                    select p;
            if (top > 0) return x.Take(top).ToList();
            return x.ToList();
        }
    }
}
