﻿using System;
using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;

namespace Social.Service.Tik
{
    public class SchoolDTO
    {
        public Guid ID { get; set; }
        public string Name { get; set; }
        public Guid ProvinceID { get; set; }
    }
    public class SchoolService : ServiceBase<School>, ISchoolService
    {
        IRepository _re;
        public SchoolService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }


        public IList<School> Search(string input, int top = 0)
        {            
            var schools = from school in _re.All<School>()
                          where school.Name.StartsWith(input) || school.Name.Contains(input)
                          select school;
            if (top > 0) return schools.Take(top).ToList();
            return schools.ToList();

        }

        public IList<School> GetSchools(IEnumerable<Guid> schoolIds)
        {
            if (!schoolIds.Any())
            {
                return new List<School>();
            }
            var schools = from school in _re.All<School>()
                          where schoolIds.Contains(school.ID)
                          select school;

            return schools.ToList();
        }

    }
}
