﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;

namespace Social.Service.Tik
{
    public class UniversityService : ServiceBase<University>, IUniversityService
    {
        IRepository _re;
        public UniversityService(ITikRepository repository): base(repository)
        {
            _re = repository;
        }


        public IList<University> Search(string input, int top = 0)
        {
            var x = from u in _re.All<University>()
                    where u.Name.StartsWith(input) || u.Name.Contains(input) 
                    select u;
            if(top > 0) return x.Take(top).ToList();
            return x.ToList();
        }
    }
}
