using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;
using Social.Lib;

namespace Social.Service.Tik
{
    public class UserCompanyAndUserSearchService : ServiceBase<UserCompanyAndUserSearch>, IUserCompanyAndUserSearchService
    { 
        IRepository _re;
        public UserCompanyAndUserSearchService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }



        public List<Guid> GetKeyWordUserID(string fullname, string company,Guid ownerID)
        {
            try
            {

                    var _listresult = (from c in _re.All<UserCompanyAndUserSearch>()
                                       where c.FullName.Contains(fullname) && c.Company.Contains(company) && c.UserID != ownerID
                                       select c.UserID).Distinct().ToList();
                    return _listresult;

               

            }
            catch
            {
                return new List<Guid>();
            }
        }

    }
}
