using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;

namespace Social.Service.Tik
{
    public class UserCompanyService : ServiceBase<UserCompany>, IUserCompanyService
    { 
        IRepository _re;
        public UserCompanyService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public string GetByUserId(Guid userid)
        {
            try
            {
                return _re.All<UserCompany>().Where(c => c.UserID == userid).Select(c => c.Company).Single();
            }
            catch {
                return "";
            }
        }
        public List<Guid> GetByCompany(List<string> company)
        {
            string uc = string.Concat(company);
            if (uc != "")
            {
                return _re.All<UserCompany>().Where(c => c.Company.Contains(uc)).Select(c => c.UserID).ToList();
            }
            else {
                return new List<Guid>();
            }
        }

        public UserCompany GetUserCompanyByUserID(Guid userid)
        {
            try
            {
                var _UserCompany = from c in
                                      _re.All<UserCompany>()
                                  where c.UserID == userid
                                  select c;

                return _UserCompany.Single();
            }
            catch
            {
                return new UserCompany();
            }
        }
    }
}
