using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;
using Social.Service.TikFriend;

namespace Social.Service.Tik
{
    public class UserConfigService : ServiceBase<UserConfig>, IUserConfigService
    { 
        IRepository _re;
        public UserConfigService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public UserConfig GetByUserIdAndConfigKey(Guid userid, string configkey)
        {
            try
            {
                var _UserConfig = from c in
                                       _re.All<UserConfig>()
                                   where c.UserID == userid
                                            && c.ConfigKey == configkey
                                   select c;

                return _UserConfig.Single();
            }
            catch
            {
                return null;
            }
        }

        public IList<UserConfig> GetByUserID(Guid userid)
        {
            try
            {
                var _UserConfig = from c in
                                      _re.All<UserConfig>()
                                  where c.UserID == userid
                                  select c;

                return _UserConfig.ToList();
            }
            catch
            {
                return null;
            }
        }
    }
}
