using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;

namespace Social.Service.Tik
{
    public class UserFamilyService : ServiceBase<UserFamily>, IUserFamilyService
    { 
        IRepository _re;
        public UserFamilyService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public IList<UserFamily> GetByUserID(Guid userid)
        {
            if (Guid.Empty.Equals(userid)) return null;

            var userfamily = from u in _re.All<UserFamily>()
                             where u.UserID == userid
                             select u;

            return userfamily.ToList();
        }

    }
}
