using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;
using Webdiyer.WebControls.Mvc;

namespace Social.Service.Tik
{
    public class UserProfileAndUserSearchService : ServiceBase<UserProfileAndUserSearch>, IUserProfileAndUserSearchService
    { 
        IRepository _re;
        public UserProfileAndUserSearchService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<UserProfileAndUserSearch> GetByHomeAddress(string keyword,string fullname, Guid ownerID)
        {
            try
            {
                var _listusersearch = (from c in _re.All<UserProfileAndUserSearch>()
                                       where c.HomeAddress.Contains(keyword) && c.FullText.Contains(fullname) && c.UserID != ownerID
                                       select c).ToList();
                return _listusersearch;
            }
            catch {
                return new List<UserProfileAndUserSearch>();
            }
        
        }
        public List<UserProfileAndUserSearch> GetByCurrentAddress(string keyword,string fullname, Guid ownerID)
        {
            try
            {
                var _listusersearch = (from c in _re.All<UserProfileAndUserSearch>()
                                       where c.CurrentAddress.Contains(keyword) && c.FullText.Contains(fullname) && c.UserID != ownerID
                                       select c).ToList();
                return _listusersearch;
            }
            catch
            {
                return new List<UserProfileAndUserSearch>();
            }

        }

    }
}
