using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;
using Social.Lib;

namespace Social.Service.Tik
{
    public class UserSchoolAndUserSearchService : ServiceBase<UserSchoolAndUserSearch>, IUserSchoolAndUserSearchService
    { 
        IRepository _re;
        public UserSchoolAndUserSearchService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<UserSchoolAndUserSearch> getall()
        {
            try
            {
                var _list = _re.All<UserSchoolAndUserSearch>().Distinct().ToList();
                return _list;
            }
            catch
            {
                return new List<UserSchoolAndUserSearch>();

            }
        }

        public List<Guid> GetKeyWordUserID(string fullname, string school, Int16 _class,Guid ownerID)
        {
            try
            {
                if (_class != 0)
                {
                    var _listresult = (from c in _re.All<UserSchoolAndUserSearch>()
                                       where c.FullName.Contains(fullname) && c.School.Contains(school) && c.ClassYear == _class && c.UserID != ownerID 
                                       select c.UserID).Distinct().ToList();
                    return _listresult;

                }
                else
                {
                    var _listresult = (from c in _re.All<UserSchoolAndUserSearch>()
                                       where c.FullName.Contains(fullname) && c.School.Contains(school) && c.UserID != ownerID
                                       select c.UserID).Distinct().ToList();
                    return _listresult;
                }

            }
            catch
            {
                return new List<Guid>();
            }
        }

    }
}
