﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Social.DAL.Interface;
using Social.Entity;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;

namespace Social.Service.Tik
{
    public class UserSchoolService : ServiceBase<UserSchool>, IUserSchoolService
    {
        IRepository _re;
        public UserSchoolService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }
        public IList<UserSchool> Search(string a)
        {
            var qrySearch = from school in _re.All<UserSchool>()
                            select new { School = school.School, ClassYear = school.ClassYear };
            //Pagging
            qrySearch=qrySearch.Take(10);

            var enumSearch = qrySearch.AsEnumerable().Select(it => new UserSchool
            {
                School = it.School,
                ClassYear = it.ClassYear
            });

            return enumSearch.ToList();
        }

        public string GetByUserID(Guid userid)
        {
            try
            {
                var userschool = _re.All<UserSchool>().Where(c => c.UserID == userid).Select(c => c.School);
                return userschool.Single();
            }
            catch {
                return "";
            }
        }

        public UserSchool GetUserSchooolByUserID(Guid userid)
        {
            try
            {
                var _UserSchool = from c in
                                      _re.All<UserSchool>()
                                  where c.UserID == userid
                                  select c;

                return _UserSchool.Single();
            }
            catch
            {
                return new UserSchool();
            }
        }
        public UserSchool GetByUserIDTop1(Guid userID)
        {
            try
            {
                var _usershool = _re.All<UserSchool>().Where(c => c.UserID == userID).Take(1).Single();
                return _usershool;
            }
            catch
            {
                return new UserSchool();
            }
        }

        public List<Guid> GetBySchool(List<string> school)
        {
            
            string sc = string.Concat(school);
            if (sc != "")
            {
                var userschool = _re.All<UserSchool>().Where(c => c.School.Contains(sc)).Select(c => c.UserID).ToList();
                return userschool;
            }
            else
            {
                return new List<Guid>();
            }
            
        }
    }
}
