using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;
using Webdiyer.WebControls.Mvc;

namespace Social.Service.Tik
{
    public class UserSearchService : ServiceBase<UserSearch>, IUserSearchService
    { 
        IRepository _re;
        public UserSearchService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<UserSearch> GetByFullText(string keyword,int top)
        {
            try
            {
                var listuser = from c in _re.All<UserSearch>()
                               where c.FullText.Contains(keyword)
                               select c;
                if (top != 0)
                {
                    
                    return listuser.Take(top).Distinct().ToList();
                }
                else {
                    return listuser.Distinct().ToList();
                }
            }
            catch {
                return new List<UserSearch>();
            }
        }

        public int GetCountResultSearch(string keyword)
        {
            try {
                var _listsearch = (from c in _re.All<UserSearch>()
                                   where c.FullText.Contains(keyword)
                                   select c).Distinct().Count();
                return _listsearch;
                             
            }
            catch {
                return new int();
            }
        }


        public PagedList<UserSearch> GetByFullTextSearch(string keyword, int pageIndex = 0, int pageSize = 10)
        {
                var listuser = from c in _re.All<UserSearch>()
                               where c.FullText.Contains(keyword)
                               select c;
                return listuser.Distinct().OrderByDescending(mv => mv.Username).ToPagedList(pageIndex, pageSize);

        }


        public List<UserSearch> GetByFullText(string keyword, int top,Guid[] listExisted)
        {
            try
            {
                var listuser = from c in _re.All<UserSearch>()
                               where !listExisted.Contains(c.UserID) && c.FullText.Contains(keyword)
                               select c;
                if (top != 0)
                {

                    return listuser.Take(top).Distinct().ToList();
                }
                else
                {
                    return listuser.Distinct().ToList();
                }
            }
            catch
            {
                return new List<UserSearch>();
            }
        }
    }
}
