using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;
using Social.Lib;

namespace Social.Service.Tik
{
    public class UserUniversityAndUserSearchService : ServiceBase<UserUniversityAndUserSearch>, IUserUniversityAndUserSearchService
    { 
        IRepository _re;
        public UserUniversityAndUserSearchService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<UserUniversityAndUserSearch> GetAll()
        {
            try {
                var _list = _re.All<UserUniversityAndUserSearch>().Distinct().ToList();
                return _list;
            }
            catch {
                return new List<UserUniversityAndUserSearch>();
                 
            }
        }
        public List<Guid> GetKeyWordUserID(string fullname, string school, Int16 _class,Guid ownerID)
        {
            try {
                if (_class != 0)
                {
                    var _listresult = (from c in _re.All<UserUniversityAndUserSearch>()
                                       where c.FullName.Contains(fullname) && c.University.Contains(school) && c.ClassYear == _class && c.UserID != ownerID
                                       select c.UserID).Distinct().ToList();
                    return _listresult.ToList();
                }
                else {
                    var _listresult = (from c in _re.All<UserUniversityAndUserSearch>()
                                       where c.FullName.Contains(fullname) && c.University.Contains(school) && c.UserID != ownerID
                                       select c.UserID).Distinct().ToList();
                    return _listresult;
                }
                             
            }
            catch {
                return new List<Guid>();
            }
        }
       


    }
}
