using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System;

namespace Social.Service.Tik
{
    public class UserUniversityService : ServiceBase<UserUniversity>, IUserUniversityService
    { 
        IRepository _re;
        public UserUniversityService(ITikRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<UserUniversity> GetByUniversity(string university)
        {
            try
            {
                var _university = from c in _re.All<UserUniversity>()
                                  where c.University.Contains(university)
                                  select c;
                return _university.ToList();
            }
            catch {
                return new List<UserUniversity>();
            }

        }

        public UserUniversity GetByUserID(Guid userId)
        {
            try
            {
                var _university = from c in
                                      _re.All<UserUniversity>()
                                  where c.UserID == userId
                                  
                                  select c;

                return _university.Single();
            }
            catch {
                return new UserUniversity();
            }
        }
        public UserUniversity GetByTop1(Guid userID)
        {
            try {
                var _useruniversity = _re.All<UserUniversity>().Where(c => c.UserID == userID).Take(1).Single();
                return _useruniversity;
            }
            catch {
                return new UserUniversity();
            }
        }

        public List<Guid> GetListByUniversity(List<string> university)
        {
            string sc = string.Concat(university);
            if (sc != "")
            {
                var usersuniversity = _re.All<UserUniversity>().Where(c => c.University.Contains(sc)).Select(c => c.UserID).ToList();
                return usersuniversity;
            }
            else
            {
                return new List<Guid>();
            }

        }
        public string GetStringByUserID(Guid userId)
        {
            try
            {
                var userunniversity = _re.All<UserUniversity>().Where(c => c.UserID == userId).Select(c => c.University);
                return userunniversity.Single();
            }
            catch { return ""; }
        }
        public List<UserUniversity> ListGetByGuid(Guid userid)
        {
            try
            {
                var useruniversity = from c in _re.All<UserUniversity>().Where(c => c.UserID == userid) select c;
                return useruniversity.ToList();
            }
            catch { return new List<UserUniversity>(); }
        }
    }
}
