using System;
using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.TikActivity;
using Social.Service.Interface.TikActivity;

namespace Social.Service.TikActivity
{
    public class UserCommentService : ServiceBase<UserComment>, IUserCommentService
    {
        IRepository _re;
        public UserCommentService(ITikActivityRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<UserComment> GetComments(Guid objectid)
        {
            if (Guid.Empty.Equals(objectid)) return null;

            var comments = from c in _re.All<UserComment>()
                           where c.ObjectID == objectid
                           select c;
            if (comments.Any())
            {
                return comments.ToList();
            }
            return null;
        }

        public List<Guid> GetCommentIDs(Guid objectid)
        {
             if (Guid.Empty.Equals(objectid)) return null;

            var comments = from c in _re.All<UserComment>()
                           where c.ObjectID == objectid
                           select new {c.ID};
            if (comments.Any())
            {
                List<Guid> guids = new List<Guid>();
                foreach (var comment in comments)
                {
                    guids.Add(comment.ID);
                }
                return guids;
            }
            return null;
        }

        public UserComment GetComment(Guid commentid)
        {
            if (Guid.Empty.Equals(commentid)) return null;
            var comment = from c in _re.All<UserComment>()
                          where c.ID == commentid
                          select c;
            if (comment.Any())
            {
                return comment.FirstOrDefault();
            }
            return null;
        }

        //public bool AddComment(Guid objectID, UserComment comment)
        //{
        //    throw new NotImplementedException();
        //}

       


        //public List<UserComment> GetComments(ObjectType type, Guid objectid)
        //{
        //    switch (type)
        //    {
        //        ObjectType.Status
        //    }
        //}
    }
}
