﻿using System;
using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.TikActivity;
using Social.Service.Interface.TikActivity;

namespace Social.Service.TikActivity
{
    public class UserFeedService : ServiceBase<UserFeed>, IUserFeedService
    {
        IRepository _re;
        public UserFeedService(ITikActivityRepository repository)
            : base(repository)
        {
            _re = repository;
        }
        
        //public List<UserFeed> GetFeeds()
        //{
        //    var feeds = from f in _re.All<UserFeed>()
        //                select new UserFeed()
        //                           {
                                       
        //                           }
        //}

        public UserFeed GetFeed(Guid feedid)
        {
            if (Guid.Empty.Equals(feedid)) return null;
            var feed = from f in _re.All<UserFeed>()
                        where f.ID == feedid
                        select f;
            if(feed.Any()) return feed.FirstOrDefault();
            return null;
        }

        public List<UserFeed> GetFeedOnWall(Guid userid)
        {
            var feeds = from f in _re.All<UserFeed>()
                        where f.ObjectID == userid
                        select f;
            return feeds.ToList();
        }

    }
}
