using System;
using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.TikActivity;
using Social.Service.Interface.TikActivity;

namespace Social.Service.TikActivity
{
    public class UserLikeService : ServiceBase<UserLike>, IUserLikeService
    { 
        IRepository _re;
        public UserLikeService(ITikActivityRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public bool Like(Guid feedId, Guid commentId = new Guid())
        {
            //var feeds = from f in _re.All<UserFeed>()
            //           where f.ID == feedId
            //           select f;
            //if (feeds.Any())
            //{
            //    UserLike like = new UserLike();
            //    like.ID = Guid.NewGuid();
            //    like.ObjectID = feedId;
            //    like.LikeDate = DateTime.Now;
            //    this.Add(like);
            //    if (Guid.Empty.Equals(commentId))
            //    {
            //        var feed = feeds.FirstOrDefault();
            //        feed.LikeCount++;
            //    }
            //    else
            //    {
            //        var comments = from c in _re.All<UserComment>()
            //                       where c.ID == commentId
            //                       select c;
            //        if (comments.Any())
            //        {
            //            like.ObjectID = commentId;
            //            var comment = comments.FirstOrDefault();
            //            comment.LikeCount++;
            //        }
            //    }
            //    _re.CommitChanges();
            //    return true;
            //}
            return false;
        }

        public bool UnLike(Guid feedId, Guid commentId = new Guid())
        {
            //if (Guid.Empty.Equals(commentId))
            //{
            //    var like = from l in _re.All<UserLike>()
            //               where l.ObjectID == feedId
            //               select l;
            //    if(like.Any())
            //    {
            //        this.Delete(like.FirstOrDefault());
            //        var feeds = from f in _re.All<UserFeed>()
            //                   where f.ID == feedId
            //                   select f;
            //        if(feeds.Any())
            //        {
            //            var feed = feeds.FirstOrDefault();
            //            feed.LikeCount--;
            //        }
            //        _re.CommitChanges();
            //        return true;
            //    }
            //}else
            //{
            //    var like = from l in _re.All<UserLike>()
            //               where l.FeedID == feedId && l.ObjectID == commentId
            //               select l;
            //    if (like.Any())
            //    {
            //        this.Delete(like.FirstOrDefault());
            //        var comments = from c in _re.All<UserComment>()
            //                       where c.ID == commentId
            //                       select c;
            //        if (comments.Any())
            //        {
            //            var comment = comments.FirstOrDefault();
            //            comment.LikeCount--;
            //        }
            //        _re.CommitChanges();
            //        return true;
            //    }
            //}
            return false;
        }

        public List<UserLike> GetLikes(Guid objectid)
        {
            if (Guid.Empty.Equals(objectid)) return null;

            var likes = from l in _re.All<UserLike>()
                        where l.ObjectID == objectid
                        select l;
            if (likes.Any())
            {
                return likes.ToList();
            }
            return null;
        }

        public UserLike GetLike(Guid objectid, Guid userid)
        {
            if (Guid.Empty.Equals(objectid) || Guid.Empty.Equals(userid)) return null;
            var like = from l in _re.All<UserLike>()
                       where l.ObjectID == objectid && l.FromID == userid
                       select l;
            if (like.Any()) return like.FirstOrDefault();
            return null;
        }

        public UserLike GetLike(Guid likeid)
        {
            if (Guid.Empty.Equals(likeid)) return null;
            var like = from l in _re.All<UserLike>()
                       where l.ID == likeid
                       select l;
            if (like.Any()) return like.FirstOrDefault();
            return null;
        }

        public bool IsExisted(Guid objectid, Guid userid)
        {
            if (Guid.Empty.Equals(objectid) || Guid.Empty.Equals(userid)) return true;

            var likes = from l in _re.All<UserLike>()
                        where l.ObjectID == objectid && l.FromID == userid
                        select l;

            if (likes.Any()) return true;
            return false;
        }


    }
}
