using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.TikFriend;
using Social.Service.Interface.TikFriend;
using System;

namespace Social.Service.TikFriend
{
    public class FriendInListService : ServiceBase<FriendInList>, IFriendInListService
    { 
        IRepository _re;
        public FriendInListService(ITikFriendRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<FriendInList> GetByFriendListAndFriendId(Guid friendlistid, Guid friendid)
        {
            try
            {
                var friendinlist = from c in _re.All<FriendInList>() where c.FriendListID == friendlistid && c.FriendID == friendid select c;
                return friendinlist.ToList();
            }
            catch {

                return new List<FriendInList>();
            }
        }

        public int GetCheckFriendInList(Guid friendlistid, Guid friendid)
        {
            try
            {
                var friendinlist = from c in _re.All<FriendInList>() where c.FriendListID == friendlistid && c.FriendID == friendid select c;
                return friendinlist.Count();
            }
            catch {
                return new int();
            }

                          
        }

        public int GetByFriendListID(Guid friendlistID,bool status)
        {
            try
            {
                var friendinlist = (from c in _re.All<FriendInList>()
                                    where c.FriendListID == friendlistID && c.Status==status
                                    select c).Count();
                return friendinlist;
            }
            catch
            {
                return new int();
            }
        }
        public List<Guid> GetFriendID_ByListID(Guid listID)
        {
            try {
                var listinfriend = from c in _re.All<FriendInList>()
                                   where c.FriendListID == listID
                                   select c.FriendID;
                return listinfriend.ToList();
            }
            catch {
                return new List<Guid>();
            }
        }

        public List<FriendInList> GetFriendList_ByListIDAndStatus(Guid listID, bool status)
        {
            try
            {
                var listinfriend = (from c in _re.All<FriendInList>()
                                    where c.FriendListID == listID && c.Status == status
                                    select c).ToList();
                return listinfriend;
            }
            catch
            {
                return new List<FriendInList>();
            }
        }

        
    }
}
