using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.TikFriend;
using Social.Service.Interface.TikFriend;
using System;
using AutoMapper;

namespace Social.Service.TikFriend
{
    public class FriendListService : ServiceBase<FriendList>, IFriendListService
    { 
        IRepository _re;
        public FriendListService(ITikFriendRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<FriendListJoinFriendInList> GetJoin(Guid ow)
        {
            var qry = from c in _re.All<FriendList>()
                      where c.OwnerID == ow
                      select c;
            IEnumerable<FriendListJoinFriendInList> list = qry.ToList().Select(fr => Mapper.Map<FriendList, FriendListJoinFriendInList>(fr));

            return list.ToList();
        
        }

        public List<Guid> GetByOwnerID(Guid owner)
        {
            if (Guid.Empty.Equals(owner)) return null;
            var friendinlist = from c in _re.All<UserFriend>().Where(c => c.OwnerID == owner) select c.FriendID;
            if(friendinlist.Any())
            return friendinlist.ToList();
            return null;
        }

        public List<Guid> GetByListID(Guid owner)
        {
            if (Guid.Empty.Equals(owner)) return null;
            var friendinlist = from c in _re.All<FriendList>().Where(c => c.OwnerID == owner) select c.ID;
            if (friendinlist.Any())
                return friendinlist.ToList();
            return null;
        }

        public List<FriendList> GetStringFriendList(Guid owner)
        {
            try
            {
                var friendinlist = from c in _re.All<FriendList>() where c.OwnerID == owner select c;
                return friendinlist.ToList();
            }
            catch {
                return null;
            }
            
        }
        public List<FriendListCountFriend> GetCountFriendGround_ByOwnerID(Guid id)
        {
            var qry = from c in _re.All<FriendList>()
                      where c.OwnerID == id
                      select c;
            IEnumerable<FriendListCountFriend> list = qry.ToList().Select(fr => Mapper.Map<FriendList, FriendListCountFriend>(fr));

            return list.ToList();
        }

        public int CheckFriendList(string listname,Guid ownerID)
        {
            if(listname==string.Empty) return new int();
            try {
                var friendlist = _re.All<FriendList>().Where(c => c.FriendListName == listname && c.OwnerID == ownerID).Count();
                return friendlist;
            
            }
            catch { 
            return new int();
            }
        }


        

        
    }
}
