using System;
using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.TikFriend;
using Social.Service.Interface.TikFriend;
using Webdiyer.WebControls.Mvc;

namespace Social.Service.TikFriend
{
    public class UserFriendService : ServiceBase<UserFriend>, IUserFriendService
    { 
        IRepository _re;
        public UserFriendService(ITikFriendRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<UserFriend> GetKeyWord(string keyword, Guid id)
        {
            throw new NotImplementedException();
        }
        public List<Guid> GetByOwnerID(Guid id)
        {
            var lsfriend = from c in _re.All<UserFriend>()
                           where c.OwnerID == id
                           select c.FriendID;
            return lsfriend.Distinct().ToList();
        }

        public List<UserFriend> GetByImpressionOrder(Guid userid)
        {
            var userfriend = from c in _re.All<UserFriend>()
                             where c.OwnerID == userid
                             orderby c.Impression descending
                             select c;
            return userfriend.Distinct().ToList();
        }
        public List<Guid> GetIDByImpressionOrder(Guid userid)
        {
            if (Guid.Empty.Equals(userid)) return null;
            var userfriend = from c in _re.All<UserFriend>()
                             where c.OwnerID == userid
                             orderby c.Impression descending
                             select c.FriendID;
            if (!userfriend.Any()) return null;
            return userfriend.Distinct().ToList();
        }

        public List<UserFriend> GetByUserFriend(Guid ownnerId, Guid friendId)
        {
            try {
                var userfriend = from c in _re.All<UserFriend>()
                                 where c.OwnerID == ownnerId && c.FriendID == friendId
                                 select c;
                return userfriend.Distinct().ToList();
            }
            catch {
                return new List<UserFriend>();
            }
        }

        public int GetCountByUserFriend(Guid ownnerId, Guid friendId)
        {
            try
            {
                var userfriend = from c in _re.All<UserFriend>()
                                 where c.OwnerID == ownnerId && c.FriendID == friendId
                                 select c;
                return userfriend.Distinct().Count();
            }
            catch
            {
                return new int();
            }
        }

        public PagedList<UserFriend> GetListUserFriend_ByOwnerID(Guid ownerID, int pageIndex = 0, int pageSize = 10)
        {
                var _userfriend = from c in _re.All<UserFriend>()
                                  where c.OwnerID == ownerID
                                  select c;

                return _userfriend.Distinct().OrderByDescending(mv => mv.CreatedDate).ToPagedList(pageIndex, pageSize);

        }

        public UserFriend GetByID(Guid id)
        {
            try
            {
                var _user = _re.All<UserFriend>().Where(c => c.ID == id).Single();
                return _user;
            }
            catch {


                return new UserFriend();
            }
        }

        public bool CheckExsitFriend(Guid ownerID, Guid friendID)
        {
            try {
                var _userfriend = _re.All<UserFriend>().Where(c => c.OwnerID == ownerID && c.FriendID == friendID).Distinct().Count();
                if (_userfriend > 0)
                    return true;
                else
                    return false;
            }
            catch {
                return false;
            }
        }
    }
}
