using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.TikMessage;
using Social.Service.Interface.TikMessage;
using System;

namespace Social.Service.TikMessage
{
    public class MessageCommentService : ServiceBase<MessageComment>, IMessageCommentService
    { 
        IRepository _re;
        public MessageCommentService(ITikMessageRepository repository)
            : base(repository)
        {
            _re = repository;
        }
        public List<MessageCommentView> GetListByMessageID(Guid msgID,Guid userID,int pageIndex=0,int pageSize=20)
        {
            var list = from mc in _re.All<MessageCommentView>()
                       where mc.MessageID == msgID
                       select mc;
            return list.OrderBy(mc => mc.CreatedDate).Skip(pageSize * pageIndex).Take(pageSize).ToList();
        }

    }
}
