using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Social.DAL.Interface;
using Social.Entity.TikMusic;
using Social.Service.Interface.TikMusic;

namespace Social.Service.TikMusic
{
    public class AlbumService : ServiceBase<Album>, IAlbumService
    { 
        IRepository _re;
        public AlbumService(ITikMusicRepository repository)
            : base(repository)
        {
            _re = repository;
        }
        
        public List<Album> GetListAlbumByUserId(Guid userId)
        {
            var retval = from it in _re.All<Album>()
                         where it.UserID == userId orderby it.CreatedDate descending 
                           select it;
            return retval.ToList();
        }

        public List<Album> GetPageListAlbumByUserId(Guid userId, int pageIndex, int pageSize, out int totalRow, bool isMyMusic=false)
        {
            if(isMyMusic)
            {
                var lstAb = from it in _re.All<Album>()
                            where it.UserID == userId
                            orderby it.CreatedDate descending
                            select it;
                totalRow = lstAb.Count();

                var stastRow = (pageIndex - 1) * pageSize;
                var ret = lstAb.Skip(stastRow).Take(pageSize);
                return ret.ToList();
            }
            else
            {
                var lstAb = from it in _re.All<Album>()
                            where it.UserID == userId && it.SongCount>0
                            orderby it.CreatedDate descending
                            select it;
                totalRow = lstAb.Count();

                var stastRow = (pageIndex - 1) * pageSize;
                var ret = lstAb.Skip(stastRow).Take(pageSize);
                return ret.ToList();
            }
        }

        public List<Album> GetListAlbumDefaultByUserId(Guid userId)
        {
            var retval = from it in _re.All<Album>()
                         where it.UserID == userId 
                         orderby it.CreatedDate descending
                         select it;
            return retval.ToList();
        }

        public List<Album> GetByAlbumIdUserId(Guid albumId, Guid userId)
        {
            var list = from it in _re.All<Album>()
                       where it.ID == albumId && it.UserID == userId 
                       orderby it.CreatedDate descending 
                         select it;
            return list.ToList();
        }

        public string GenerateXmlAlbum(string albumId)
        {
            throw new NotImplementedException();
        }
    }
}
