using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using Social.DAL.Interface;
using Social.Entity.TikMusic;
using Social.Service.Interface.TikMusic;

namespace Social.Service.TikMusic
{
    public class SongService : ServiceBase<Song>, ISongService
    { 
        IRepository _re;
        public SongService(ITikMusicRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public List<Song> GetByAlbumId(Guid albumId)
        {
            var list = from it in _re.All<Song>()
                       where it.AlbumID == albumId
                       orderby it.CreatedDate descending
                       select it;
            return list.ToList();
        }

        public List<Song> GetPageListSongByUserId(Guid userId, int pageIndex, int pageSize, out int totalRow)
        {
            var lstAb = from it in _re.All<Song>()
                        where it.UserID == userId
                        orderby it.CreatedDate descending
                        select it;
            totalRow = lstAb.Count();
            var stastRow = (pageIndex - 1) * pageSize;
            var ret = lstAb.Skip(stastRow).Take(pageSize);
            return ret.ToList();
        }
    }
}
