using System;
using System.Collections.Generic;
using System.Linq;
using Social.DAL.Interface;
using Social.Entity.TikPhoto;
using Social.Service.Interface.TikPhoto;

namespace Social.Service.TikPhoto
{
    public class PhotoTagService : ServiceBase<PhotoTag>, IPhotoTagService
    { 
        IRepository _re;
        public PhotoTagService(ITikPhotoRepository repository)
            : base(repository)
        {
            _re = repository;
        }

        public void DeleteByUidAndPid(Guid uId, Guid pId)
        {
            var retval = from it in _re.All<PhotoTag>()
                         where it.PhotoID == pId && it.UserID==uId
                         select it;
            foreach (var photoTag in retval)
            {
                _re.Delete(photoTag);
            }
            _re.CommitChanges();
        }

        public List<Guid> DeleteByPid(Guid pId)
        {
            var retval = from it in _re.All<PhotoTag>()
                         where it.PhotoID == pId
                         select it;
            var lstRetVal = new List<Guid>();
            foreach (var photoTag in retval)
            {
                lstRetVal.Add(photoTag.UserID);
                _re.Delete(photoTag);
            }
            _re.CommitChanges();
            return lstRetVal;
        }

        public List<PhotoTag> GetListByPid(Guid pId)
        {
            var retval = from it in _re.All<PhotoTag>()
                         where it.PhotoID == pId
                         select it;
            return retval.ToList(); 
        }

        public List<PhotoTag> GetByUid(Guid uId)
        {
            var retval = from it in _re.All<PhotoTag>()
                         where it.UserID == uId
                         select it;
            return retval.ToList(); 
        }
    }
}
