﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Service.Interface.Tik;
using System.Web.Script.Serialization;
using System.Text;

namespace Social.Web.AjaxHandlers
{
    /// <summary>
    /// Summary description for GetCompany
    /// </summary>
    public class GetCompany : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            if (context.Request.UrlReferrer == null) return;
            if (!context.Request.UrlReferrer.Host.Equals(context.Request.Url.Host)) return;

            context.Response.ContentType = "application/json";
            context.Response.ContentEncoding = Encoding.UTF8;
            string query = context.Request.Form["query"];
            int top = string.IsNullOrEmpty(context.Request.Form["limit"]) ? 0 : Convert.ToInt32(context.Request.Form["limit"]);
            if (string.IsNullOrEmpty(query))
            {
                context.Response.Write(" ");
                return;
            }

            var companyService = DependencyResolver.Current.GetService<ICompanyService>();
            var company = companyService.Search(query, top);

            JavaScriptSerializer serializer = new JavaScriptSerializer();
            var output = serializer.Serialize(company);
            context.Response.Write(output); 
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}