﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Social.Lib;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using System.Web.Mvc;
using System.Web.SessionState;

namespace Social.Web.AjaxHandlers
{
    /// <summary>
    /// Summary description for UpdateProfile
    /// </summary>
    public class UpdateProfile : IHttpHandler, IReadOnlySessionState
    {
        private readonly IUserProfileService _user = DependencyResolver.Current.GetService<IUserProfileService>();

        public void ProcessRequest(HttpContext context)
        {
            var result = "";
            var type = context.Request.QueryString["type"];
            if (string.IsNullOrEmpty(type))
            {
                type = context.Request.Form["type"];
            }
            switch (type)
            {
                case "AboutMe":
                    result = UpdateAboutMe(context);
                    break;
                default:
                    result = "";
                    break;
            }
            context.Response.ContentType = "text/plain";
            context.Response.Write(result);
        }

        /// <summary>
        ///     Update About Me
        /// </summary>
        /// <param name="context"></param>
        /// <returns>
        ///     1 - update success
        ///     0 - update false
        /// </returns>
        private string UpdateAboutMe(HttpContext context)
        {
            Guid userID = SessionManager.CurrentUserID();

            UserProfile user = _user.GetByID(userID);

            if (user == null) return "0";
            string val = context.Request.QueryString["val"];
            if (string.IsNullOrEmpty(val))
            {
                val = context.Request.Form["val"];
            }

            if (!val.Trim().Equals("Cập nhật giới thiệu của bạn!"))
            {
                user.AboutMe = val;
            }
            try
            {
                _user.Update(user);
            }
            catch(Exception ex)
            {
                return "0";
            }

            return "1";
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}