﻿using System.Web.Mvc;

namespace Social.Web.Areas.Cms
{
    public class CmsAreaRegistration : AreaRegistration
    {
        public override string AreaName
        {
            get
            {
                return "Cms";
            }
        }

        public override void RegisterArea(AreaRegistrationContext context)
        {
            context.MapRoute(
                "Cms_Intro",
                "intro/{pagekey}",
                new {controller="StaticPage", action = "Index", pagekey = UrlParameter.Optional }
            );
            context.MapRoute(
                "Cms_User_Search",
                "member/search",
                new { controller = "MemberSearch", action = "SearchResult", character = UrlParameter.Optional }
            );
            context.MapRoute(
                "Cms_List",
                "member/list/{character}",
                new { controller = "Member", action = "Index", character = UrlParameter.Optional }
            );
            context.MapRoute(
                "Cms_Search",
                "member/result/{character}",
                new { controller = "MemberSearch", action = "Index", character = UrlParameter.Optional }
            );
            context.MapRoute(
                "Cms_default",
                "member/{character}/{startRow}/{endRow}",
                new { controller = "Member", action = "Index", character = UrlParameter.Optional, startRow = UrlParameter.Optional, endRow = UrlParameter.Optional }
            );

            

            context.MapRoute(
                "Cms_Update",
                "member/{action}/{character}",
                new { controller = "Member", action = "Basic", character = UrlParameter.Optional }
            );

            context.MapRoute(
                "Cms_UpdateUniversity",
                "member/{action}/{id}",
                new { controller = "Member", action = "University", id = UrlParameter.Optional }
            );
        }
    }
}
