﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Mvc;
using Social.Entity;
using Social.Entity.Tik;
using Social.Service;
using Social.Service.Interface.Tik;
using Social.Web.Extends.Helper;
using Google.GData.Contacts;
using Google.GData.Client;
using Google.GData.Extensions;
using Google.Contacts;
using System.Data;
using System.Collections;
using System.Configuration;

namespace Social.Web.Areas.Cms.Controllers
{
    public class MemberController : Controller
    {
        //
        // GET: /Cms/Member/
        IUserProfileService _user;
        //
        // GET: /UserSchool/
        public MemberController(IUserProfileService user)
        {
            _user = user;
        }

        public ActionResult Index(string character = "A", string startRow = "", string endRow = "")
        {
            List<UserProfile> listUser = new List<UserProfile>();
            int sRow = 0;
            int eRow = 0;

            int.TryParse(startRow,out sRow);
            int.TryParse(endRow,out eRow);

            int totalUser = (sRow == 0|| eRow == 0) ? _user.CountListUserByCharacter(character) : eRow - sRow + 1;
            //int totalUser = (sRow == 0 || eRow == 0) ? 189000 : eRow - sRow + 1;

            Dictionary<string, string> groupUser = new Dictionary<string,string>();
            int memberSize = 0;
            int.TryParse(ConfigurationManager.AppSettings["MemberSize"],out memberSize);
            if (memberSize == 0) memberSize = 20;

            if (totalUser > memberSize)
            {
                int count = totalUser / memberSize;
                if (totalUser % memberSize > 0)
                {
                    count++;
                }

                int lengthGroupUser = (count > memberSize) ? count : memberSize;

                for (int i = 0; i < ((count > memberSize) ? memberSize : count); i++)
                {
                    int startUserIndex = sRow == 0 ? lengthGroupUser * i + 1 : sRow + lengthGroupUser * i;
                    int endUserIndex = totalUser >= lengthGroupUser * (i + 1) ? lengthGroupUser + startUserIndex - 1 : totalUser +  ((sRow == 0) ? sRow : (sRow - 1)) ;

                    groupUser.Add(GetGroupUser(character, startUserIndex, endUserIndex), string.Format("/member/{0}/{1}/{2}", character, startUserIndex, endUserIndex));
                }
            }
            else
            {
                listUser = _user.GetListUserByCharacter(character);
            }

            ViewBag.groupUser = groupUser;

            ViewData["DefaultAvata"] = ConfigurationManager.AppSettings["DefaultAvatar"];

            return View(listUser);
        }

        private string GetGroupUser(string character, int startUserIndex, int endUserIndex)
        {
            UserProfile userStart = _user.GetUserByCharacterAndIndex(character, startUserIndex);
            ViewData["StartUser"] = userStart;

            UserProfile userEnd = _user.GetUserByCharacterAndIndex(character, endUserIndex);
            ViewData["EndUser"] = userEnd;

            //return String.Format("{0} {1} - {2} {3}", userStart.FirstName, userStart.LastName, userEnd.FirstName, userEnd.LastName);
            return String.Format("Thành viên : {0} - Đến thành viên {1}", userStart.FullName, userEnd.FullName);
        }

        public ActionResult Search(string character)
        {
            return View(_user.GetAll(u => u.LastName.Contains(character) && u.FirstName.Contains(character)));
        }

        [HttpPost]
        public ActionResult SearchResult(string keySearch)
        {
            IList<UserProfile> listdata = _user.GetAll(u => u.LastName.ToLower().Contains(keySearch.ToLower()) || u.FirstName.ToLower().Contains(keySearch.ToLower()));

            return RedirectToAction("Search", listdata);
        }
    }
}
