﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Mvc;
using Social.Entity;
using Social.Entity.Tik;
using Social.Service;
using Social.Service.Interface.Tik;
using Social.Web.Extends.Helper;
using Google.GData.Contacts;
using Google.GData.Client;
using Google.GData.Extensions;
using Google.Contacts;
using System.Data;
using System.Collections;
using System.Configuration;

namespace Social.Web.Areas.Cms.Controllers
{
    public class MemberSearchController : Controller
    {
        //
        // GET: /Cms/Member/
        IUserProfileService _user;

        public MemberSearchController(IUserProfileService user)
        {
            _user = user;
        }

        public ActionResult Index(string character)
        {
            if (TempData["KeySearch"] != null)
            {
                ViewData["KeySearch"] = TempData["KeySearch"].ToString();
            }

            return View(_user.GetAll(u => u.LastName.Contains(character) || u.FirstName.Contains(character)));
        }

        [HttpPost]
        public ActionResult SearchResult(string keySearch)
        {
            //IList<UserProfile> listdata = _user.GetAll(u => u.LastName.ToLower().Contains(keySearch.ToLower()) || u.FirstName.ToLower().Contains(keySearch.ToLower()));
            TempData["KeySearch"] = string.IsNullOrEmpty(keySearch) ? "Nhập tên" : keySearch;
            return RedirectToAction("Index", "MemberSearch", new { character = keySearch});
        }
    }
}
