﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.DAL;
using Social.Entity;
using Social.Service;
using Social.Service.Interface.TikCms;
using Social.Web.Logging;
using Social.Web.Extends;
using Social.Entity.TikCms;
using Social.Lib;

namespace Social.Web.Areas.Cms.Controllers
{
    public class StaticPageController : Controller
    {
        IStaticPageService _ls;
        // GET: /Support/
        public StaticPageController(IStaticPageService ls) 
        {
            _ls = ls;
        }
        public ActionResult Index(string pagekey = "gioi-thieu")
        {
            //Get List
            List<StaticPage> lstPage;
            if (Memcached.MainCache.Get<List<StaticPage>>("StaticPage") != null)
                lstPage = Memcached.MainCache.Get<List<StaticPage>>("StaticPage");
            else
            {
                lstPage = _ls.GetAll().ToList();
                Memcached.MainCache.Store(Enyim.Caching.Memcached.StoreMode.Set, "StaticPage", lstPage, Memcached.CacheTime);
            }            
            //Get Detail            
            StaticPage page;
            if (Memcached.MainCache.Get<StaticPage>("DetailPage_" + pagekey) != null)
                page = Memcached.MainCache.Get<StaticPage>("DetailPage_" + pagekey);
            else
            {
                page = _ls.GetByPageKey(pagekey);
                if (page == null)
                    page = _ls.GetByPageKey("gioi-thieu");
                Memcached.MainCache.Store(Enyim.Caching.Memcached.StoreMode.Set, "DetailPage_" + page.PageKey, page, Memcached.CacheTime);
            }
            ViewData["PageDetail"] = page;
            return View(lstPage);
        }


    }
}
