﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Lib;
using Social.Service.Interface.TikActivity;
using Social.Web.Areas.Feed.Models;

namespace Social.Web.Areas.Feed.Controllers
{
    public class NotificationController : Controller
    {
        private IUserNotificationService _userNotification;
        public NotificationController(IUserNotificationService userNotification)
        {
            _userNotification = userNotification;
        }

        public ActionResult Index()
        {
            if (!SessionManager.CheckLogin()) return RedirectToRoute("Register_Index");

            var notifications = _userNotification.GetAll(SessionManager.CurrentUserID(), false);
            List<Notification> listNotification = Notification.Convert(notifications, false);
            _userNotification.UpdateRead(SessionManager.CurrentUserID());
            return View(listNotification);
        }

    }
}
