﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Entity.Tik;
using Social.Entity.TikActivity;
using Social.Lib;
using Social.Service.Interface.Tik;
using Social.Service.Interface.TikActivity;
using Social.Service.Tik;
using Social.Web.Areas.Feed.Models;

namespace Social.Web.Areas.Feed.Controllers
{
    public class WallController : Controller
    {
        private IUserFeedService _userFeed;
        private IUserProfileService _userProfile;
        private IUserActivityService _userActivity;
        private UserProfile _currentUser;
        private UserProfile _user;
        
        public WallController(IUserFeedService userFeed, IUserProfileService userProfileService, IUserActivityService userActivity)
        {
            _userFeed = userFeed;
            _userProfile = userProfileService;
            _userActivity = userActivity;
            _currentUser = _userProfile.CurrentUser();
        }

        public ActionResult Index(string username)
        {
            if (!SessionManager.CheckLogin()) return RedirectToRoute("Register_Index");

            if (string.IsNullOrEmpty(username)) return RedirectToAction("NotFoundUser", "Error", new { area = "" });
            _user = _userProfile.GetUserByUsername(username);
            if (_user == null) return RedirectToAction("NotFoundUser", "Error", new { area = "" });

            bool isViewWall = Social.Web.Service.CheckPermission.IsPermission(Social.Lib.SessionManager.CurrentUserID(), _user.ID, Social.Lib.Tik.Constants.ConfigKey.USER_WALL);
            if (!isViewWall) return Redirect(string.Format("~/{0}/Profile", username));

            var activity = _userActivity.GetWallActivity(_user.ID, DateTime.Now, ConfigManager.MaxFeedItemLoad);
            var activities = ActivityWall.Convert(_user.ID, activity);

            //List<Social.Web.Areas.Feed.Models.Feed> feeds = Social.Web.Areas.Feed.Models.Feed.Convert(userFeeds);
            ViewData.Add("CurrentUser", _currentUser);
            ViewData.Add("User", _user);
            return View(activities);
        }

    }
}
