﻿using System;
using System.Web.Mvc;

namespace Social.Web.Areas.Feed
{
    public class FeedAreaRegistration : AreaRegistration
    {
        public override string AreaName
        {
            get
            {
                return "Feed";
            }
        }

        public override void RegisterArea(AreaRegistrationContext context)
        {
            //Tu choi vao wall truc tiep 
            context.Routes.IgnoreRoute("Feed/Wall");
            context.Routes.IgnoreRoute("Feed/Wall/Index");

            context.MapRoute(
                "Notification_default",
                "Notification",
                new { controller = "Notification", action = "Index", id = UrlParameter.Optional }
                );
            context.MapRoute(
                "Feed_Index",
                "Feed/Index",
                new {controller = "Index", action = "Index", id = UrlParameter.Optional}
                );
            context.MapRoute(
                "Feed_Index_default",
                "Feed",
                new {controller = "Index", action = "Index", id = UrlParameter.Optional}
                );
            context.MapRoute(
                "Feed_Wall_Default",
                "{username}",
                new { controller = "Wall", action = "Index" }
                );
            context.MapRoute(
                "Feed_Wall",
                "{username}/Wall",
                new {controller = "Wall", action = "Index"}
                );
            context.MapRoute(
                "Feed_View",
                "Feed/View/{objectid}/{comment}",
                new {controller = "Index", action = "View", comment = false}
                );
            context.MapRoute(
                "Feed_default",
                "Feed/{controller}/{action}/{id}",
                new { action = "Index", id = UrlParameter.Optional }
                );
            //context.MapRoute(
            //    "Feed_default_with_username",
            //    "{username}/Feed/{controller}/{action}/{id}",
            //    new {action = "Index", id = UrlParameter.Optional}
            //    ); 
            //context.MapRoute(
            //    "Feed_Index_with_username",
            //    "{username}/Feed/Index",
            //    new { controller = "Index", action = "Index", id = UrlParameter.Optional }
            //    );
            //context.MapRoute(
            //    "Feed_Index_default_with_username",
            //    "{username}/Feed",
            //    new { controller = "Index", action = "Index", id = UrlParameter.Optional }
            //    );

        }
    }
}
