﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Entity.Tik;
using Social.Entity.TikActivity;
using Social.Lib.Activity;
using Social.Service.Interface.Tik;
using Social.Service.Interface.TikActivity;

namespace Social.Web.Areas.Feed.Models
{
    public class Activity
    {
        public enum TypeShow
        {
            Activity = 1,
            Feed = 2,
            Tag = 3,
            Friend = 4,
            Comment = 5,
            Like =6,
            ProfileAvatar = 7
        }

        public Guid ID { get; set; }

        public TypeShow Type { get; set; }

        public Guid OwnerID { get; set; }
        public UserProfile Owner { get; set; }
        public byte ActivityType { get; set; }
        public byte TargetType { get; set; }
        public Guid TargetID { get; set; }

        public UserProfile TargetUser { get; set; }
        public byte ObjectType { get; set; }
        public Guid ObjectID { get; set; }
        public DateTime CreatedDate { get; set; }

        public Feed ObjectFeed { get; set;}
        public FeedActivity ObjectFeedActivity { get; set; }
        public FeedFriend ObjectFeedFriend { get; set; }
        public FeedTag ObjectTag { get; set; }
        public FeedComment ObjectComment { get; set; }
        public FeedChangeAvatar ObjectFeedChangeAvatar { get; set; }
        protected IUserProfileService _userProfileService = DependencyResolver.Current.GetService<IUserProfileService>();
        protected IUserFeedService _userFeedService = DependencyResolver.Current.GetService<IUserFeedService>();

        public Activity()
        {
            
        }
    }
}
