﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Service.Interface.Tik;
using Social.Entity.Tik;
using Social.Lib;
using Social.Service.Interface.TikFriend;

namespace Social.Web.Areas.Friend.Controllers
{
    public class ColleaguesController : Controller
    {
        //
        // GET: /Friend/Colleagues/
        //đồng nghiệp

        ICompanyService _companyservice;
        IUserCompanyService _usercompanyservice;
        IUserProfileService _userprofileservice;
        IUserCompanyAndUserSearchService _usercompanyandusersearchservice;

        IUserUniversityAndUserSearchService _useruniversityandusersearchservice;
        IUserSchoolAndUserSearchService _userschoolandusersearchservice;
        
        //đã là bạn
        IFriendSearchService _friendsearchservice;
        //đang chờ kết bạn
        IFriendRequestService _friendrequestservice;

        public ColleaguesController(ICompanyService companyservice, IUserCompanyService usercompanyservice,IUserProfileService userprofileservice,IUserCompanyAndUserSearchService usercompanyandusersearchservice,IUserUniversityAndUserSearchService useruniversityandusersearchservice,IUserSchoolAndUserSearchService userschoolandusersearchservice,IFriendSearchService friendsearchservice,IFriendRequestService friendrequestservice)
        {
            _usercompanyandusersearchservice = usercompanyandusersearchservice;
            _userprofileservice = userprofileservice;
            _companyservice = companyservice;
            _usercompanyservice = usercompanyservice;
            _useruniversityandusersearchservice = useruniversityandusersearchservice;
            _userschoolandusersearchservice = userschoolandusersearchservice;
            _friendsearchservice = friendsearchservice;
            _friendrequestservice = friendrequestservice;
        }

        public JsonResult GetCompany()
        {
            try {
                var listcompany = _companyservice.GetAll();
                return Json(listcompany, JsonRequestBehavior.AllowGet);
            }
            catch {
                return Json(new Company(), JsonRequestBehavior.AllowGet);
            }
        }
        public ActionResult GetByUserID()
        {
            try {
                if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
                var jsonusercompany = _usercompanyservice.GetUserCompanyByUserID(SessionManager.CurrentUserID());
                if (jsonusercompany != null)
                    return View(jsonusercompany);
                else
                    return View();
            }
            catch {
                return View();
            }
        
        }
        public ActionResult Colleagues()
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            var jsonusercompany = _usercompanyservice.GetByUserId(SessionManager.CurrentUserID());
            ViewData["JsonUserCompany"] = jsonusercompany;

            return View();
        }

        public string ResultKeyword(string fullname, string company)
        {

            string str = "";

            try
            {

                var _list = _usercompanyandusersearchservice.GetKeyWordUserID(fullname, company,SessionManager.CurrentUserID());
                var _listuserprofile = _userprofileservice.GetAllUserID(_list);
                str = "<div class=\"result-search\"><div class=\"friend-display\">Có " + _list.Count() + " kết quả tìm kiếm</div><div class=\"list_search_result\"><ul>";

                foreach (var listuser in _listuserprofile)
                {
                    if (listuser.ID != SessionManager.CurrentUserID())
                    {

                        str += "<li><a alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" href=\"" + listuser.ProfileLink + "\">";
                        str += "<img width=\"50\" height=\"50\" alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" src=\"" + listuser.SmallAvatarUrl + "\" class=\"imgSearchFriend\"></a>";
                        str += "<p>";
                        str += "<strong><a alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" href=\"" + listuser.ProfileLink + "\" class=\"linkSearchFriend\">" + listuser.FullName + "</a></strong></p><p class=\"mf_1000054475\">";

                        var checkrequestfriend = _friendrequestservice.GetCountByFromUserIDAndToUserID(SessionManager.CurrentUserID(), listuser.ID);
                        var checkrequestfriend1 = _friendrequestservice.GetCountByFromUserIDAndToUserID(listuser.ID, SessionManager.CurrentUserID());
                        var checkuserfriend = _friendsearchservice.CheckFriend(listuser.ID, SessionManager.CurrentUserID());
                        if (checkrequestfriend > 0)
                        {
                            str += "<span> đang chờ kết bạn</span></p></li>";
                        }
                        else if (checkrequestfriend1 > 0)
                        {
                            str += "<span> đồng ý kết bạn</span></p></li>";
                        }
                        else if (checkuserfriend == true)
                        {

                        }
                        else
                        {
                            str += "<img height=\"16\" class=\"icon01 ico14\" src=\"http://banbecdn.net/images/graphics/blank_img.gif\">";
                            str += "<a href=\"#\" class=\"btn-addfriendearch\" id=\"" + listuser.ID + "\"  alt=\"" + listuser.FullName + "\"> kết bạn</a></p></li>";
                        }
                    }
                }

                str += "</ul></div></div>";
            }
            catch { }
            return str;
        }



    }
}
