﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Service.Tik;
using Social.Service.Interface.Tik;
using Social.Entity.Tik;
using Social.Lib;
using Social.Service.Interface.TikFriend;

namespace Social.Web.Areas.Friend.Controllers
{
    public class EducationController : Controller
    {
        //
        // GET: /Friend/Education/
        //giáo dục

        IUserUniversityService _useruniversityservice;
        IUniversityService _universityservice;
        IUserSchoolService _usershoolservice;
        ISchoolService _shoolservice;
        IUserUniversityAndUserSearchService _useruniversityandusersearchservice;
        IUserSchoolAndUserSearchService _userschoolandusersearchservice;
        IUserProfileService _userprofileservice;
        //đã là bạn
        IFriendSearchService _friendsearchservice;
        //đang chờ kết bạn
        IFriendRequestService _friendrequestservice;

        public EducationController(IUserUniversityService useruniversityservice,
            IUniversityService universityservice,
            IUserSchoolService usershoolservice,IUserProfileService userprofileservice,
            IFriendSearchService friendsearchservice,
            IFriendRequestService friendrequestservice,

            ISchoolService shoolservice, IUserUniversityAndUserSearchService useruniversityandusersearchservice, IUserSchoolAndUserSearchService userschoolandusersearchservice)
        {

            _useruniversityservice = useruniversityservice;
            _universityservice = universityservice;
            _usershoolservice = usershoolservice;
            _shoolservice = shoolservice;
            _useruniversityandusersearchservice = useruniversityandusersearchservice;
            _userschoolandusersearchservice = userschoolandusersearchservice;
            _userprofileservice = userprofileservice;
            _friendsearchservice=friendsearchservice;
            _friendrequestservice = friendrequestservice;

        }



        public JsonResult GetUniversity()
        {
            //lấy tất cả các trường đổ vào textbox
            var listuniversity = _universityservice.GetAll();
            return Json(listuniversity, JsonRequestBehavior.AllowGet);
        }

        public ActionResult GetByUserIDUniversity()
        {
            try
            {
                if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
                Guid userID = SessionManager.CurrentUserID();
                var jsonuserUniversity = _useruniversityservice.GetByTop1(userID);
                ViewData["jsonuserUniversity"] = jsonuserUniversity;
                return View(jsonuserUniversity);
            }
            catch {
                return View();
            }
            
        }
        public JsonResult GetHightShools()
        {
            try {
                var listshools = _shoolservice.GetAll();
                return Json(listshools, JsonRequestBehavior.AllowGet);
            }
            catch {
                return Json(new School(), JsonRequestBehavior.AllowGet);
            }
        
        }
        public ActionResult GetByUserShools()
        {
            try {
                if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
                Guid userID = SessionManager.CurrentUserID();
                var jsonusershool = _usershoolservice.GetByUserIDTop1(userID);
                ViewData["jsonusershool"] = jsonusershool;
                return View(jsonusershool);

            
            }
            catch {
                return View();
            }
        }
        public ActionResult ResultSearch(string fullname,string school,Int16 _class)
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            var _list = _useruniversityandusersearchservice.GetKeyWordUserID(fullname,school,_class,SessionManager.CurrentUserID());
            return View(_list);
        }
        public string ResultKeyword(string fullname, string school, string _class)
        {
            
            string str = "";
            try {
                Int16 kq=0;
                try {
                    kq = Convert.ToInt16(_class);
                }
                catch { }
                var _list = _useruniversityandusersearchservice.GetKeyWordUserID(fullname, school, kq,SessionManager.CurrentUserID());
                var _listuserprofile = _userprofileservice.GetAllUserID(_list);

                str = "<div class=\"result-search\"><div class=\"friend-display\">Có " + _listuserprofile.Count() + " kết quả tìm kiếm</div><div class=\"list_search_result\"><ul>";

                foreach (var listuser in _listuserprofile)
                {
                    if (listuser.ID != SessionManager.CurrentUserID())
                    {
                        str += "<li><a alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" href=\"" + listuser.ProfileLink + "\">";
                        str += "<img width=\"50\" height=\"50\" alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" src=\"" + listuser.SmallAvatarUrl + "\" class=\"imgSearchFriend\"></a>";
                        str += "<p>";
                        str += "<strong><a alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" href=\"" + listuser.ProfileLink + "\" class=\"linkSearchFriend\">" + listuser.FullName + "</a></strong></p><p class=\"mf_1000054475\">";
                        var checkrequestfriend = _friendrequestservice.GetCountByFromUserIDAndToUserID(SessionManager.CurrentUserID(), listuser.ID);
                        var checkrequestfriend1 = _friendrequestservice.GetCountByFromUserIDAndToUserID(listuser.ID, SessionManager.CurrentUserID());
                        var checkuserfriend = _friendsearchservice.CheckFriend(listuser.ID,SessionManager.CurrentUserID());
                        if (checkrequestfriend > 0)
                        {
                            str += "<span> đang chờ kết bạn</span></p></li>";
                        }
                        else if (checkrequestfriend1 > 0)
                        {
                            str += "<span> đồng ý kết bạn</span></p></li>";
                        }
                        else if (checkuserfriend==true)
                        {

                        }
                        else
                        {
                            str += "<img height=\"16\" class=\"icon01 ico14\" src=\"http://banbecdn.net/images/graphics/blank_img.gif\">";
                            str += "<a href=\"#\" class=\"btn-addfriendearch\" id=\"" + listuser.ID + "\"  alt=\"" + listuser.FullName + "\"> kết bạn</a></p></li>";
                        }
                    }

                }

                str+="</ul></div></div>";
            }
            catch { }
            return str;
        }


        //hiển thị trường trung học

        public string ResultKeywordSchool(string fullname, string school, string _class)
        {

            string str = "";
           
            try
            {
                Int16 kq = 0;
                try
                {
                    kq = Convert.ToInt16(_class);
                }
                catch { }
                var _list = _userschoolandusersearchservice.GetKeyWordUserID(fullname, school, kq,SessionManager.CurrentUserID());
                var _listuserprofile = _userprofileservice.GetAllUserID(_list);
                str = "<div class=\"result-search\"><div class=\"friend-display\">Có " + _list.Count() + " kết quả tìm kiếm</div><div class=\"list_search_result\"><ul>";

                foreach (var listuser in _listuserprofile)
                {
                    if (listuser.ID != SessionManager.CurrentUserID())
                    {
                        str += "<li><a alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" href=\"" + listuser.ProfileLink + "\">";
                        str += "<img width=\"50\" height=\"50\" alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" src=\"" + listuser.SmallAvatarUrl + "\" class=\"imgSearchFriend\"></a>";
                        str += "<p>";
                        str += "<strong><a alt=\"" + listuser.FullName + "\" title=\"" + listuser.FullName + "\" href=\"" + listuser.ProfileLink + "\" class=\"linkSearchFriend\">" + listuser.FullName + "</a></strong></p><p class=\"mf_1000054475\">";

                        var checkrequestfriend = _friendrequestservice.GetCountByFromUserIDAndToUserID(SessionManager.CurrentUserID(), listuser.ID);
                        var checkrequestfriend1 = _friendrequestservice.GetCountByFromUserIDAndToUserID(listuser.ID, SessionManager.CurrentUserID());
                        var checkuserfriend = _friendsearchservice.CheckFriend(listuser.ID,SessionManager.CurrentUserID());
                        if (checkrequestfriend > 0)
                        {
                            str += "<span> đang chờ kết bạn</span></p></li>";
                        }
                        else if (checkrequestfriend1 > 0)
                        {
                            str += "<span> đồng ý kết bạn</span></p></li>";
                        }
                        else if (checkuserfriend== true)
                        {

                        }
                        else
                        {
                            str += "<img height=\"16\" class=\"icon01 ico14\" src=\"http://banbecdn.net/images/graphics/blank_img.gif\">";
                            str += "<a href=\"#\" class=\"btn-addfriendearch\" id=\""+ listuser.ID +"\"  alt=\"" + listuser.FullName + "\"> kết bạn</a></p></li>";
                        }

                    }

                }

                str += "</ul></div></div>";
            }
            catch { }
            return str;
        }

        




    }
}
