﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Service.Interface.TikFriend;
using Social.Web.Logging;
using Social.Entity.Tik;
using Social.Web.Extends;
using Social.Entity.TikFriend;
using Social.Service.Interface.Tik;
using Social.Service.TikFriend;
using System.Web.Script.Serialization;
using Social.Lib;

namespace Social.Web.Areas.Friend.Controllers
{
    public class FriendController : Controller
    {
        IUserProfileService _user;
        IFriendRequestService _friend;
        IUserFriendService _userfriend;

        IFriendListService _friendlist;
        IFriendInListService _friendinlistsevrvice;
        IUserUniversityService _useruniversityservice;
        IUserCompanyService _usercompanyservice;
        IUserSchoolService _userschoolservice;
        IFriendSearchService _friendsearchservice;
        IUserSearchService _usersearchservice;
        //IFriendInListService _friendinlist;

        private const int defaultPageSize = 10;
        public FriendController(IFriendRequestService friend, IUserProfileService user, IUserFriendService userfriend, IFriendListService friendlist, IFriendInListService friendinlistsevrvice, IUserUniversityService useruniversityservice, IUserCompanyService usercompanyservice, IUserSchoolService userschoolserivce, IFriendSearchService friendsearchservice,IUserSearchService usersearchservice)
        {
            _friendsearchservice = friendsearchservice;
            _friend = friend;
            _user = user;
            _userfriend = userfriend;
            _friendlist = friendlist;
            _friendinlistsevrvice = friendinlistsevrvice;
            _useruniversityservice = useruniversityservice;
            _usercompanyservice = usercompanyservice;
            _userschoolservice = userschoolserivce;
            _usersearchservice = usersearchservice;
            //_friendinlist = friendinlistsevrvice;
            if (SessionManager.IsLoggedIn())
            {
                Guid id = new Guid(SessionManager.Get("UserID").ToString());
                var ufr = _friend.GetByFromUserID(id);
                ViewData["DemWaiting"] = ufr.Count();
                ViewData["CountRequestFriend"] = _friend.Get(id).Count().ToString();
                var ufriend = _userfriend.GetAll().Where(o => o.OwnerID == id).Count();
                ViewData["CountListFriend"] = ufriend;
            }
        }

        public ActionResult GroupFriend(Guid friendinlistid, Guid friendid)
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");

            //Guid id = new Guid(SessionManager.Get("UserID").ToString());
            int friendinlist = _friendinlistsevrvice.GetCheckFriendInList(friendinlistid, friendid);
            //ViewBag["CountFriendList"] = friendlist.Count().ToString();
            //if (friendlist.Count > 0)
            //{
            if (friendinlist != 0)
            {
                ViewData["GroupFriend"] = "true";
            }
            else
            {
                ViewData["GroupFriend"] = "false";
            }

            //}
            return View();

        }

        public ActionResult Index(string username)
        {

            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");

            

            ViewData["SomeText"] = string.Empty;

            Guid id = new Guid(SessionManager.Get("UserID").ToString());
            var friendlist = _friendlist.GetStringFriendList(id);

            ViewData["FriendList"] = friendlist;



            List<Guid> ContatinerThisNot = new List<Guid> { id };
            if (!string.IsNullOrEmpty(username))
            {
                //username = SessionManager.CurrentUserUserName();
                UserProfile userProfile = _user.GetUserByUsername(username);
                Guid idoffriend = userProfile.ID;

                ContatinerThisNot.Add(idoffriend);

            }

            //Lấy danh sách người đã có yêu cầu kết bạn rồi
            var friendRequested = _friend.GetAll().Where(x => x.FromUserID == id || x.ToUserID==id).ToList().Select(x => x.ToUserID);
            //Lấy danh sách đã kết bạn
            var friends = _userfriend.GetAll().Where(o => o.OwnerID == id).ToList().Select(p => p.FriendID);
            //lấy danh sách trường
            var universitystring = _useruniversityservice.ListGetByGuid(id);
            //lấy trường university
            string universityquery = "";
            if (universitystring.Count() > 0)
            {
                universityquery = universitystring[0].University.ToString();
            }

            //json university
            JavaScriptSerializer serializer = new JavaScriptSerializer();

            // create a generic list of university
            List<UniversityObject> listOfUniversity = new List<UniversityObject>();

            // deserialize as a list of Categories, and put into listofuniversity
            listOfUniversity = serializer.Deserialize<List<UniversityObject>>("[" + universityquery + "]");
            List<string> listUniver = new List<string>();
            List<Guid> listuniversitypriority = new List<Guid>();

            //for (int k = 0; k < listOfCategories.Count(); k++)
            //{
            //    listUniver.Add(listOfCategories[k].name.ToString());
            //if (k == listOfCategories.Count - 1)
            //{
            try
            {
                var testuniversity = _useruniversityservice.GetByUniversity(listOfUniversity[listOfUniversity.Count() - 1].name.ToString()).Select(u => u.UserID).ToList();
                for (int o = 0; o < testuniversity.Count(); o++)
                {
                    if (testuniversity[o] != id)
                    {
                        listuniversitypriority.Add(testuniversity[o]);
                    }
                }
            }
            catch { }
            //    }

            //}

            //chỗ này là chỗ lấy các thằng cùng trường


            //
            //
            //lấy chuỗi trường học của thằng đăng nhập
            //
            //
            string schoolstring = "";
            try
            {
                schoolstring = _userschoolservice.GetByUserID(id);
            }
            catch { }
            JavaScriptSerializer javascriptshool = new JavaScriptSerializer();
            List<SchoolObject> listofshool = new List<SchoolObject>();
            listofshool = serializer.Deserialize<List<SchoolObject>>("[" + schoolstring + "]");
            //cắt chuỗi ra từng thằng
            List<string> liststringpriority = new List<string>();
            foreach (var sc in listofshool)
            {
                liststringpriority.Add(sc.name.ToString());
            }

            //lấy được thằng cùng trường tiểu học rồi hè hè
            var testschoolpriority = _userschoolservice.GetBySchool(liststringpriority);
            //int demcainhi = testschoolpriority.Count();

            // -- 1 -- cùng trường tiểu học
            var suggestFriendListschool = _user.GetUserProfileCountFriend().Where(x => testschoolpriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !ContatinerThisNot.Contains(x.ID)).Take(10).ToList();
            foreach (var suggestFriend in suggestFriendListschool)
            {
                //Lấy danh sách bạn của thằng suggest
                var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID).Distinct();
                //Đếm số lượng bạn chung
                int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                ////Đếm
                //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                //var dem=from c in _userfriend.GetAll()
                //        where c.OwnerID
                if (dem > 0)
                {
                    suggestFriend.UserCount = dem;
                }

            }

            //
            //
            //end hết chỗ lấy các thằng cùng trường
            //
            //

            //
            //
            //lấy các thằng cùng công ty cái
            //
            string listusercompany = "";
            try
            {
                listusercompany = _usercompanyservice.GetByUserId(id);
            }
            catch { }
            JavaScriptSerializer javascriptcompany = new JavaScriptSerializer();
            List<string> liststringcompany = new List<string>();
            List<CompanyObject> listofcomapny = new List<CompanyObject>();
            listofcomapny = serializer.Deserialize<List<CompanyObject>>("[" + listusercompany + "]");


            foreach (var ucom in listofcomapny)
            {
                liststringcompany.Add(ucom.name);
            }
            var testcompanypriority = _usercompanyservice.GetByCompany(liststringcompany);
            // -- 2 -- cùng công ty nè
            var suggestFrindListCompany = _user.GetUserProfileCountFriend().Where(x => testcompanypriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !ContatinerThisNot.Contains(x.ID)).Take(10).ToList();
            int demcongtytrungnhau = suggestFrindListCompany.Count();
            foreach (var suggestFriend in suggestFrindListCompany)
            {
                //Lấy danh sách bạn của thằng suggest
                var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID).Distinct();
                //Đếm số lượng bạn chung
                int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                ////Đếm
                //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                //var dem=from c in _userfriend.GetAll()
                //        where c.OwnerID
                if (dem > 0)
                {
                    suggestFriend.UserCount = dem;
                }

            }


            //
            //
            //lấy các thằng cùng công ty cái
            //
            //


            // lấy userId có cùng trường với thằng đăng nhập
            var fruniversity = _useruniversityservice.GetAll().Where(c => listUniver.Contains(c.University) && !ContatinerThisNot.Contains(c.UserID)).Select(c => c.UserID);
            int fo = fruniversity.Count();

            //Lấy danh sách gợi ý
            // -- 3 -- cùng lớp đại học
            var suggestFriendList = _user.GetUserProfileCountFriend().Where(x => listuniversitypriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !ContatinerThisNot.Contains(x.ID)).Take(10).ToList();

            foreach (var suggestFriend in suggestFriendList)
            {
                //Lấy danh sách bạn của thằng suggest
                var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID).Distinct();
                //Đếm số lượng bạn chung
                int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                ////Đếm
                //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                //var dem=from c in _userfriend.GetAll()
                //        where c.OwnerID
                if (dem > 0)
                {
                    suggestFriend.UserCount = dem;
                }

            }

            List<UserProfileAndCountUserFriend> GetListFriendSuggest = new List<UserProfileAndCountUserFriend>();
            List<Guid> listcungdiemchung = new List<Guid>();
            if (GetListFriendSuggest.Count() > 0)
            {
                foreach (var suggest in GetListFriendSuggest)
                {
                    listcungdiemchung.Add(suggest.ID);
                }
            }
            //add cùng trường tiểu học
            foreach (var school in suggestFriendListschool)
            {
                GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = school.AboutMe, BirthDay = school.BirthDay, CurrentAddress = school.CurrentAddress, Email = school.Email, FirstName = school.FirstName, Gender = school.Gender, HomeAddress = school.HomeAddress, LastName = school.LastName, UserName = school.UserName, ID = school.ID, UserCount = school.UserCount, SmallAvatarUrl = school.SmallAvatarUrl });
            }

            //add bạn cùng học đại học
            foreach (var school in suggestFriendList)
            {
                GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = school.AboutMe, BirthDay = school.BirthDay, CurrentAddress = school.CurrentAddress, Email = school.Email, FirstName = school.FirstName, Gender = school.Gender, HomeAddress = school.HomeAddress, LastName = school.LastName, UserName = school.UserName, ID = school.ID, UserCount = school.UserCount, SmallAvatarUrl = school.SmallAvatarUrl });
            }

            //add bạn cùng công ty
            foreach (var school in suggestFrindListCompany)
            {
                GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = school.AboutMe, BirthDay = school.BirthDay, CurrentAddress = school.CurrentAddress, Email = school.Email, FirstName = school.FirstName, Gender = school.Gender, HomeAddress = school.HomeAddress, LastName = school.LastName, UserName = school.UserName, ID = school.ID, UserCount = school.UserCount, SmallAvatarUrl = school.SmallAvatarUrl });
            }
            int demgiongnhau = GetListFriendSuggest.Count();
            if (demgiongnhau < 20)
            {
                // thêm các bạn gơi ý kết bạn
                var suggestFriend = _user.GetUserProfileCountFriend().Where(x => !listcungdiemchung.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !ContatinerThisNot.Contains(x.ID)).Take(20 - demgiongnhau).ToList();
                foreach (var friend in suggestFriend)
                {
                    //đếm số bạn chung

                    //Lấy danh sách bạn của thằng suggest
                    var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == friend.ID).Select(f => f.FriendID).Distinct();
                    //Đếm số lượng bạn chung
                    int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                    ////Đếm
                    //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                    //var dem=from c in _userfriend.GetAll()
                    //        where c.OwnerID
                    if (dem > 0)
                    {
                        friend.UserCount = dem;
                    }

                    GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = friend.AboutMe, BirthDay = friend.BirthDay, CurrentAddress = friend.CurrentAddress, Email = friend.Email, FirstName = friend.FirstName, Gender = friend.Gender, HomeAddress = friend.HomeAddress, LastName = friend.LastName, UserName = friend.UserName, ID = friend.ID, UserCount = friend.UserCount, SmallAvatarUrl = friend.SmallAvatarUrl });



                }
            }


            var totalfriend = GetListFriendSuggest.OrderBy(c => Guid.NewGuid()).Take(3).ToList();
            //var friendguinot=totalfriend.Select(c=>c.ID);
            foreach (var fr in totalfriend)
            {
                GetListFriendSuggest.Remove(fr);
            }
            ViewData["MoreFriend"] = GetListFriendSuggest;

            ViewData["ListFriend"] = totalfriend;

            return View("Index");
        }

        public ActionResult _SuggestFriendPage()
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");

            ViewData["SomeText"] = string.Empty;

            Guid id = new Guid(SessionManager.Get("UserID").ToString());
            var friendlist = _friendlist.GetStringFriendList(id);

            ViewData["FriendList"] = friendlist;



            List<Guid> ContatinerThisNot = new List<Guid> { id };


            //Lấy danh sách người đã có yêu cầu kết bạn rồi
            var friendRequested = _friend.GetAll().Where(x => x.FromUserID == id).ToList().Select(x => x.ToUserID);
            //Lấy danh sách đã kết bạn
            var friends = _userfriend.GetAll().Where(o => o.OwnerID == id).ToList().Select(p => p.FriendID);
            //lấy danh sách trường
            var universitystring = _useruniversityservice.ListGetByGuid(id);
            //lấy trường university
            string universityquery = "";
            if (universitystring.Count() > 0)
            {
                universityquery = universitystring[0].University.ToString();
            }

            //json university
            JavaScriptSerializer serializer = new JavaScriptSerializer();

            // create a generic list of university
            List<UniversityObject> listOfUniversity = new List<UniversityObject>();

            // deserialize as a list of Categories, and put into listofuniversity
            listOfUniversity = serializer.Deserialize<List<UniversityObject>>("[" + universityquery + "]");
            List<string> listUniver = new List<string>();
            List<Guid> listuniversitypriority = new List<Guid>();

            //for (int k = 0; k < listOfCategories.Count(); k++)
            //{
            //    listUniver.Add(listOfCategories[k].name.ToString());
            //if (k == listOfCategories.Count - 1)
            //{
            try
            {
                var testuniversity = _useruniversityservice.GetByUniversity(listOfUniversity[listOfUniversity.Count() - 1].name.ToString()).Select(u => u.UserID).ToList();
                for (int o = 0; o < testuniversity.Count(); o++)
                {
                    if (testuniversity[o] != id)
                    {
                        listuniversitypriority.Add(testuniversity[o]);
                    }
                }
            }
            catch { }
            //    }

            //}

            //chỗ này là chỗ lấy các thằng cùng trường


            //
            //
            //lấy chuỗi trường học của thằng đăng nhập
            //
            //
            string schoolstring = "";
            try
            {
                schoolstring = _userschoolservice.GetByUserID(id);
            }
            catch { }
            JavaScriptSerializer javascriptshool = new JavaScriptSerializer();
            List<SchoolObject> listofshool = new List<SchoolObject>();
            listofshool = serializer.Deserialize<List<SchoolObject>>("[" + schoolstring + "]");
            //cắt chuỗi ra từng thằng
            List<string> liststringpriority = new List<string>();
            foreach (var sc in listofshool)
            {
                liststringpriority.Add(sc.name.ToString());
            }

            //lấy được thằng cùng trường tiểu học rồi hè hè
            var testschoolpriority = _userschoolservice.GetBySchool(liststringpriority);
            //int demcainhi = testschoolpriority.Count();

            // -- 1 -- cùng trường tiểu học
            var suggestFriendListschool = _user.GetUserProfileCountFriend().Where(x => testschoolpriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !ContatinerThisNot.Contains(x.ID)).Take(10).ToList();
            foreach (var suggestFriend in suggestFriendListschool)
            {
                //Lấy danh sách bạn của thằng suggest
                var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID);
                //Đếm số lượng bạn chung
                int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                ////Đếm
                //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                //var dem=from c in _userfriend.GetAll()
                //        where c.OwnerID
                if (dem > 0)
                {
                    suggestFriend.UserCount = dem;
                }

            }

            //
            //
            //end hết chỗ lấy các thằng cùng trường
            //
            //

            //
            //
            //lấy các thằng cùng công ty cái
            //
            string listusercompany = "";
            try
            {
                listusercompany = _usercompanyservice.GetByUserId(id);
            }
            catch { }
            JavaScriptSerializer javascriptcompany = new JavaScriptSerializer();
            List<string> liststringcompany = new List<string>();
            List<CompanyObject> listofcomapny = new List<CompanyObject>();
            listofcomapny = serializer.Deserialize<List<CompanyObject>>("[" + listusercompany + "]");


            foreach (var ucom in listofcomapny)
            {
                liststringcompany.Add(ucom.name);
            }
            var testcompanypriority = _usercompanyservice.GetByCompany(liststringcompany);
            // -- 2 -- cùng công ty nè
            var suggestFrindListCompany = _user.GetUserProfileCountFriend().Where(x => testcompanypriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !ContatinerThisNot.Contains(x.ID)).Take(10).ToList();
            int demcongtytrungnhau = suggestFrindListCompany.Count();
            foreach (var suggestFriend in suggestFrindListCompany)
            {
                //Lấy danh sách bạn của thằng suggest
                var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID);
                //Đếm số lượng bạn chung
                int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                ////Đếm
                //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                //var dem=from c in _userfriend.GetAll()
                //        where c.OwnerID
                if (dem > 0)
                {
                    suggestFriend.UserCount = dem;
                }

            }


            //
            //
            //lấy các thằng cùng công ty cái
            //
            //


            // lấy userId có cùng trường với thằng đăng nhập
            var fruniversity = _useruniversityservice.GetAll().Where(c => listUniver.Contains(c.University) && !ContatinerThisNot.Contains(c.UserID)).Select(c => c.UserID);
            int fo = fruniversity.Count();

            //Lấy danh sách gợi ý
            // -- 3 -- cùng lớp đại học
            var suggestFriendList = _user.GetUserProfileCountFriend().Where(x => listuniversitypriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !ContatinerThisNot.Contains(x.ID)).Take(10).ToList();

            foreach (var suggestFriend in suggestFriendList)
            {
                //Lấy danh sách bạn của thằng suggest
                var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID);
                //Đếm số lượng bạn chung
                int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                ////Đếm
                //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                //var dem=from c in _userfriend.GetAll()
                //        where c.OwnerID
                if (dem > 0)
                {
                    suggestFriend.UserCount = dem;
                }

            }

            List<UserProfileAndCountUserFriend> GetListFriendSuggest = new List<UserProfileAndCountUserFriend>();
            List<Guid> listcungdiemchung = new List<Guid>();
            if (GetListFriendSuggest.Count() > 0)
            {
                foreach (var suggest in GetListFriendSuggest)
                {
                    listcungdiemchung.Add(suggest.ID);
                }
            }
            //add cùng trường tiểu học
            foreach (var school in suggestFriendListschool)
            {
                GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = school.AboutMe, BirthDay = school.BirthDay, CurrentAddress = school.CurrentAddress, Email = school.Email, FirstName = school.FirstName, Gender = school.Gender, HomeAddress = school.HomeAddress, LastName = school.LastName, UserName = school.UserName, ID = school.ID, UserCount = school.UserCount });
            }

            //add bạn cùng học đại học
            foreach (var school in suggestFriendList)
            {
                GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = school.AboutMe, BirthDay = school.BirthDay, CurrentAddress = school.CurrentAddress, Email = school.Email, FirstName = school.FirstName, Gender = school.Gender, HomeAddress = school.HomeAddress, LastName = school.LastName, UserName = school.UserName, ID = school.ID, UserCount = school.UserCount });
            }

            //add bạn cùng công ty
            foreach (var school in suggestFrindListCompany)
            {
                GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = school.AboutMe, BirthDay = school.BirthDay, CurrentAddress = school.CurrentAddress, Email = school.Email, FirstName = school.FirstName, Gender = school.Gender, HomeAddress = school.HomeAddress, LastName = school.LastName, UserName = school.UserName, ID = school.ID, UserCount = school.UserCount });
            }
            int demgiongnhau = GetListFriendSuggest.Count();
            if (demgiongnhau < 20)
            {
                // thêm các bạn gơi ý kết bạn
                var suggestFriend = _user.GetUserProfileCountFriend().Where(x => !listcungdiemchung.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !ContatinerThisNot.Contains(x.ID)).Take(20 - demgiongnhau).ToList();
                foreach (var friend in suggestFriend)
                {
                    GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = friend.AboutMe, BirthDay = friend.BirthDay, CurrentAddress = friend.CurrentAddress, Email = friend.Email, FirstName = friend.FirstName, Gender = friend.Gender, HomeAddress = friend.HomeAddress, LastName = friend.LastName, UserName = friend.UserName, ID = friend.ID, UserCount = friend.UserCount });
                }
            }

            return View(GetListFriendSuggest);
        }




        public ActionResult ListFriendGroup(int pId = 0)
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            try
            {


                Guid id = new Guid(SessionManager.Get("UserID").ToString());

                var viewuserfriend = _userfriend.GetListUserFriend_ByOwnerID(id, pId, 10);

                ViewData["ViewListFriend"] = viewuserfriend;

                var listfriend = _friendlist.GetJoin(id);
                foreach (var fr in listfriend)
                {
                    var friendinlist = _friendinlistsevrvice.Single(u => u.FriendListID == fr.ID);

                    if (friendinlist != null)
                    {
                        fr.FriendID = friendinlist.FriendID;
                    }
                }
                ViewData["FriendList"] = listfriend;
                if (Request.IsAjaxRequest())
                    return PartialView("ListFriendGroupAjax", viewuserfriend);



                return View();
            }
            catch
            {
                return RedirectToAction("Index", "", new { area = "Register" });
            }

        }


        public ActionResult SelectGroupFriend(string pId)
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            try
            {

                Guid id = new Guid(SessionManager.Get("UserID").ToString());
                //lấy ra friendID của friendinlist
                var friendinlists = _friendinlistsevrvice.GetFriendList_ByListIDAndStatus(new Guid(pId), true);


                //lấy ra tất cả userprofile của container friendID
                List<UserProfile> userprofile = new List<UserProfile>();
                foreach (var us in friendinlists)
                {
                    var uprofile = _user.GetByID(us.FriendID);
                    userprofile.Add(uprofile);
                }



                ViewData["CountSelectGroup"] = userprofile.Count();

                ViewData["ViewListFriend"] = userprofile;



                var listfriend = _friendlist.GetJoin(id);
                foreach (var fr in listfriend)
                {
                    var friendinlist = _friendinlistsevrvice.Single(u => u.FriendListID == fr.ID);

                    if (friendinlist != null)
                    {
                        fr.FriendID = friendinlist.FriendID;
                    }
                }
                ViewData["FriendList"] = listfriend;
                return View();
            }
            catch
            {
                return RedirectToAction("Index", "", new { area = "Register" });
            }

        }


        public ActionResult RequestListFriend(int pId = 0)
        {

            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            Guid id = new Guid(SessionManager.Get("UserID").ToString());
            var ufr = _friend.GetByFromUserID(new Guid(SessionManager.CurrentUserID().ToString()));


            var user_profile = _user.GetByID(id);

            //var user_profilepage = _user.GetByIDPage(id, pId, 10);

            //ViewBag["CountFriendList"] = friendlist.Count().ToString();
            //if (friendlist.Count > 0)
            //{
            ViewData["UserProfile"] = user_profile;
            //}
            var friendRequest = _friend.GetPage(id, pId, 10);
            foreach (var fr in friendRequest)
            {
                var userprofile = _user.Single(u => u.ID == fr.FromUserID);
                if (userprofile != null)
                {
                    fr.FullName = userprofile.FirstName + " " + userprofile.LastName;
                    fr.SmallAvatar = userprofile.SmallAvatarUrl;
                    fr.ProfileLink = userprofile.ProfileLink;

                }
            }

            if (Request.IsAjaxRequest())
                return PartialView("RequestListFriendAjax", friendRequest);

            return View(friendRequest);
        }

        //gửi mail cho bạn bè có trong danh sach mai của bạn
        //gmail
        public bool SendMailInviteFriend(string friend)
        {

            char[] separator = new char[] { ',' };

            string[] strSplitArr = friend.Split(separator);

            foreach (string arrStr in strSplitArr)
            {
                bool send = Social.Lib.Utility.Utility.SendMail(arrStr);
            }

            return true;
        }




        public ActionResult ListFriendTop6(string username)
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            Guid owrderId = Guid.Empty;
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            if (string.IsNullOrEmpty(username))
            {
                username = SessionManager.CurrentUserUserName();
                owrderId = new Guid(SessionManager.CurrentUserID().ToString());
            }
            else
            {
                UserProfile userProfile = _user.GetUserByUsername(username);

                owrderId = userProfile.ID;
            }
            var listfriendtop6 = _friendsearchservice.GetByOwnerIDTopIndex(owrderId, 6);

            foreach (var list in listfriendtop6)
            {
                var user1 = _user.GetByID(list.FriendID);
                list.UserName = user1.UserName;
            }

            //đếm số bạn của thằng đăng nhập
            int countfriend = _friendsearchservice.GetByOwnerIDTopIndex(owrderId, 0).Count();
            var listalluserfriend = _friendsearchservice.GetByOwnerIDTopIndex(owrderId, 0);
            foreach (var friendlistall1 in listalluserfriend)
            {
                var user1 = _user.GetByID(friendlistall1.FriendID);
                friendlistall1.UserName = user1.UserName;
            }



            foreach (var friendlistall in listfriendtop6)
            {
                listalluserfriend.Remove(friendlistall);
            }

            ViewData["ViewAllUserFriend"] = listalluserfriend;
            ViewData["CountFriend"] = countfriend.ToString();
            ViewData["ListTopFriend"] = listfriendtop6;
            return View();
        }

        public bool DeleteFriend(string friendid, string frid)
        {
            try
            {
                Guid ownnerID = new Guid(SessionManager.Get("UserID").ToString());
                Guid id = new Guid(friendid);
                Guid grid = new Guid(frid);
                //_userfriend.Delete(c => c.ID == id);

                _userfriend.Delete(c => c.OwnerID == ownnerID && c.FriendID == grid);
                _userfriend.Delete(c => c.OwnerID == grid && c.FriendID == ownnerID);
                _friendsearchservice.Delete(c => c.OwnerID == ownnerID && c.FriendID == grid);
                _friendsearchservice.Delete(c => c.OwnerID == grid && c.FriendID == ownnerID);
                
                var owner = _friendlist.GetStringFriendList(ownnerID);
                foreach (var listfriend in owner)
                {
                    Guid ListID = listfriend.ID;
                    //var listIn = _friendinlistsevrvice.GetByFriendListAndFriendId(ListID, grid);
                    _friendinlistsevrvice.Delete(c => c.FriendListID == ListID && c.FriendID == grid);
                }



                return true;
            }
            catch
            {
                return false;
            }

        }



        public JsonResult AddGroupFriend(Guid idgroup, Guid idfriend, int status)
        {
            //Guid groupid = new Guid(idgroup);
            //Guid friendid = new Guid(idfriend);
            if (SessionManager.CurrentUserID() == null) RedirectToRoute("Register_Index");

            Guid ownerid = new Guid(SessionManager.Get("UserID").ToString());
            Social.Entity.TikFriend.FriendInList friendinlistentity = new FriendInList();
            var friendlist = _friendlist.GetStringFriendList(ownerid);
            foreach (var friend in friendlist)
            {
                var friendinlist = _friendinlistsevrvice.GetByFriendListAndFriendId(friend.ID, idfriend);
                if (friendinlist.Count() > 0)
                {


                    var listID = friendinlist[0].FriendListID;
                    _friendinlistsevrvice.Delete(c => c.FriendListID == listID && c.FriendID == idfriend);
                    if (idgroup != new Guid("00000000-0000-0000-0000-000000000000"))
                    {
                        friendinlistentity.FriendID = idfriend;
                        friendinlistentity.FriendListID = idgroup;
                        friendinlistentity.ID = Guid.NewGuid();
                        if (status == 1)
                        {

                            friendinlistentity.Status = true;

                        }
                        else
                        {
                            friendinlistentity.Status = false;
                        }
                        _friendinlistsevrvice.Add(friendinlistentity);
                        return Json(friendinlistentity, JsonRequestBehavior.AllowGet);
                    }
                    else
                    {
                        return Json(friendinlistentity, JsonRequestBehavior.AllowGet);
                    }

                }
            }

            friendinlistentity.FriendID = idfriend;
            friendinlistentity.FriendListID = idgroup;
            friendinlistentity.ID = Guid.NewGuid();
            if (status == 1)
            {
                friendinlistentity.Status = true;
            }
            else
            {
                friendinlistentity.Status = false;
            }
            _friendinlistsevrvice.Add(friendinlistentity);

            return Json(friendinlistentity, JsonRequestBehavior.AllowGet);
        }

        public ActionResult TestTooltip()
        {
            return View();
        }

        public JsonResult YouGenaralDialog(Guid friend)
        {
            Guid ownerID = new Guid(SessionManager.Get("UserID").ToString());
            //add list bạn chung
            List<UserProfile> listuserfriend = new List<UserProfile>();

            // kiểm tra thằng đăng nhập có những bạn nào

            var ownerlistfriend = _userfriend.GetByOwnerID(ownerID);

            //kiểm tra bạn chung của thằng được so sánh

            foreach (var friend1 in ownerlistfriend)
            {
                Guid _idfriend = new Guid(friend1.ToString());
                var friendlistselect = _userfriend.GetByUserFriend(friend, _idfriend);
                if (friendlistselect.Count() > 0)
                {
                    var userprofile = _user.GetByID(_idfriend);
                    listuserfriend.Add(userprofile);

                }
            }

            return Json(listuserfriend, JsonRequestBehavior.AllowGet);
        }

        public JsonResult SaveGroupFriend(string value)
        {
            FriendList friendlist = new FriendList();
            if (SessionManager.Get("UserID") == null)
            {
                return Json(friendlist, JsonRequestBehavior.AllowGet);
            }
            if (value.Trim().Length < 2)
            {
                return Json(friendlist, JsonRequestBehavior.AllowGet);
            }
            else
            {

                System.Text.RegularExpressions.Regex.Replace(value.Trim(), "<[^>]*>", string.Empty);
                friendlist.ID = Guid.NewGuid();
                friendlist.OwnerID = new Guid(SessionManager.CurrentUserID().ToString());
                friendlist.CreatedDate = System.DateTime.Now;
                friendlist.UpdatedDate = System.DateTime.Now;
                friendlist.FriendListName = value;
                _friendlist.Add(friendlist);
            }
            return Json(friendlist, JsonRequestBehavior.AllowGet);
        }

        public ActionResult ListNameGroup()
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            int dem = 0;

            //khai báo lấy ra toàn bộ namegroup
            var listnamefriend = _friendlist.GetCountFriendGround_ByOwnerID(new Guid(SessionManager.CurrentUserID().ToString()));

            //lấy ra toàn id của nhóm 
            //var listIDGroup = _friendlist.GetByOwnerID(new Guid(SessionManager.CurrentUserID().ToString()));
            //lấy ra toàn bộ bạn thuộc nhóm
            foreach (var list1 in listnamefriend)
            {

                int listfriendGroup = _friendinlistsevrvice.GetByFriendListID(list1.ID, true);
                if (listfriendGroup > 0)
                {
                    var userfriend = _userfriend.GetByUserFriend(new Guid(SessionManager.CurrentUserID().ToString()), list1.ID);

                    dem += listfriendGroup;
                    list1.CountFriend = listfriendGroup;
                }

            }
            var countfriend = _userfriend.GetByOwnerID(new Guid(SessionManager.CurrentUserID().ToString())).Count();

            dem = countfriend - dem;
            ViewData["Dem"] = dem.ToString();

            //hè mè hiển thị nhóm bạn
            // ViewData["ListNameGroup"] = listnamefriend;
            return View(listnamefriend);
        }

        public bool DeleteGroup(string value)
        {
            if (!SessionManager.IsLoggedIn()) return false;
            Guid idgroup = new Guid(value);
            try
            {
                _friendinlistsevrvice.Delete(c => c.FriendListID == idgroup);
                _friendlist.Delete(c => c.ID == idgroup);
                return true;
            }
            catch
            {
                return false;
            }

            //delete


        }
        public JsonResult EditGroup(string value, string listID)
        {
            try
            {
                if (value.Trim().Length < 2)
                {
                    return Json(new FriendList(), JsonRequestBehavior.AllowGet);
                }
                System.Text.RegularExpressions.Regex.Replace(value.Trim(), "<[^>]*>", string.Empty);
                Guid ownerID = new Guid(SessionManager.CurrentUserID().ToString());
                Guid Id = new Guid(listID);
                var _friendlistentity = _friendlist.Single(p => p.ID == Id);
                _friendlistentity.OwnerID = ownerID;
                _friendlistentity.FriendListName = value.Trim();
                _friendlistentity.CreatedDate = System.DateTime.Now;
                _friendlistentity.UpdatedDate = System.DateTime.Now;
                _friendlist.Update(_friendlistentity);
                return Json(_friendlistentity, JsonRequestBehavior.AllowGet);

            }
            catch
            {
                return Json(new FriendList(), JsonRequestBehavior.AllowGet);
            }

        }


        //xóa gửi yêu cầu kết bạn

        public bool DeleteWriteRequestFriend(string id, string friendid)
        {

            try
            {
                Guid _id = new Guid(id);
                Guid _friendid = new Guid(friendid);
                var _friendListGuiD = _friendlist.GetStringFriendList(new Guid(SessionManager.CurrentUserID().ToString()));
                foreach (var _friend0 in _friendListGuiD)
                {
                    Guid _listID = _friend0.ID;
                    _friendinlistsevrvice.Delete(c => c.FriendListID == _listID && c.FriendID == _friendid);
                }
                _friend.Delete(c => c.ID == _id);
                return true;
            }
            catch
            {
                return false;
            }


        }
        public string DeleteRequestInLeftColumn(Guid id)
        {
            try {
                Guid ownerID=SessionManager.CurrentUserID();
                var _listfriendlist = _friendlist.GetByListID(ownerID);
                try
                {
                    foreach (var list in _listfriendlist)
                    {
                        _friendinlistsevrvice.Delete(c => c.FriendListID == list && c.FriendID == id);
                    }
                }
                catch { }

                var _friendrequestinleft = _friend.GetByID(id);
                    Guid fromUserID = _friendrequestinleft.FromUserID;
                    Guid toUserID = _friendrequestinleft.ToUserID;
                    _friend.Delete(c => c.ToUserID == toUserID && c.FromUserID == fromUserID);
                    return "<a style=\"position: absolute; right: -80px;top: -2px\" class=\"fl uiBtn Img friendbtn\" id=\"" + toUserID.ToString() + "\" href=\"#\"><span><i></i>Kết bạn</span></a><span id=\"displayrequestfriend\"></span>";
            }
            catch {
                return "";
            }
        }

        //hết xóa gửi yêu cầu




        public ActionResult WaitingFriend(int pId = 0)
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            try
            {
                Guid id = new Guid(SessionManager.Get("UserID").ToString());
                var ufr = _friend.GetByFromUserIDPage(id, pId, 10);

                foreach (var user in ufr)
                {

                    var listfriend0 = _user.GetByID(user.ToUserID);
                    user.ProfileLink = listfriend0.ProfileLink;
                    user.SmallAvatar = listfriend0.SmallAvatarUrl;
                    user.FullName = listfriend0.FullName;

                }
                ViewData["ViewListFriend"] = ufr;

                var listfriend = _friendlist.GetJoin(id);
                foreach (var fr in listfriend)
                {
                    var friendinlist = _friendinlistsevrvice.Single(u => u.FriendListID == fr.ID);

                    if (friendinlist != null)
                    {
                        fr.FriendID = friendinlist.FriendID;
                    }
                }
                ViewData["FriendList"] = listfriend;
                if (Request.IsAjaxRequest())
                    return PartialView("WaitingAjax", ufr);


                return View();
            }
            catch
            {
                return RedirectToAction("Index", "", new { area = "Register" });
            }

        }
        public bool CheckGroupListFriend(string value)
        {
            if (value.Trim().Length < 2) return false;
            var checkgroup = _friendlist.CheckFriendList(value.Trim(), new Guid(SessionManager.CurrentUserID().ToString()));
            if (checkgroup > 0)
                return true;
            else
                return false;
        }

        public ActionResult CheckFriendRequetAndUserFriend(string username)
        {
            Guid owrderId = Guid.Empty;
            Guid touserID = Guid.Empty;
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            owrderId = new Guid(SessionManager.CurrentUserID().ToString());
            if (string.IsNullOrEmpty(username))
            {
                username = SessionManager.CurrentUserUserName();
                owrderId = new Guid(SessionManager.CurrentUserID().ToString());
            }
            else
            {
                UserProfile userProfile = _user.GetUserByUsername(username);

                touserID = userProfile.ID;
                ViewData["FullNameFriend"] = userProfile.FullName;
            }

            var friendrequestview = _friend.GetByFromUserIDAndToUserID(owrderId, touserID);
            if (friendrequestview.Count() > 0)
            {
                var _userprofile1 = _user.GetByID(touserID);

                return PartialView("WaitingRequestFriend", _userprofile1);
            }
            var userfriend = _userfriend.GetCountByUserFriend(owrderId, touserID);
            if (userfriend > 0)
            {
                var _userprofile1 = _user.GetByID(touserID);
                return PartialView("CheckUserFriend", _userprofile1);
            }
            if (owrderId == touserID || touserID == new Guid("00000000-0000-0000-0000-000000000000"))
            {
                var _userprofile1 = _user.GetByID(owrderId);
                return PartialView("CheckUserFriend", _userprofile1);
            }
            if (_friend.GetByFromUserIDAndToUserID(touserID, owrderId).Count() > 0)
            {
                var _userprofile1 = _user.GetByID(touserID);
                return PartialView("_PageAgreeSuggest", _userprofile1);
            }
            var userprofile = _user.GetByID(touserID);
            return View(userprofile);





        }
        public ActionResult ResultSearchFull(string keyword,int pId=0)
        {
            ViewData["Keyword"] = keyword;
            var countlist = _usersearchservice.GetCountResultSearch(keyword);
            ViewData["CountList"] = countlist;
            var listusersearch = _usersearchservice.GetByFullTextSearch(keyword, pId, defaultPageSize);
            if (Request.IsAjaxRequest())
                return PartialView("_ResultPageSearch", listusersearch);
            return View(listusersearch);
            //return View();
        }

        public ActionResult _PageFriendPageLeft(string friendId)
        {
            Guid owrderId = Guid.Empty;
            Guid frID = new Guid(friendId);
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            owrderId = new Guid(SessionManager.CurrentUserID().ToString());
            var requestfrienddialogleft = _friend.GetByFromUserIDAndToUserID(owrderId, frID);
            var userprofile1 = _user.GetByID(frID);
            if (requestfrienddialogleft.Count() > 0)
            {
                //đang chờ kết bạn

                return PartialView("_Pagedialogwaitingrequest", userprofile1);
            }
            var rqfrienddialogleft = _friend.GetByFromUserIDAndToUserID(frID, owrderId);
            if (rqfrienddialogleft.Count() > 0)
            {
                //đồng ý kết bạn
                //var userprofile0 = _user.GetByID(frID);
                return PartialView("_pagedialogrequestuserfriend", userprofile1);
            }
            var _userfriendleftdialog = _userfriend.GetByUserFriend(owrderId, frID);
            if (_userfriendleftdialog.Count() > 0 || owrderId == frID)
            {

                return PartialView("_Pagedialogleftuserfirend");
            }

            return View(userprofile1);

        }
        public ActionResult InvitedFriend()
        {
            return View();
        }
        public ActionResult _confirmFriend(string username)
        {
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            Guid owrderId = SessionManager.CurrentUserID();
            Guid frID = Guid.Empty;
            
            if (!string.IsNullOrEmpty(username))
            {
                var _userprofileinfo = _user.GetUserByUsername(username);
                frID = _userprofileinfo.ID;
                var _checkuserfriend = _userfriend.GetByUserFriend(owrderId, frID);
                if (_checkuserfriend.Count() > 0)
                    ViewData["ConfirmFriend"] = "<a href=\"#\" id=\"confirmcancelfriend\" class=\"" + _checkuserfriend[0].ID + "\" >Hủy kết bạn</a>";
                var _checkuserrequest = _friend.GetByFromUserIDAndToUserID(owrderId, frID);
                if (_checkuserrequest.Count() > 0)
                    ViewData["ConfirmFriend"] = "<a href=\"#\" id=\"confirmrequestfriend\" class=\"" + _checkuserrequest[0].ID + "\">Hủy lời mời kết bạn</a>";
                        
            }
            return View();


        
        }

        public string DeleteFriendInLeft(Guid id)
        {
            try
            {
                var _userfriendleft = _userfriend.GetByID(id);
                Guid fromUser = _userfriendleft.OwnerID;
                Guid toUser = _userfriendleft.FriendID;
                _userfriend.Delete(c => c.OwnerID == fromUser && c.FriendID == toUser);
                _userfriend.Delete(c => c.OwnerID == toUser && c.FriendID == fromUser);
                _friendsearchservice.Delete(c => c.OwnerID == fromUser && c.FriendID == toUser);
                _friendsearchservice.Delete(c => c.OwnerID == toUser && c.FriendID == fromUser);
                return "<a style=\"position: absolute; right: -80px;top: -2px\" class=\"fl uiBtn Img friendbtn\" id=\"" + toUser.ToString() + "\" href=\"#\"><span><i></i>Kết bạn</span></a><span id=\"displayrequestfriend\"></span>";

            }
            catch {
                return "";
            }
        
        
        }
        public JsonResult RequestInsertTop(Guid friendid)
        {
            FriendRequest _frq = new FriendRequest();
            try
            {
                Guid ownerID = SessionManager.CurrentUserID();
                if (_friend.GetCountByFromUserIDAndToUserID(ownerID, friendid) > 0)
                {
                    return Json(new FriendList(), JsonRequestBehavior.AllowGet);
                }

                _frq.ID = Guid.NewGuid();
                _frq.CreatedDate = System.DateTime.Now;
                _frq.FromUserID = ownerID;
                _frq.ToUserID = friendid;
                _frq.UpdatedDate = System.DateTime.Now;
                _frq.Status = false;
                _frq.Message = "Kết bạn với mạng xã hội Tik.Vn";
                _friend.Add(_frq);
                return Json(_frq, JsonRequestBehavior.AllowGet);
            }
            catch {
                return Json(new FriendList(), JsonRequestBehavior.AllowGet);
            }
        
        }
        public ActionResult ClassMate()
        {
            return View();
        }


        //đay là kết bạn ở trang tìm kiếm

        public ActionResult CheckFriendSearch(string username)
        {
            Guid owrderId = Guid.Empty;
            Guid touserID = Guid.Empty;
            if (SessionManager.CurrentUserID() == null) return RedirectToRoute("Register_Index");
            owrderId = new Guid(SessionManager.CurrentUserID().ToString());
            if (string.IsNullOrEmpty(username))
            {
                username = SessionManager.CurrentUserUserName();
                owrderId = new Guid(SessionManager.CurrentUserID().ToString());
            }
            else
            {
                UserProfile userProfile = _user.GetUserByUsername(username);

                touserID = userProfile.ID;
                ViewData["FullNameFriend"] = userProfile.FullName;
            }

            var friendrequestview = _friend.GetByFromUserIDAndToUserID(owrderId, touserID);
            if (friendrequestview.Count() > 0)
            {
                var _userprofile1 = _user.GetByID(touserID);

                return PartialView("_searchwaitingrequest", _userprofile1);
            }
            var userfriend = _userfriend.GetCountByUserFriend(owrderId, touserID);
            if (userfriend > 0)
            {
                var _userprofile1 = _user.GetByID(touserID);
                return PartialView("_SearchCheckFriend", _userprofile1);
            }
            if (owrderId == touserID || touserID == new Guid("00000000-0000-0000-0000-000000000000"))
            {
                var _userprofile1 = _user.GetByID(owrderId);
                return PartialView("_SearchCheckFriend", _userprofile1);
            }
            if (_friend.GetByFromUserIDAndToUserID(touserID, owrderId).Count() > 0)
            {
                var _userprofile1 = _user.GetByID(touserID);
                return PartialView("_searchagree", _userprofile1);
            }
            var userprofile = _user.GetByID(touserID);
            return View(userprofile);

        }




        

    }
    



    public class UniversityObject
    {
        public string id { get; set; }
        public string name { get; set; }
        //public IList<UniversityObject> GetAll();
    }
    public class CompanyObject
    {
        public string id { get; set; }
        public string name { get; set; }
    }
    public class SchoolObject
    {
        public string id { get; set; }
        public string name { get; set; }
    }
}
