﻿using System.Web.Mvc;

namespace Social.Web.Areas.Friend
{
    public class FriendAreaRegistration : AreaRegistration
    {
        public override string AreaName
        {
            get
            {
                return "Friend";
            }
        }

        public override void RegisterArea(AreaRegistrationContext context)
        {

            context.MapRoute(
                "Friend_default",
                "Friend/Friend/{controller}/{action}/{id}",
                new { action = "Index", id = UrlParameter.Optional }

            );
            context.MapRoute(
                "Friend_Index",
                "Friend/Index",
                new { controller = "Friend", action = "Index", pId = UrlParameter.Optional }
            );
            context.MapRoute(
                "Friend_RequestListFriend",
                "Friend/RequestListFriend/{pId}",
                new { controller = "Friend", action = "RequestListFriend", pId = UrlParameter.Optional }
            );

            context.MapRoute(
                "Friend_ListFriendGroup",
                "Friend/ListFriendGroup/{pId}",
                new { controller = "Friend", action = "ListFriendGroup", pId = UrlParameter.Optional }
            );
            context.MapRoute(
                "Friend_FriendRandom",
                "Friend/FriendRandom",
                new { controller = "Friend", action = "FriendRandom", pId = UrlParameter.Optional }
            );
            context.MapRoute(
                "Friend_DeleteFriend",
                "Friend/DeleteFriend",
                new { controller = "Friend", action = "DeleteFriend", pId = UrlParameter.Optional }
            );
            context.MapRoute(
                "Friend_SendMailInviteFriend",
                "Friend/SendMailInviteFriend",
                new { controller = "Friend", action = "SendMailInviteFriend", pId = UrlParameter.Optional }
            );
            context.MapRoute(
                "Friend_TestPaging",
                "Friend/TestPaging",
                new { controller = "Friend", action = "TestPaging", pId = UrlParameter.Optional }
            );

            context.MapRoute(
                "Friend_AddGroupFriend",
                "Friend/AddGroupFriend",
                new { controller = "Friend", action = "AddGroupFriend", pId = UrlParameter.Optional }
            );
            context.MapRoute(
               "Friend_TestToolTip",
               "Friend/TestToolTip",
               new { controller = "Friend", action = "TestToolTip", pId = UrlParameter.Optional }
           );

            context.MapRoute(
               "Friend_YouGenaralDialog",
               "Friend/YouGenaralDialog",
               new { controller = "Friend", action = "YouGenaralDialog", pId = UrlParameter.Optional }
           );
            context.MapRoute(
               "Friend_SaveGroupFriend",
               "Friend/SaveGroupFriend",
               new { controller = "Friend", action = "SaveGroupFriend", pId = UrlParameter.Optional }
           );
            context.MapRoute(
               "Friend_DeleteGroup",
               "Friend/DeleteGroup",
               new { controller = "Friend", action = "DeleteGroup", pId = UrlParameter.Optional }
           );
            context.MapRoute(
               "Friend_WaitingFriend",
               "Friend/WaitingFriend",
               new { controller = "Friend", action = "WaitingFriend" }
           );
            context.MapRoute(
               "Friend_SelectGroupFriend",
               "Friend/SelectGroupFriend/{pId}",
               new { controller = "Friend", action = "SelectGroupFriend", pId = UrlParameter.Optional }
           );
            context.MapRoute(
               "Friend_EditGroup",
               "Friend/EditGroup",
               new { controller = "Friend", action = "EditGroup", pId = UrlParameter.Optional }
           );
            context.MapRoute(
              "Friend_DeleteWriteRequestFriend",
              "Friend/DeleteWriteRequestFriend",
              new { controller = "Friend", action = "DeleteWriteRequestFriend", pId = UrlParameter.Optional }
          );
            context.MapRoute(
               "Friend_CheckGroupListFriend",
               "Friend/CheckGroupListFriend",
               new { controller = "Friend", action = "CheckGroupListFriend", pId = UrlParameter.Optional }
           );
            context.MapRoute(
               "Friend_CheckFriendRequetAndUserFriend",
               "Friend/CheckFriendRequetAndUserFriend",
               new { controller = "Friend", action = "CheckFriendRequetAndUserFriend", pId = UrlParameter.Optional }
           );
            context.MapRoute(
              "Friend_ResultSearchFull",
              "Friend/ResultSearchFull/{keyword}/{pId}",
              new { controller = "Friend", action = "ResultSearchFull", keyword="", pId = UrlParameter.Optional }
          );
            context.MapRoute(
               "Friend__confirmFriend",
               "Friend/_confirmFriend",
               new { controller = "Friend", action = "_confirmFriend", pId = UrlParameter.Optional }
           );
            context.MapRoute(
               "Friend_DeleteRequestInLeftColumn",
               "Friend/DeleteRequestInLeftColumn",
               new { controller = "Friend", action = "DeleteRequestInLeftColumn", pId = UrlParameter.Optional }
           );
            context.MapRoute(
               "Friend_RequestInsertTop",
               "Friend/RequestInsertTop",
               new { controller = "Friend", action = "RequestInsertTop", pId = UrlParameter.Optional }
           );
            
           context.MapRoute(
               "Friend__ResultPageSearch",
               "Friend/_ResultPageSearch/{pId}",
               new { controller = "Friend", action = "_ResultPageSearch", pId = UrlParameter.Optional }
           );
            context.MapRoute(
               "Friend_ClassMate",
               "Friend/ClassMate",
               new { controller = "Friend", action = "ClassMate" }
           );
             context.MapRoute(
               "Friend_CheckFriendSearch",
               "Friend/CheckFriendSearch",
               new { controller = "Friend", action = "CheckFriendSearch" }
           );

             context.MapRoute(
                "Friend__searchagree",
                "Friend/_searchagree",
                new { controller = "Friend", action = "_searchagree" }
            );
             context.MapRoute(
                "Friend__searchwaitingrequest",
                "Friend/_searchwaitingrequest",
                new { controller = "Friend", action = "_searchwaitingrequest" }
            );
             context.MapRoute(
                "Friend__SearchCheckFriend",
                "Friend/_SearchCheckFriend",
                new { controller = "Friend", action = "_SearchCheckFriend" }
            );
            


            //đồng nghiệp
            context.MapRoute(
               "Colleagues_GetCompany",
               "Colleagues/GetCompany",
               new { controller = "Colleagues", action = "GetCompany" }
           );
            context.MapRoute(
              "Colleagues_GetByUserID",
              "Colleagues/GetByUserID",
              new { controller = "Colleagues", action = "GetByUserID" }
          );

            //cùng trường
            context.MapRoute(
               "Education_GetUniversity",
               "Education/GetUniversity",
               new { controller = "Education", action = "GetUniversity" }
           );
            context.MapRoute(
               "Education_GetByUserIDUniversity",
               "Education/GetByUserIDUniversity",
               new { controller = "Education", action = "GetByUserIDUniversity" }
           );

            context.MapRoute(
               "Education_GetHightShools",
               "Education/GetHightShools",
               new { controller = "Education", action = "GetHightShools" }
           );
            context.MapRoute(
               "Education_GetByUserShools",
               "Education/GetByUserShools",
               new { controller = "Education", action = "GetByUserShools" }
           );
             context.MapRoute(
               "Education_ResultSearch",
               "Education/ResultSearch",
               new { controller = "Education", action = "ResultSearch" }
           );
            context.MapRoute(
               "Education_ResultKeyword",
               "Education/ResultKeyword",
               new { controller = "Education", action = "ResultKeyword" }
           );
            context.MapRoute(
               "Education_ResultKeywordSchool",
               "Education/ResultKeywordSchool",
               new { controller = "Education", action = "ResultKeywordSchool" }
           );
            context.MapRoute(
               "Colleagues_Colleagues",
               "Colleagues/Colleagues",
               new { controller = "Colleagues", action = "Colleagues" }
           );
            context.MapRoute(
               "Colleagues_ResultKeyword",
               "Colleagues/ResultKeyword",
               new { controller = "Colleagues", action = "ResultKeyword" }
           );
            context.MapRoute(
               "Fellow_Index",
               "Fellow/Index",
               new { controller = "Fellow", action = "Index" }
           );
            context.MapRoute(
               "Fellow_ResultFellowCurrentAddress",
               "Fellow/ResultFellowCurrentAddress",
               new { controller = "Fellow", action = "ResultFellowCurrentAddress" }
           );
            context.MapRoute(
               "Fellow_ResultFellowHomeAddress",
               "Fellow/ResultFellowHomeAddress",
               new { controller = "Fellow", action = "ResultFellowHomeAddress" }
           );
            
            
            
            

        }
    }
}
