﻿using System.Web.Mvc;

namespace Social.Web.Areas.Message
{
    public class MessageAreaRegistration : AreaRegistration
    {
        public override string AreaName
        {
            get
            {
                return "Message";
            }
        }

        public override void RegisterArea(AreaRegistrationContext context)
        {
            context.MapRoute(
                "Message_default",
                "message",
                new { controller = "Index", action = "Index"}
            );
            context.MapRoute(
                "Message_query",
                "message/query/{query}",
                new { controller = "Index", action = "Index", query = UrlParameter.Optional }
            );
            context.MapRoute(
                "Message_mark",
                "message/mark",
                new { controller = "Index", action = "Mark" }
            );
            context.MapRoute(
                "Message_comment",
                "message/comment",
                new { controller = "Index", action = "Comment" }
            );
            context.MapRoute(
                "Message_read",
                "message/read/{id}",
                new { controller = "Index", action = "Read",id=UrlParameter.Optional }
            );
            context.MapRoute(
                "Message_delete",
                "message/delete/{id}",
                new { controller = "Index", action = "Delete", id = UrlParameter.Optional }
            );
            context.MapRoute(
                "Message_sent",
                "message/sent/{p}",
                new { controller = "Index", action = "Sent",p=UrlParameter.Optional }
            );
            context.MapRoute(
                "Message_add",
                "message/add",
                new { controller = "Index", action = "Add" }
            );
            

            context.MapRoute(
                "Message_page",
                "message/p/{p}",
                new { controller = "Index", action = "Index", p = UrlParameter.Optional }
            );
        }
    }
}
