﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Service.Interface.TikApplication;
using Social.Lib;
using Social.Service.Interface.Tik;
using Social.Entity.Tik;

namespace Social.Web.Areas.Note.Controllers
{
    public class ListController : Controller
    {
        //
        // GET: /Note/List/
        INoteService _note;
        IUserProfileService _user;

        public ListController(IUserProfileService user, INoteService note)
        {
            _note = note;
            _user = user;
        }

        public ActionResult Index(string username)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");

            int totalRow = 0;

            if (string.IsNullOrEmpty(username))
            {
                return View(_note.GetListNoteByUserIdAndPageNumber(SessionManager.CurrentUserID(), 1, 10, out totalRow));
            }

            UserProfile user = _user.GetUserByUsername(username);

            if (user == null) return RedirectToActionPermanent("NotFoundUser", "Error", new { area = "" });

            IList<Social.Entity.TikApplication.Note> listNote = _note.GetListNoteByUserIdAndPageNumber(user.ID, 1, 10, out totalRow);

            if (listNote == null) return View();

            return View(listNote);
        }

        public ActionResult NewNote(string username)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");

            if (string.IsNullOrEmpty(username))
            {
                return View(_note.GetListNoteByUserID(SessionManager.CurrentUserID()));
            }

            UserProfile user = _user.GetUserByUsername(username);

            if (user == null) return View();

            IList<Social.Entity.TikApplication.Note> listNewNote = _note.GetTopListNoteByUserID(user.ID);
            ViewData["ListNewNote"] = listNewNote;

            return View();
        }

        public ActionResult Tagged(string username)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");

            if (string.IsNullOrEmpty(username))
            {
                return View(_note.GetListNoteByUserID(SessionManager.CurrentUserID()));
            }

            UserProfile user = _user.GetUserByUsername(username);

            if (user == null) return RedirectToActionPermanent("NotFoundUser", "Error", new { area = "" });

            IList<Social.Entity.TikApplication.Note> listData = _note.GetListNoteTags(user.ID);

            return View(listData);
        }
    }
}
