﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Lib;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;
using Social.Service.Interface.TikApplication;
using System.Web.Script.Serialization;

namespace Social.Web.Areas.Note.Controllers
{
    public class SharedNoteController : Controller
    {
        //
        // GET: /Note/Shared/
        IUserProfileService _user;
        INoteService _note;

        public SharedNoteController(IUserProfileService user, INoteService note)
        {
            _user = user;
            _note = note;
        }

        public ActionResult _LeftColumn(string username = "")
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            if (string.IsNullOrEmpty(username))
            {
                username = SessionManager.CurrentUserUserName();
            }

            UserProfile userProfile = _user.GetUserByUsername(username);
            if (userProfile == null)
            {
                return RedirectToActionPermanent("NotFoundUser", "Error", new { area = "" });
            }

            ViewData["CurrentUserProfile"] = userProfile;

            return View();
        }

        public ActionResult _LeftColumnView(string username = "", string id = "")
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            if (string.IsNullOrEmpty(username))
            {
                username = SessionManager.CurrentUserUserName();
            }

            UserProfile userProfile = _user.GetUserByUsername(username);
            if (userProfile == null)
            {
                return RedirectToActionPermanent("NotFoundUser", "Error", new { area = "" });
            }

            ViewData["CurrentUserProfile"] = userProfile;

            if (!string.IsNullOrEmpty(id))
            {
                try
                {
                    Guid noteID = Guid.Parse(id);
                    Social.Entity.TikApplication.Note noteView = _note.GetNoteByID(noteID);
                    if (noteView != null)
                    {
                        ViewData["CurrentNote"] = noteView;

                        if(!string.IsNullOrEmpty(noteView.Tags))
                        {
                            var json_serializer = new JavaScriptSerializer();
                            List<FriendTag> friendTag = json_serializer.Deserialize<List<FriendTag>>(noteView.Tags);
                            ViewData["ListFriendTag"] = friendTag;
                        }
                    }
                }
                catch { ; }
            }

            return View();
        }

    }

    public class FriendTag
    {
        public Guid FriendID { get; set; }
        public string UserName { get; set; }
        public string FriendFullName { get; set; }
        public string AvatarSmall { get; set; }
    }
}
