﻿using System;
using System.ComponentModel.DataAnnotations;
using Social.Web.Properties;
using System.Web.Mvc;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using Social.Service.Interface.Tik;

namespace Social.Web.Areas.Note.Models
{
    [Serializable]
    public class NoteModel
    {
        public Guid ID { get; set; }
        public Guid UserID { get; set; }
        public String Title { get; set;}
        public String Body { get ; set ; }
        public String Tags { get; set; }
        public String Photo { get; set; }
        public String PhotoUrl { get; set; }
        public Byte PrivacyType { get; set; }
        public IEnumerable<SelectListItem> PrivacyTypes
        {
            get
            {
                List<SelectListItem> selectList = new List<SelectListItem>();
                selectList.Add(new SelectListItem { Value = "1", Text = "Tất cả mọi người", Selected = PrivacyType.ToString().Equals("1") });
                selectList.Add(new SelectListItem { Value = "2", Text = "Chỉ bạn bè", Selected = PrivacyType.ToString().Equals("2") });
                selectList.Add(new SelectListItem { Value = "3", Text = "Chỉ mình tôi", Selected = PrivacyType.ToString().Equals("3") });
                return selectList;
            }
        }
        public String PrivacyPeople { get; set; }
        public Byte Status { get; set; }
        public Int32 ViewCount { get; set; }
        public DateTime CreatedDate { get; set; }
        public DateTime ModifiedDate { get; set; }
        public Int32 LikeCount { get; set; }
        public Int32 CommentCount { get; set; }
        public Boolean IsUserLike { get; set; }
        public string SuggestionFriend { get; set; }
    }
}