﻿using System.Web.Mvc;
using System.Web.Routing;
using System.Web;

namespace Social.Web.Areas.Note
{
    public class NoteAreaRegistration : AreaRegistration
    {
        public override string AreaName
        {
            get
            {
                return "Note";
            }
        }

        public override void RegisterArea(AreaRegistrationContext context)
        {
            context.MapRoute(
                "Note_default",
                "Note/{controller}/{action}/{id}",
                new { action = "Index", id = UrlParameter.Optional }
            );
            context.MapRoute(
                "Note_with_username",
                "{username}/Note/{controller}/{action}/{id}",
                new { action = "Index", controller = "List", id = UrlParameter.Optional },
                new { username = new NotEqual("Ajax") }
            );
            context.MapRoute(
               "NoteView_with_username",
               "{username}/Note/{controller}/{id}",
               new { action = "Index", controller = "View", id = UrlParameter.Optional },
               new { username = new NotEqual("Ajax") }
           );
            context.MapRoute(
               "NoteView_without_username",
               "Note/{controller}/{id}",
               new { action = "Index", controller = "View", id = UrlParameter.Optional },
               new { username = new NotEqual("Ajax") }
           );
        }
    }

    public class NotEqual : IRouteConstraint
    {
        private string _match = string.Empty;

        public NotEqual(string match)
        {
            _match = match;
        }

        public bool Match(HttpContextBase httpContext, Route route, string parameterName, RouteValueDictionary values, RouteDirection routeDirection)
        {
            return string.Compare(values[parameterName].ToString(), _match, true) != 0;
        }

    }
}
