﻿using System.Web.Mvc;

namespace Social.Web.Areas.Photo
{
    public class PhotoAreaRegistration : AreaRegistration
    {
        public override string AreaName
        {
            get
            {
                return "Photo";
            }
        }

        public override void RegisterArea(AreaRegistrationContext context)
        {

            context.MapRoute(
                "Photo_EditAlbum",
                "{username}/Photo/EditAlbum/{abid}",
                new { controller = "Photo", action = "EditAlbum"}
            );

            context.MapRoute(
                "Photo_ListPhotoInAlbum",
                "{username}/Photo/ListPhotoInAlbum/{abid}",
                new { controller = "Photo", action = "ListPhotoInAlbum"}
            );

            context.MapRoute(
                "Photo_PhotoInfo",
                "Photo/PhotoInfo",
                new { controller = "Photo", action = "PhotoInfo", pId = UrlParameter.Optional }
            );

            context.MapRoute(
                "Photo_NextPhoto",
                "Photo/NextPhoto/{abId}/{pId}",
                new { controller = "Photo", action = "NextPhoto", abId = UrlParameter.Optional, pId = UrlParameter.Optional }
            );

            context.MapRoute(
                "Photo_PrevPhoto",
                "Photo/PrevPhoto/{abId}/{pId}",
                new { controller = "Photo", action = "PrevPhoto", abId = UrlParameter.Optional, pId = UrlParameter.Optional }
            );

            context.MapRoute(
                "Photo_Album_Detail",
                "Photo/AlbumDetail/{abId}",
                new { controller = "Photo", action = "AlbumDetail" }
            );

            context.MapRoute(
                "Photo_AlbumDetail",
                "{username}/Photo/AlbumDetail/{abId}/{pId}",
                new { controller = "Photo", action = "AlbumDetail"}
            );

            context.MapRoute(
                "Photo_ActionUploadPhotoAlbum",
                "Photo/ActionUploadPhotoAlbum",
                new { controller = "Photo", action = "ActionUploadPhotoAlbum", albumId = UrlParameter.Optional, isFirst = UrlParameter.Optional, isLatest = UrlParameter.Optional }
            );

            context.MapRoute(
                "Photo_CreateAlbum",
                "Photo/CreateAlbum",
                new { controller = "Photo", action = "CreateAlbum", id = UrlParameter.Optional }
            );

            context.MapRoute(
                "Photo_UploadPhotoAlbum",
                "{username}/Photo/UploadPhotoAlbum/{abid}",
                new { controller = "Photo", action = "UploadPhotoAlbum", abid = UrlParameter.Optional }
            );
               
            context.MapRoute(
                "Photo_ListAlbum",
                "{username}/Photo/ListAlbum", new { controller = "Photo", action = "ListAlbum", username = UrlParameter.Optional }
            );

            context.MapRoute(
                "Photo_Photo_Detail",
                "Photo/PhotoDetail/{pId}", new { controller = "Photo", action = "PhotoDetail" }
            );

            context.MapRoute(
               "Photo_PhotoDetail",
               "{username}/Photo/PhotoDetail/{pId}", new { controller = "Photo", action = "PhotoDetail"}
            );

            context.MapRoute(
                "Photo_default",
                "Photo", new { controller = "Photo", action = "Index" }
            );

            context.MapRoute(
                "Photo_default_with_UserName",
                "{username}/Photo", new { controller = "Photo", action = "Index"}
            );
        }
    }
}
