﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Mvc;
using Social.Entity;
using Social.Entity.Tik;
using Social.Lib;
using Social.Service;
using Social.Service.Interface.Tik;
using Social.Web.Extends.Helper;
using Google.GData.Contacts;
using Google.GData.Client;
using Google.GData.Extensions;
using Google.Contacts;
using System.Data;
using System.Collections;
using System.Configuration;
namespace Social.Web.Areas.Profile.Controllers
{
    public class InfoController : Controller
    {
        //
        // GET: /Cms/Info/
        IUserProfileService _user;
        IUserHobbyService _userHobby;
        IUserUniversityService _userUniversity;
        IUserSchoolService _userSchool;
        IUserCompanyService _userCompany;
        IUserContactService _userContact;

        public InfoController(IUserProfileService user)
        {
            _user = user;
        }

        public ActionResult Index(UserProfile user, string username)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            if (string.IsNullOrEmpty(username))
            {
                username = SessionManager.CurrentUserUserName();
            }

            user = _user.GetUserByUsername(username);
            Guid userID = user.ID;
            _userHobby = DependencyResolver.Current.GetService<IUserHobbyService>();
            ViewData["Hobby"] = _userHobby.Single(u => u.UserID == userID);

            _userUniversity = DependencyResolver.Current.GetService<IUserUniversityService>();
            ViewData["UserUniversity"] = _userUniversity.GetAll(u => u.UserID == userID);

            _userSchool = DependencyResolver.Current.GetService<IUserSchoolService>();
            ViewData["UserSchool"] = _userSchool.GetAll(u => u.UserID == userID);

            _userCompany = DependencyResolver.Current.GetService<IUserCompanyService>();
            ViewData["Company"] = _userCompany.GetAll(u => u.UserID == userID);

            _userContact = DependencyResolver.Current.GetService<IUserContactService>();
            ViewData["UserNickContact"] = _userContact.GetAll(u => u.UserID == userID && u.Service != "0") ;

            _userContact = DependencyResolver.Current.GetService<IUserContactService>();
            ViewData["UserWebContact"] = _userContact.GetAll(u => u.UserID == userID && u.Service == "0");

            return View(user);
        }

    }
}
