﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Mvc;
using Social.Entity;
using Social.Entity.Tik;
using Social.Lib;
using Social.Service;
using Social.Service.Interface.Tik;
using Social.Web.Extends.Helper;
using Google.GData.Contacts;
using Google.GData.Client;
using Google.GData.Extensions;
using Google.Contacts;
using System.Data;
using System.Collections;
using System.Configuration;

namespace Social.Web.Areas.Profile.Controllers
{
    public class UpdateController : Controller
    {
        //
        // GET: /Cms/Update/

        IUserProfileService _user;
        IUserHobbyService _userhobby;
        IUserUniversityService _userUniversity;
        IUserSchoolService _userSchool;
        IUserCompanyService _userCompany;
        IUserContactService _userContact;
        IUserFamilyService _userFamily;
        //
        // GET: /UserSchool/
        public UpdateController(IUserProfileService user, IUserHobbyService userhobby, IUserSchoolService userSchool, IUserUniversityService userUniversity, IUserCompanyService userCompany, IUserContactService userContact, IUserFamilyService userFamily)
        {
            _user = user;
            _userhobby = userhobby;
            _userSchool = userSchool;
            _userUniversity = userUniversity;
            _userCompany = userCompany;
            _userContact = userContact;
            _userFamily = userFamily;
        }

        #region Basic
        public ActionResult Basic(UserProfile user)
        {
            if (TempData["error"] != null)
            {
                string err = TempData["error"].ToString();
                if (!string.IsNullOrEmpty(err))
                {
                    ViewData["ErrorMessage"] = err;
                }
            }
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            user = _user.Single(u => u.ID == userID);

            int nam = System.DateTime.Now.Year;
            int namold = System.DateTime.Now.AddYears(-120).Year;
            Dictionary<string, string> monthList = new Dictionary<string, string>();
            monthList.Add("0", "Tháng:");
            for (int i = 1; i <= 12; i++)
            {
                monthList.Add(i.ToString(), "Tháng " + i.ToString());
            }
            ViewBag.MonthList = monthList.Select(x => new SelectListItem
            {
                Text = x.Value,
                Value = x.Key,
                Selected = x.Key.Equals(user.BirthDay.Month.ToString())
            }).ToList();

            Dictionary<string, string> dayList = new Dictionary<string, string>();
            dayList.Add("0", "Ngày:");
            for (int i = 1; i <= 31; i++)
            {
                dayList.Add(i.ToString(), i.ToString());
            }
            ViewData["DayList"] = dayList.Select(x => new SelectListItem
            {
                Text = x.Value,
                Value = x.Key,
                Selected = x.Key.Equals(user.BirthDay.Day.ToString())
            }).ToList();

            Dictionary<string, string> yearList = new Dictionary<string, string>();
            yearList.Add("0", "Năm");
            for (int i = nam; i >= namold; i--)
            {
                yearList.Add(i.ToString(), i.ToString());
            }
            ViewData["YearList"] = yearList.Select(x => new SelectListItem
            {
                Text = x.Value,
                Value = x.Key,
                Selected = x.Key.Equals(user.BirthDay.Year.ToString())
            }).ToList();

            Dictionary<string, string> genderList = new Dictionary<string, string>();
            genderList.Add("0", "Chọn giới tính");
            genderList.Add("1", "Nam");
            genderList.Add("2", "Nữ");
            ViewData["GenderList"] = genderList.Select(x => new SelectListItem
            {
                Text = x.Value,
                Value = x.Key,
                Selected = x.Key.Equals(user.Gender.ToString())
            }).ToList();

            ViewData["InterestedIn"] = string.IsNullOrEmpty(user.InterestedIn) ? null : user.InterestedIn.Split(';').ToList<string>();

            return View(user);
        }

        [HttpPost]
        public ActionResult UpdateBasic(string DayList, string MonthList, string YearList, string GenderList, string[] chb_lookingfor, UserProfile user, string currrent_province_id, string currrent_province_name, string home_province_id, string home_province_name)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            UserProfile userEdit = _user.Single(u => u.ID == userID);

            System.Text.StringBuilder interested = new System.Text.StringBuilder();

            if (chb_lookingfor != null)
            {
                foreach (string item in chb_lookingfor)
                {
                    if (!item.Equals("true") && !item.Equals("false"))
                    {
                        interested.AppendFormat("; {0}", item);
                    }
                }
            }

            userEdit.FirstName = user.FirstName;
            userEdit.LastName = user.LastName;
            try
            {
                userEdit.BirthDay = new DateTime(int.Parse(YearList), int.Parse(MonthList), int.Parse(DayList));
            }
            catch
            {
                TempData["error"] = "Ngày sinh không đúng định dạng."; ;
            }

            userEdit.Gender = byte.Parse(GenderList);
            userEdit.InterestedIn = String.IsNullOrEmpty(interested.ToString()) ? string.Empty : interested.ToString().Remove(0, 2);

            if (!string.IsNullOrEmpty(currrent_province_id) && !string.IsNullOrEmpty(currrent_province_name))
            {
                userEdit.CurrentAddress = string.Format("{{ID:'{0}',Name:'{1}'}}", currrent_province_id, currrent_province_name);
            }

            if (!string.IsNullOrEmpty(home_province_id) && !string.IsNullOrEmpty(home_province_name))
            {
                userEdit.HomeAddress = string.Format("{{ID:'{0}',Name:'{1}'}}", home_province_id, home_province_name);
            }
            try
            {
                _user.Update(userEdit);
                Social.Lib.SessionManager.UpdateFullName(string.Format("{0} {1}", user.FirstName, user.LastName));
                TempData["error"] = "Bạn đã cập nhật thành công";
            }
            catch
            {
                TempData["error"] = "Quá trình cập nhật không thành công. Bạn thử lại sau ít phút";
            }

            return RedirectToAction("Basic");
        }
        #endregion

        #region University
        public ActionResult University()
        {
            if (TempData["error"] != null)
            {
                string err = TempData["error"].ToString();
                if (!string.IsNullOrEmpty(err))
                {
                    ViewData["ErrorMessage"] = err;
                }
            }

            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();

            Dictionary<string, string> yearList = new Dictionary<string, string>();
            yearList.Add("0", "Năm");
            int nam = System.DateTime.Now.Year;
            int namold = System.DateTime.Now.AddYears(-120).Year;
            for (int i = namold; i <= nam; i++)
            {
                yearList.Add(i.ToString(), i.ToString());
            }

            IList<UserSchool> userSchoolList = _userSchool.GetAll(u => u.UserID == userID);
            if (userSchoolList != null)
            {
                ViewData["UserSchoolList"] = userSchoolList;
                int countSchool = 0;
                foreach (UserSchool item in userSchoolList)
                {
                    ViewData[string.Format("high_school_year_{0}", countSchool)] = yearList.Select(x => new SelectListItem
                    {
                        Text = x.Value,
                        Value = x.Key,
                        Selected = x.Key.Equals(item.ClassYear.ToString())
                    }).ToList();
                    countSchool++;
                }
            }

            IList<UserUniversity> userUniversityList = _userUniversity.GetAll(u => u.UserID == userID);
            if (userUniversityList != null)
            {
                ViewData["UserUniversityList"] = userUniversityList;
                int count = 0;
                foreach (UserUniversity item in userUniversityList)
                {
                    ViewData[string.Format("university_year_{0}", count)] = yearList.Select(x => new SelectListItem
                    {
                        Text = x.Value,
                        Value = x.Key,
                        Selected = x.Key.Equals(item.ClassYear.ToString())
                    }).ToList();
                    count++;
                }
            }

            Dictionary<string, string> monthList = new Dictionary<string, string>();
            monthList.Add("0", "Tháng:");
            for (int i = 1; i <= 12; i++)
            {
                monthList.Add(i.ToString(), "Tháng " + i.ToString());
            }

            Dictionary<string, string> positionList = new Dictionary<string, string>();
            positionList.Add("", "Chọn vị trí");
            positionList.Add("{ID:'1',Name:'Nhân viên'}", "Nhân viên");
            positionList.Add("{ID:'2',Name:'Kỹ sư'}", "Kỹ sư");
            positionList.Add("{ID:'3',Name:'Phó phòng'}", "Phó phòng");
            positionList.Add("{ID:'4',Name:'Trưởng phòng'}", "Trưởng phòng");
            positionList.Add("{ID:'5',Name:'Cố vấn/Giám sát'}", "Cố vấn/Giám sát");
            positionList.Add("{ID:'6',Name:'Phó giám đốc/Phó tổng giám đốc'}", "Phó giám đốc/Phó tổng giám đốc");
            positionList.Add("{ID:'7',Name:'Giám đốc/Tổng giám đốc'}", "Giám đốc/Tổng giám đốc");
            positionList.Add("{ID:'8',Name:'Khác'}", "Khác");

            IList<UserCompany> userCompanyList = _userCompany.GetAll(u => u.UserID == userID);
            if (userCompanyList != null)
            {
                ViewData["UserCompanyList"] = userCompanyList;
                int count = 0;
                foreach (UserCompany item in userCompanyList)
                {
                    ViewData[string.Format("company_from_month_{0}", count)] = monthList.Select(x => new SelectListItem
                    {
                        Text = x.Value,
                        Value = x.Key,
                        Selected = x.Key.Equals(item.FromMonth.ToString())
                    }).ToList();

                    ViewData[string.Format("company_to_month_{0}", count)] = monthList.Select(x => new SelectListItem
                    {
                        Text = x.Value,
                        Value = x.Key,
                        Selected = x.Key.Equals(item.ToMonth.ToString())
                    }).ToList();

                    ViewData[string.Format("company_from_year_{0}", count)] = yearList.Select(x => new SelectListItem
                    {
                        Text = x.Value,
                        Value = x.Key,
                        Selected = x.Key.Equals(item.FromYear.ToString())
                    }).ToList();

                    ViewData[string.Format("company_to_year_{0}", count)] = yearList.Select(x => new SelectListItem
                    {
                        Text = x.Value,
                        Value = x.Key,
                        Selected = x.Key.Equals(item.ToYear.ToString())
                    }).ToList();

                    ViewData[string.Format("company_position_{0}", count)] = positionList.Select(x => new SelectListItem
                    {
                        Text = x.Value,
                        Value = x.Key,
                        Selected = x.Key.Equals(item.Position)
                    }).ToList();
                    count++;
                }
            }

            return View();
        }

        [HttpPost]
        public ActionResult UpdateUniversity(string[] high_school_name, string[] high_school_id, string[] high_school_year, string[] high_school_GuidID, string listSchoolDelete,
                                                string[] university_name, string[] university_id, string[] university_year, string[] university_GuidID, string listUniversityDelete,
                                                string[] company_name, string[] company_id, string[] company_GuidID, string[] company_job, string[] company_from_month, string[] company_from_year, string[] company_to_month, string[] company_to_year, string[] company_position, string[] location_name, string[] company_locationID, string[] company_description, string listCompanyDelete)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();

            #region Update high school
            if (!string.IsNullOrEmpty(listSchoolDelete))
            {
                foreach (string item in listSchoolDelete.Split(','))
                {
                    if (!string.IsNullOrEmpty(item))
                    {
                        Guid guidDelete = Guid.Parse(item);
                        _userSchool.Delete(u => u.ID == guidDelete);
                    }
                }
            }

            if (high_school_GuidID != null)
            {
                for (int i = 0; i < high_school_GuidID.Length; i++)
                {
                    if (string.IsNullOrEmpty(high_school_GuidID[i]))
                    {
                        if (!string.IsNullOrEmpty(high_school_name[i]))
                        {
                            UserSchool userSchool = new UserSchool();
                            userSchool.ID = Guid.NewGuid();
                            userSchool.UserID = userID;
                            userSchool.School = string.Format("{{ID:'{0}',Name:'{1}'}}", high_school_id[i], high_school_name[i]);//{id:20292-2290290912-2902020,name='Truwowng dai hoc mo'}
                            userSchool.ClassYear = Convert.ToInt16(high_school_year[i]);
                            _userSchool.Add(userSchool);
                        }
                    }
                    else
                    {

                        Guid guidSchool = Guid.Parse(high_school_GuidID[i]);
                        UserSchool userSchool = _userSchool.Single(u => u.ID == guidSchool);
                        userSchool.School = string.Format("{{ID:'{0}',Name:'{1}'}}", high_school_id[i], high_school_name[i]);
                        userSchool.ClassYear = Convert.ToInt16(high_school_year[i]);
                        _userSchool.Update(userSchool);
                    }
                }
            }
            #endregion

            #region Update university
            if (!string.IsNullOrEmpty(listUniversityDelete))
            {
                foreach (string item in listUniversityDelete.Split(','))
                {
                    if (!string.IsNullOrEmpty(item))
                    {
                        Guid guidDelete = Guid.Parse(item);
                        _userUniversity.Delete(u => u.ID == guidDelete);
                    }
                }
            }

            if (university_GuidID != null)
            {
                for (int i = 0; i < university_GuidID.Length; i++)
                {
                    if (string.IsNullOrEmpty(university_GuidID[i]))
                    {
                        if (!string.IsNullOrEmpty(university_name[i]))
                        {
                            UserUniversity userUniversity = new UserUniversity();
                            userUniversity.ID = Guid.NewGuid();
                            userUniversity.UserID = userID;
                            userUniversity.University = string.Format("{{ID:'{0}',Name:'{1}'}}", university_id[i], university_name[i]);//{id:20292-2290290912-2902020,name='Truwowng dai hoc mo'}
                            userUniversity.ClassYear = Convert.ToInt16(university_year[i]);
                            _userUniversity.Add(userUniversity);
                        }
                    }
                    else
                    {
                        Guid guidUniversity = Guid.Parse(university_GuidID[i]);
                        UserUniversity userUniversity = _userUniversity.Single(u => u.ID == guidUniversity);
                        userUniversity.University = string.Format("{{ID:'{0}',Name:'{1}'}}", university_id[i], university_name[i]);
                        userUniversity.ClassYear = Convert.ToInt16(university_year[i]);
                        _userUniversity.Update(userUniversity);
                    }
                }
            }
            #endregion

            #region Update Company
            if (!string.IsNullOrEmpty(listCompanyDelete))
            {
                foreach (string item in listCompanyDelete.Split(','))
                {
                    if (!string.IsNullOrEmpty(item))
                    {
                        Guid guidDelete = Guid.Parse(item);
                        _userCompany.Delete(u => u.ID == guidDelete);
                    }
                }
            }

            if (company_GuidID != null)
            {
                for (int i = 0; i < company_GuidID.Length; i++)
                {
                    if (string.IsNullOrEmpty(company_GuidID[i].Trim()))
                    {
                        if (!string.IsNullOrEmpty(company_name[i]))
                        {
                            UserCompany userCompany = new UserCompany();
                            userCompany.ID = Guid.NewGuid();
                            userCompany.UserID = userID;
                            userCompany.Company = string.Format("{{ID:'{0}',Name:'{1}'}}", company_id[i], company_name[i]);//{id:20292-2290290912-2902020,name='Truwowng dai hoc mo'}
                            userCompany.Job = company_job[i];
                            userCompany.Position = company_position[i];
                            userCompany.City = string.Format("{{ID:'{0}',Name:'{1}'}}", company_locationID[i], location_name[i]);
                            userCompany.Description = company_description[i];
                            if (!string.IsNullOrEmpty(company_from_month[i].Trim()))
                                userCompany.FromMonth = Convert.ToInt16(company_from_month[i]);

                            if (!string.IsNullOrEmpty(company_from_year[i].Trim()))
                                userCompany.FromYear = Convert.ToInt16(company_from_year[i]);

                            if (!string.IsNullOrEmpty(company_to_month[i].Trim()))
                                userCompany.ToMonth = Convert.ToInt16(company_to_month[i]);

                            if (!string.IsNullOrEmpty(company_to_year[i].Trim()))
                                userCompany.ToYear = Convert.ToInt16(company_to_year[i]);

                            _userCompany.Add(userCompany);
                        }
                    }
                    else
                    {
                        Guid guidCompany = Guid.Parse(company_GuidID[i]);
                        UserCompany userCompany = _userCompany.Single(u => u.ID == guidCompany);
                        userCompany.Company = string.Format("{{ID:'{0}',Name:'{1}'}}", company_id[i], company_name[i]);//{id:20292-2290290912-2902020,name='Truwowng dai hoc mo'}
                        userCompany.Job = company_job[i];
                        userCompany.Position = company_position[i];
                        userCompany.City = string.Format("{{ID:'{0}',Name:'{1}'}}", company_locationID[i], location_name[i]);
                        userCompany.Description = company_description[i];
                        if (!string.IsNullOrEmpty(company_from_month[i].Trim()))
                            userCompany.FromMonth = Convert.ToInt16(company_from_month[i]);

                        if (!string.IsNullOrEmpty(company_from_year[i].Trim()))
                            userCompany.FromYear = Convert.ToInt16(company_from_year[i]);

                        if (!string.IsNullOrEmpty(company_to_month[i].Trim()))
                            userCompany.ToMonth = Convert.ToInt16(company_to_month[i]);

                        if (!string.IsNullOrEmpty(company_to_year[i].Trim()))
                            userCompany.ToYear = Convert.ToInt16(company_to_year[i]);

                        _userCompany.Update(userCompany);
                    }
                }
            }
            #endregion

            TempData["error"] = "Cập nhật thành công";

            return RedirectToAction("University");
        }
        #endregion

        #region Favorite
        public ActionResult Favorite(UserHobby userhobby)
        {
            if (TempData["error"] != null)
            {
                string err = TempData["error"].ToString();
                if (!string.IsNullOrEmpty(err))
                {
                    ViewData["ErrorMessage"] = err;
                }
            }

            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            UserProfile user = _user.Single(u => u.ID == userID);
            if (user != null)
            {
                ViewData["FullName"] = string.Format("{0} {1}", user.FirstName, user.LastName);
            }

            userhobby = _userhobby.Single(u => u.UserID == userID);

            return View(userhobby);
        }

        [HttpPost]
        public ActionResult UpdateFavorite(UserHobby userHobby)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            UserHobby userHobbyEdit = _userhobby.Single(u => u.UserID == userID);
            if (userHobbyEdit != null)
            {
                userHobbyEdit.Book = userHobby.Book;
                userHobbyEdit.Game = userHobby.Game;
                userHobbyEdit.Movie = userHobby.Movie;
                userHobbyEdit.Music = userHobby.Music;
                userHobbyEdit.Other = userHobby.Other;
                userHobbyEdit.Sport = userHobby.Sport;

                try
                {
                    _userhobby.Update(userHobbyEdit);
                    TempData["error"] = "Bạn đã cập nhật thành công";
                }
                catch
                {
                    TempData["error"] = "Quá trình cập nhật không thành công. Bạn thử lại sau ít phút";
                }

                return RedirectToAction("Favorite");
            }

            userHobby.ID = Guid.NewGuid();
            userHobby.UserID = userID;
            try
            {
                _userhobby.Add(userHobby);
                TempData["error"] = "Bạn đã cập nhật thành công";
            }
            catch
            {
                TempData["error"] = "Quá trình cập nhật không thành công. Bạn thử lại sau ít phút";
            }

            return RedirectToAction("Favorite");
        }

        #endregion

        #region Contact
        public ActionResult Contact(UserProfile user)
        {
            if (TempData["error"] != null)
            {
                string err = TempData["error"].ToString();
                if (!string.IsNullOrEmpty(err))
                {
                    ViewData["ErrorMessage"] = err;
                }
            }

            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            user = _user.Single(u => u.ID == userID);

            IList<UserContact> userWebList = _userContact.GetAll(u => u.UserID == userID && u.Service == "0");
            if (userWebList != null)
            {
                ViewData["UserContactWebsite"] = userWebList;
            }

            IList<UserContact> userNickList = _userContact.GetAll(u => u.UserID == userID && u.Service != "0");
            if (userNickList != null)
            {
                ViewData["UserContactNick"] = userNickList;
            }

            return View(user);
        }

        [HttpPost]
        public ActionResult UpdateContact(string[] nicks, string[] nicks_Type, string[] nicks_GuidID, string listNickDelete, string[] webs, string[] webs_Type, string[] webs_GuidID, string listWebDelete, UserProfile user)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            UserProfile userEdit = _user.Single(u => u.ID == userID);

            userEdit.Mobile = user.Mobile;

            try
            {
                _user.Update(userEdit);
                TempData["error"] = "Bạn đã cập nhật thành công";
            }
            catch
            {
                TempData["error"] = "Quá trình cập nhật không thành công. Bạn thử lại sau ít phút";
            }

            if (!string.IsNullOrEmpty(listNickDelete))
            {
                foreach (string item in listNickDelete.Split(','))
                {
                    if (!string.IsNullOrEmpty(item))
                    {
                        Guid guidDelete = Guid.Parse(item);
                        _userContact.Delete(u => u.ID == guidDelete);
                    }
                }
            }

            if (nicks_GuidID != null)
            {
                for (int i = 0; i < nicks_GuidID.Length; i++)
                {
                    if (string.IsNullOrEmpty(nicks_GuidID[i].Trim()))
                    {
                        UserContact userContact = new UserContact();
                        userContact.ID = Guid.NewGuid();
                        userContact.UserID = userID;
                        userContact.NickName = nicks[i].ToString();
                        userContact.Service = nicks_Type[i].ToString();
                        _userContact.Add(userContact);
                    }
                    else
                    {
                        Guid guidNick = Guid.Parse(nicks_GuidID[i]);
                        UserContact userContact = _userContact.Single(u => u.ID == guidNick);
                        userContact.NickName = nicks[i].ToString();
                        userContact.Service = nicks_Type[i].ToString();
                        _userContact.Update(userContact);
                    }
                }
            }

            if (webs_GuidID != null)
            {
                for (int i = 0; i < webs_GuidID.Length; i++)
                {
                    if (string.IsNullOrEmpty(webs_GuidID[i].Trim()))
                    {
                        UserContact userContact = new UserContact();
                        userContact.ID = Guid.NewGuid();
                        userContact.UserID = userID;
                        userContact.NickName = webs[i].ToString();
                        userContact.Service = webs_Type[i].ToString();
                        _userContact.Add(userContact);
                    }
                    else
                    {
                        Guid guidNick = Guid.Parse(webs_GuidID[i]);
                        UserContact userContact = _userContact.Single(u => u.ID == guidNick);
                        userContact.NickName = webs[i].ToString();
                        userContact.Service = webs_Type[i].ToString();
                        _userContact.Update(userContact);
                    }
                }
            }

            return RedirectToAction("Contact");
        }
        #endregion

        #region Avatar
        public ActionResult Avatar(UserProfile user)
        {
            if (TempData["error"] != null)
            {
                string err = TempData["error"].ToString();
                if (!string.IsNullOrEmpty(err))
                {
                    ViewData["ErrorMessage"] = err;
                }
            }

            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            user = _user.Single(u => u.ID == userID);
            ViewData["LargeAvatar"] = string.IsNullOrEmpty(user.LargeAvatarUrl) ? ConfigurationManager.AppSettings["DefaultAvatar"] : Social.Lib.Utility.Utility.GetAvatarUrl(user.LargeAvatarUrl);
            return View(user);
        }

        #endregion

        #region Relationship
        public ActionResult Relationship()
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            UserProfile userProfile = _user.GetByID(userID);
            if (TempData["error"] != null)
            {
                string err = TempData["error"].ToString();
                if (!string.IsNullOrEmpty(err))
                {
                    ViewData["ErrorMessage"] = err;
                }
            }

            IList<UserFamily> listFamily = _userFamily.GetByUserID(userID);
            if (listFamily != null)
            {
                Dictionary<string, string> listFamilyType = new Dictionary<string, string>();
                if (userProfile.Gender.Equals(1))
                {
                    listFamilyType.Add("1", "Con trai");
                    listFamilyType.Add("2", "Cha");
                    listFamilyType.Add("3", "Anh trai");
                    listFamilyType.Add("4", "Em trai");
                    listFamilyType.Add("5", "Cậu - Chú - Bác");
                    listFamilyType.Add("6", "Cháu trai");
                }
                else
                {
                    listFamilyType.Add("7", "Con gái");
                    listFamilyType.Add("8", "Mẹ");
                    listFamilyType.Add("9", "Chị gái");
                    listFamilyType.Add("10", "Em gái");
                    listFamilyType.Add("11", "Cô dì");
                    listFamilyType.Add("12", "Cháu gái");
                }

                ViewData["UserFamily"] = listFamily;
                int countSchool = 0;
                foreach (UserFamily item in listFamily)
                {
                    ViewData[string.Format("userfamilyType_{0}", countSchool)] = listFamilyType.Select(x => new SelectListItem
                    {
                        Text = x.Value,
                        Value = x.Key,
                        Selected = x.Key.Equals(item.FamilyType.ToString())
                    }).ToList();
                    countSchool++;
                }
            }
            return View(userProfile);
        }

        [HttpPost]
        public ActionResult UpdateRelationship(string marrialUserid, string marrialName, string marrialAvatar, string relationshipType, string[] userfamily_fullname, string[] userfamily_id, string[] userfamily_avatar, string[] userFamilyType, string[] userfamily_name, string deleteUserFamily)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            try
            {
                UserProfile user = _user.GetByID(userID);
                user.MaritalStatus = byte.Parse(relationshipType);
                if (!string.IsNullOrEmpty(marrialUserid))
                {
                    string avatar = marrialAvatar.Replace(ConfigurationManager.AppSettings["AvatarServerUrl"], string.Empty);
                    user.MaritialWith = string.Format("{{FriendID:'{0}',FriendFullName:'{1}',FriendSmallAvatarUrl:'{2}'}}", marrialUserid, marrialName, marrialAvatar);
                }
                _user.Update(user);

                if (!string.IsNullOrEmpty(deleteUserFamily))
                {
                    foreach (string item in deleteUserFamily.Split(','))
                    {
                        if (!string.IsNullOrEmpty(item))
                        {
                            try
                            {
                                Guid guidDelete = Guid.Parse(item);
                                _userFamily.Delete(u => u.ID == guidDelete);
                            }
                            catch (Exception ex)
                            {
                                ;
                            }
                        }
                    }
                }

                if (userfamily_fullname != null)
                {
                    if (userfamily_fullname.Length > 0)
                    {
                        for (int i = 0; i < userfamily_fullname.Length; i++)
                        {
                            UserFamily userfamily = new UserFamily();
                            userfamily.ID = Guid.NewGuid();
                            userfamily.UserID = userID;
                            string userFamilyAvatar = userfamily_avatar[i].Replace(ConfigurationManager.AppSettings["AvatarServerUrl"], string.Empty);
                            userfamily.FamilyWith = string.Format("{{ID:'{0}',Name:'{1}',SmallAvatar:'{2}'}}",
                                                userfamily_id[i].Trim(),
                                                string.IsNullOrEmpty(userfamily_fullname[i].Trim()) ? userfamily_name[i] : userfamily_fullname[i],
                                                userfamily_avatar[i].Trim());
                            userfamily.Status = string.IsNullOrEmpty(userfamily_fullname[i].Trim()) ? byte.Parse("1") : byte.Parse("0");
                            userfamily.FamilyType = byte.Parse(userFamilyType[i]);
                            _userFamily.Add(userfamily);
                        }
                    }
                }

                TempData["error"] = "Bạn đã cập nhật thành công";
            }
            catch
            {
                TempData["error"] = "Quá trình cập nhật không thành công. Bạn thử lại sau ít phút";
            }

            return RedirectToAction("Relationship");
        }
        #endregion
    }
}
