﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Web.Mvc;
using Google.Contacts;
using Google.GData.Client;
using Google.GData.Extensions;
using Social.Entity;
using Social.Entity.Tik;
using Social.Lib;
using Social.Service.Interface.Tik;
using Social.Web.Areas.Register.Models;
using Social.Web.Extends.Helper;
using Social.Web.Extends.WebService;
using System.Linq;
using System.Text;

namespace Social.Web.Areas.Register.Controllers
{
    public class JoinController : Controller
    {
        //
        // GET: /Register/Join/
        IUserProfileService _user;
        IUserCompanyService _userCompany;
        IUserUniversityService _userUniversity;
        IUserSchoolService _userSchool;
        //
        // GET: /UserSchool/
        public JoinController(IUserProfileService user, IUserCompanyService userCompany, IUserUniversityService userUniversity, IUserSchoolService userSchool)
        {
            _user = user;
            _userCompany = userCompany;
            _userSchool = userSchool;
            _userUniversity = userUniversity;
        }

        public ActionResult Index(JoinIndexModel join)
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            UserProfile user = _user.Single(u=> u.ID == userID);
            join.ID = userID;
            join.CurrentAddress = user.CurrentAddress;

            UserUniversity userUniversity = _userUniversity.GetByUserID(userID);
            if (userUniversity != null)
            {
                join.UniveristyName = userUniversity.University;
                join.UniveristyYear = userUniversity.ClassYear;
                join.UserUniveristyGuid = userUniversity.ID;
            }

            UserSchool userSchool = _userSchool.GetUserSchooolByUserID(userID);
            if (userSchool != null)
            {
                join.SchoolName = userSchool.School;
                join.SchoolYear = userSchool.ClassYear;
                join.SchoolID = userSchool.ID;
            }

            UserCompany userCompany = _userCompany.GetUserCompanyByUserID(userID);
            if (userUniversity != null)
            {
                join.ComparyName = userCompany.Company;
                join.ComparyID = userCompany.ID;
            }
            return View(join);
        }

        public ActionResult Create(JoinIndexModel join)
        {
            UserProfile userProfile = new UserProfile();
            userProfile = _user.GetByID(join.ID);

            if (userProfile == null) return RedirectToRoute("Register_Index");
            userProfile.CurrentAddress = join.CurrentAddress;
            _user.Update(userProfile);

            UserSchool userSchool = new UserSchool();
            userSchool.ID = Guid.NewGuid();
            userSchool.UserID = join.ID;
            userSchool.School = string.Format("{{ID:'{0}',Name:'{1}'}}", join.SchoolID, join.SchoolName);//{id:20292-2290290912-2902020,name='Truwowng dai hoc mo'}
            userSchool.ClassYear = Convert.ToInt16(join.SchoolYear);
            _userSchool.Add(userSchool);

            UserUniversity userUniversity  = new UserUniversity();
            userUniversity.ID = Guid.NewGuid();
            userUniversity.UserID = join.ID;
            userUniversity.University = string.Format("{{ID:'{0}',Name:'{1}'}}", join.UniveristyID, join.UniveristyName);//{id:20292-2290290912-2902020,name='Truwowng dai hoc mo'}
            userUniversity.ClassYear = Convert.ToInt16(join.UniveristyYear);
            _userUniversity.Add(userUniversity);

            UserCompany userCompany = new UserCompany();
            userCompany.ID = Guid.NewGuid();
            userCompany.UserID = join.ID;
            userCompany.Company = string.Format("{{ID:'{0}',Name:'{1}'}}", join.ComparyID, join.ComparyName);//{id:20292-2290290912-2902020,name='Truwowng dai hoc mo'}
            userCompany.Job = string.Empty;
            _userCompany.Add(userCompany);

            return RedirectToAction("Index", "Avatar");
        }
    }
}
