﻿using System;
using System.ComponentModel.DataAnnotations;
using Social.Web.Properties;
using System.Web.Mvc;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
namespace Social.Web.Areas.Register.Models
{
    [Serializable]
    public class JoinIndexModel
    {
        //
        // GET: /Register/JoinIndexModel/
        public Guid ID { get; set; }

        public Guid UserSchoolGuid { get; set; }
        public string SchoolName { get; set; }
        public Guid SchoolID { get; set; }
        public int SchoolYear { get; set; }
        public IEnumerable<SelectListItem> SchoolYears
        {
            get
            {
                int currentYear = DateTime.Now.Year;
                List<SelectListItem> yearList = new List<SelectListItem>();
                yearList.Add(new SelectListItem { Value = "0", Text = "Năm:", Selected = true });
                for (int i = currentYear; i >= currentYear - 120; i--)
                {
                    yearList.Add(new SelectListItem { Text = i.ToString(), Value = i.ToString() });
                }
                return yearList;
            }
        }

        public Guid UserUniveristyGuid { get; set; }
        public string UniveristyName { get; set; }
        public Guid UniveristyID { get; set; }
        public int UniveristyYear { get; set; }
        public IEnumerable<SelectListItem> UniveristyYears
        {
            get
            {
                int currentYear = DateTime.Now.Year;
                List<SelectListItem> yearList = new List<SelectListItem>();
                yearList.Add(new SelectListItem { Value = "0", Text = "Năm:", Selected = true });
                for (int i = currentYear; i >= currentYear - 120; i--)
                {
                    yearList.Add(new SelectListItem { Text = i.ToString(), Value = i.ToString() });
                }
                return yearList;
            }
        }

        public Guid UserComparyGuid { get; set; }
        public string ComparyName { get; set; }
        public Guid ComparyID { get; set; }
        public int ComparyYear { get; set; }
        public IEnumerable<SelectListItem> ComparyYears
        {
            get
            {
                int currentYear = DateTime.Now.Year;
                List<SelectListItem> yearList = new List<SelectListItem>();
                yearList.Add(new SelectListItem { Value = "0", Text = "Năm:", Selected = true });
                for (int i = currentYear; i >= currentYear - 120; i--)
                {
                    yearList.Add(new SelectListItem { Text = i.ToString(), Value = i.ToString() });
                }
                return yearList;
            }
        }

        public string CurrentAddress { get; set; }
        public Guid CityID {get;set;}
    }
}
