﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Social.Web.Controllers
{
    public class ErrorController : Controller
    {
        //Custom errors
        public ActionResult NotFoundUser()
        {
            return View("NotFoundUser");
        }

        public ActionResult NotFoundPage()
        {
            return View("NotFoundPage");
        }

        public ActionResult NotPermission()
        {
            return View("NotPermission");
        }

        public ActionResult General(Exception exception)
        {
            ViewData["exception"] = exception;
            return View("Exception");
        }


        //Server Errors
        [PreventDirectAccess]
        public ActionResult ServerError()
        {
            return View("Error");
        }
        
        [PreventDirectAccess]
        public ActionResult AccessDenied()
        {
            return View("Error403");
        }

        public ActionResult NotFound()
        {
            return View("Error404");
        }

        private class PreventDirectAccessAttribute : FilterAttribute, IAuthorizationFilter
        {
            public void OnAuthorization(AuthorizationContext filterContext)
            {
                object value = filterContext.RouteData.Values["fromAppErrorEvent"];
                if (!(value is bool && (bool)value))
                    filterContext.Result = new ViewResult { ViewName = "Error404" };
            }
        }
    }
}
