﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Lib;
using Social.Web.Extends.Helper;
using Social.Entity.Tik;
using Social.Service.Interface.Tik;

namespace Social.Web.Controllers
{
    public class HomeController : Controller
    {

        IUserProfileService _userProfile;
        public HomeController(IUserProfileService userProfile)
        {
            _userProfile = userProfile;
        }
        public ActionResult Index()
        {
            try
            {
                if (Request.Cookies["REMEMBER_ME"] != null)
                {
                    string[] email_pass = Lib.Base64String.Decode(Request.Cookies["REMEMBER_ME"].Value).Split('|');
                    string email = email_pass[0];
                    string passwordHash = email_pass[1];

                    UserProfile user = _userProfile.Single(u => u.Password == passwordHash && u.Email == email && u.IsActive);
                    if (user != null)
                    {
                        SessionManager.Set("UserID", user.ID);
                        SessionManager.Set("UserName", user.UserName);
                        SessionManager.Set("FullName", user.FullName);
                        SessionManager.Set("Email", user.Email);
                        SessionManager.Set("SmallAvatarUrl", user.SmallAvatarUrl);
                        SessionManager.Set("MediumAvatarUrl", user.MediumAvatarUrl);
                        SessionManager.Set("ProfileLink", user.ProfileLink);
                    }
                }
            }
            catch (Exception ex)
            {
                LogHelper.Error("Check cookie remember",ex.Message);
            }
            if (!SessionManager.IsLoggedIn())
                return RedirectToRoute("Register_Index");
            return RedirectToRoute("Feed_Index");
        }

    }
}