﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Service.Interface.Tik;
using Social.Lib;
using Social.Entity.Tik;

namespace Social.Web.Controllers
{
    public class SharedController : Controller
    {
        //
        // GET: /Shared/
        IUserProfileService _user;

        public SharedController(IUserProfileService user)
        {
            _user = user;
        }

        public ActionResult _LeftColumn(string username="")
        {            
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            if (string.IsNullOrEmpty(username))
            {
                username = SessionManager.CurrentUserUserName();
            }
            
            UserProfile userProfile = _user.GetUserByUsername(username);
            if (userProfile == null)
            {
                return RedirectToActionPermanent("NotFoundUser", "Error", new { area = "" });
            }

            //Guid userID = SessionManager.CurrentUserID();
            //UserProfile user = _user.Single(u => u.ID == userID);

            //if (user == null) return RedirectToRoute("Register_Index");

            ViewData["CurrentUserProfile"] = userProfile;

            return View();
        }

        public ActionResult _LeftEditProfileColumn()
        {
            if (!SessionManager.IsLoggedIn()) return RedirectToRoute("Register_Index");
            Guid userID = SessionManager.CurrentUserID();
            UserProfile user = _user.Single(u => u.ID == userID);

            if (user == null) return RedirectToRoute("Register_Index");

            ViewData["CurrentUserProfile"] = user;

            return View();
        }

        public ActionResult _RightColumn()
        {
            return View();
        }
    }
}
