﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Web.Logging;
using Social.Lib;

namespace Social.Web.Extends.Helper
{
    public class LogHelper
    {
        static ILogger _log = DependencyResolver.Current.GetService<ILogger>();
        public static void Log(string message)
        {
            _log.Info(message);
        }
        public static void Log(string message, params object[] p)
        {
            _log.Info(string.Format(message, p));
        }
        public static void Log(Exception ex)
        {
            _log.Info(ex.Message);
        }
        public static void Error(string message)
        {
            _log.Error(message);
        }
        public static void Error(Exception ex)
        {
            _log.Error(ex.Message);
        }
        public static void Error(string message, params object[] p)
        {
            _log.Error(string.Format(message, p));
        }
        public static void Error(string action, string message)
        {
            try
            {
                _log.Error(string.Format("{0}/{1} {2} error:{3}", SessionManager.CurrentUserID(), SessionManager.CurrentUserFullName(), action, message));
            }
            catch { }
        }
    }
}