﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Google.GData.Client;
using Google.Contacts;
using Google.GData.Contacts;

namespace Social.Web.Extends.WebService
{
    public class GoogleService
    {
        #region Private Properties
        internal const string googleContactToken = "cp";
        internal const string googleCalendarToken = "cl";
        internal string _authSubToken;
        internal GAuthSubRequestFactory _gAuthSubRequestFactory;
        internal RequestSettings _requestSettings;
        internal ContactsRequest _contactsRequest;
        internal ContactsService _contactsService;
        #endregion

        internal GoogleService()
        {
            #if DEBUG
            _authSubToken = HttpContext.Current.Session["token"].ToString();
            _gAuthSubRequestFactory = new Google.GData.Client.GAuthSubRequestFactory(googleContactToken, "Tester1");
            _requestSettings = new Google.GData.Client.RequestSettings(_gAuthSubRequestFactory.ApplicationName, _authSubToken);
            _contactsRequest = new Google.Contacts.ContactsRequest(_requestSettings);
            _contactsService = new Google.GData.Contacts.ContactsService(_gAuthSubRequestFactory.ApplicationName);
            _contactsService.RequestFactory = _gAuthSubRequestFactory;
            #endif
        }
        public IEnumerable<String> GetContacts()
        {
            _requestSettings.AutoPaging = false;
            Feed<Contact> fg = _contactsRequest.GetContacts();
            return fg.Entries.Select(it => it.PrimaryEmail.Address);
        }
    }
}