﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Social.Web.Extends.Helper;
using Social.Web.vn.tik.id;
using System.Data;
using Social.Lib;

namespace Social.Web.Extends.WebService
{
    public class IDService
    {
        public class ServiceResult
        {
            public DataTable Customer { get; set; }
            public bool IsSuccess { get; set; }
            public string Message { get; set; }
            public ServiceResult()
            {
            }
            public ServiceResult(string message)
            {
                this.IsSuccess = false;
                this.Message = message;
            }
        }
        public static ServiceResult Login(string email, string password)
        {
            try
            {
                vn.tik.id.RegisterUser service = new vn.tik.id.RegisterUser();
                Result res = service.LoginTik(ConfigManager.GetKey("RegisterUser_Token"), email, password);
                ServiceResult sres = new ServiceResult();
                sres.Customer = res.Customer;
                sres.IsSuccess = res.IsSuccess;
                sres.Message = res.Message;
                LogHelper.Log("Goi webservice Login Tik voi cac tham so Email:{0}", email);
                return sres;
            }
            catch (Exception ex)
            {
                LogHelper.Error("Login with Tik ID",ex.Message);
                return new ServiceResult("Có lỗi khi đăng nhập với hệ thống ID");
            }
        }
        public static ServiceResult CheckEmailExist(string email)
        {
            try
            {
                vn.tik.id.RegisterUser service = new vn.tik.id.RegisterUser();
                Result res = service.IsEmail(email, ConfigManager.GetKey("RegisterUser_Token"));
                ServiceResult sres = new ServiceResult();
                sres.Customer = res.Customer;
                sres.IsSuccess = res.IsSuccess;
                sres.Message = res.Message;
                LogHelper.Log("Goi webservice Check Email voi cac tham so Email:{0}", email);
                return sres;
            }
            catch (Exception ex)
            {
                LogHelper.Error("Check Email with Tik ID", ex.Message);
                return new ServiceResult("Có lỗi khi kiểm tra email với hệ thống ID");
            }
        }
        public static ServiceResult RegisterUser(string email, string password, string firstName, string lastName, DateTime Birthday, byte Gender)
        {
            try
            {
                vn.tik.id.RegisterUser service = new vn.tik.id.RegisterUser();
                Result res = service.Register(ConfigManager.GetKey("RegisterUser_Token"), email, password, firstName, lastName, Birthday.ToString("dd/MM/yyyy"), Gender);
                ServiceResult sres = new ServiceResult();
                sres.Customer = res.Customer;
                sres.IsSuccess = res.IsSuccess;
                sres.Message = res.Message;
                LogHelper.Log("Goi webservice Register User voi cac tham so Email:{0};FirstName:{2},LastName:{3},BirthDay:{4},Gender:{5}",email,firstName,lastName,Birthday,Gender);
                return sres;
            }
            catch (Exception ex)
            {
                LogHelper.Error(ex);
                return new ServiceResult("Có lỗi khi đăng ký với hệ thống ID");
            }
        }
    }
}