﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Net;
using System.IO;
using System.Text;
using Social.Extends.OAuth;
using Social.Lib;
using Social.Web.Extends.Helper;
using System.Xml;

namespace Social.Web.Extends.WebService
{
    public class YahooService
    {
        public string ConsumerKey
        {
            get
            {
                return "dj0yJmk9WGVSU2tmckxwQlVoJmQ9WVdrOU5XRkpibVpuTm1zbWNHbzlNVEE0TkRNME1qQTJNZy0tJnM9Y29uc3VtZXJzZWNyZXQmeD02Ng--";
            }
        }
        public string ConsumerSecret
        {
            get
            {
                return "a5d78de87d1dea5c4d7bd503fbd2760130435d4c";
            }
        }
        public string OauthVerifier
        {
            get
            {
                try
                {
                    if (!string.IsNullOrEmpty(SessionManager.Get("Oauth_Verifier").ToString()))
                        return SessionManager.Get("Oauth_Verifier").ToString();
                    else
                        return string.Empty;
                }
                catch
                {
                    return string.Empty;
                }
            }
            set
            {
                SessionManager.Set("Oauth_Verifier", value);
            }
        }
        public string OauthToken
        {
            get
            {
                if (!string.IsNullOrEmpty(SessionManager.Get("Oauth_Token").ToString()))
                    return SessionManager.Get("Oauth_Token").ToString();
                else
                    return string.Empty;
            }
            set
            {
                SessionManager.Set("Oauth_Token",value);
            }
        }
        public string OauthTokenSecret
        {
            get
            {
                if (!string.IsNullOrEmpty(SessionManager.Get("Oauth_Token_Secret").ToString()))
                    return SessionManager.Get("Oauth_Token_Secret").ToString();
                else
                    return string.Empty;
            }
            set
            {
                SessionManager.Set("Oauth_Token_Secret", value);
            }
        }
        public string OauthSessionHandle
        {
            get
            {
                if (!string.IsNullOrEmpty(SessionManager.Get("Oauth_Session_Handle").ToString()))
                    return SessionManager.Get("Oauth_Session_Handle").ToString();
                else
                    return string.Empty;
            }
            set
            {
                SessionManager.Set("Oauth_Session_Handle",value);
            }
        }
        public string OauthYahooGuid
        {
            get
            {
                try
                {
                    if (!string.IsNullOrEmpty(SessionManager.Get("Oauth_Yahoo_Guid").ToString()))
                        return SessionManager.Get("Oauth_Yahoo_Guid").ToString();
                    else
                        return string.Empty;
                }
                catch
                {
                    return string.Empty;
                }
            }
            set
            {
                SessionManager.Set("Oauth_Yahoo_Guid",value);
            }
        }
        public string GetRequestToken()
        {
            string authorizationUrl = string.Empty;
            OAuthBase oauth = new OAuthBase();

            Uri uri = new Uri("https://api.login.yahoo.com/oauth/v2/get_request_token");
            string nonce = oauth.GenerateNonce();
            string timeStamp = oauth.GenerateTimeStamp();
            string normalizedUrl;
            string normalizedRequestParameters;
            string sig = oauth.GenerateSignature(uri, ConsumerKey, ConsumerSecret, string.Empty, string.Empty, "GET", timeStamp, nonce, OAuthBase.SignatureTypes.PLAINTEXT, out normalizedUrl, out normalizedRequestParameters); //OAuthBase.SignatureTypes.HMACSHA1
            StringBuilder sbRequestToken = new StringBuilder(uri.ToString());
            sbRequestToken.AppendFormat("?oauth_nonce={0}&", nonce);
            sbRequestToken.AppendFormat("oauth_timestamp={0}&", timeStamp);
            sbRequestToken.AppendFormat("oauth_consumer_key={0}&", ConsumerKey);
            sbRequestToken.AppendFormat("oauth_signature_method={0}&", "PLAINTEXT"); //HMAC-SHA1
            sbRequestToken.AppendFormat("oauth_signature={0}&", sig);
            sbRequestToken.AppendFormat("oauth_version={0}&", "1.0");
            sbRequestToken.AppendFormat("oauth_callback={0}", HttpUtility.UrlEncode("http://tik.vn/OAuth-yahoo/oauth-test.aspx"));
            try
            {
                string returnStr = string.Empty;
                string[] returnData;

                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(sbRequestToken.ToString());
                HttpWebResponse res = (HttpWebResponse)req.GetResponse();
                StreamReader streamReader = new StreamReader(res.GetResponseStream());
                returnStr = streamReader.ReadToEnd();
                returnData = returnStr.Split(new Char[] { '&' });
                int index;
                if (returnData.Length > 0)
                {
                    index = returnData[1].IndexOf("=");
                    string oauth_token_secret = returnData[1].Substring(index + 1);
                    OauthTokenSecret = oauth_token_secret;
                    index = returnData[3].IndexOf("=");
                    string oauth_request_auth_url = returnData[3].Substring(index + 1);
                    authorizationUrl = HttpUtility.UrlDecode(oauth_request_auth_url);
                }
            }
            catch (WebException ex)
            {
                LogHelper.Error("Yahoo import contact: "+ex.Message);
            }
            return authorizationUrl;
        }
        private void RedirectUserForAuthorization(string authorizationUrl)
        {
            //RegisterStartupScript("openwin", "<script type='text/javascript'>window.open('" + authorizationUrl + "','mywindow', 'left=250,top=50,menubar=0,resizable=0,location=1,toolbar=0,status=1,scrollbars=0,width=500,height=455');</script>");
        }
        public void GetAccessToken(string oauth_token, string oauth_verifier)
        {
            OAuthBase oauth = new OAuthBase();
            Uri uri = new Uri("https://api.login.yahoo.com/oauth/v2/get_token");
            string nonce = oauth.GenerateNonce();
            string timeStamp = oauth.GenerateTimeStamp();
            string sig = ConsumerSecret + "%26" + OauthTokenSecret;
            StringBuilder sbAccessToken = new StringBuilder(uri.ToString());
            sbAccessToken.AppendFormat("?oauth_consumer_key={0}&", ConsumerKey);
            sbAccessToken.AppendFormat("oauth_signature_method={0}&", "PLAINTEXT"); //HMAC-SHA1
            sbAccessToken.AppendFormat("oauth_signature={0}&", sig);
            sbAccessToken.AppendFormat("oauth_timestamp={0}&", timeStamp);
            sbAccessToken.AppendFormat("oauth_version={0}&", "1.0");
            sbAccessToken.AppendFormat("oauth_token={0}&", oauth_token);
            sbAccessToken.AppendFormat("oauth_nonce={0}&", nonce);
            sbAccessToken.AppendFormat("oauth_verifier={0}", oauth_verifier);
            
            try
            {
                string returnStr = string.Empty;
                string[] returnData;

                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(sbAccessToken.ToString());
                HttpWebResponse res = (HttpWebResponse)req.GetResponse();
                StreamReader streamReader = new StreamReader(res.GetResponseStream());
                returnStr = streamReader.ReadToEnd();
                returnData = returnStr.Split(new Char[] { '&' });              

                int index;
                if (returnData.Length > 0)
                {
                    index = returnData[0].IndexOf("=");
                    OauthToken = returnData[0].Substring(index + 1);

                    index = returnData[1].IndexOf("=");
                    string oauth_token_secret = returnData[1].Substring(index + 1);
                    OauthTokenSecret = oauth_token_secret;

                   index = returnData[3].IndexOf("=");
                    string oauth_session_handle = returnData[3].Substring(index + 1);
                    OauthSessionHandle = oauth_session_handle;
                    
                    index = returnData[5].IndexOf("=");
                    string xoauth_yahoo_guid = returnData[5].Substring(index + 1);
                    OauthYahooGuid = xoauth_yahoo_guid;
                }
            }
            catch (WebException ex)
            {
                LogHelper.Error("Yahoo import contact: " + ex.Message);
            }
        }
        private void RefreshToken()
        {
            OAuthBase oauth = new OAuthBase();
            Uri uri = new Uri("https://api.login.yahoo.com/oauth/v2/get_token");
            string nonce = oauth.GenerateNonce();
            string timeStamp = oauth.GenerateTimeStamp();
            string sig = ConsumerSecret + "%26" + OauthTokenSecret;
            StringBuilder sbrefreshToken = new StringBuilder(uri.ToString());
            sbrefreshToken.AppendFormat("?oauth_consumer_key={0}&", ConsumerKey);
            sbrefreshToken.AppendFormat("oauth_signature_method={0}&", "PLAINTEXT"); //HMAC-SHA1
            sbrefreshToken.AppendFormat("oauth_signature={0}&", sig);
            sbrefreshToken.AppendFormat("oauth_timestamp={0}&", timeStamp);
            sbrefreshToken.AppendFormat("oauth_version={0}&", "1.0");
            sbrefreshToken.AppendFormat("oauth_token={0}&", OauthToken);
            sbrefreshToken.AppendFormat("oauth_session_handle={0}&", OauthSessionHandle);
            sbrefreshToken.AppendFormat("oauth_nonce={0}", nonce);
            try
            {
                string returnStr = string.Empty;
                string[] returnData;

                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(sbrefreshToken.ToString());
                HttpWebResponse res = (HttpWebResponse)req.GetResponse();
                StreamReader streamReader = new StreamReader(res.GetResponseStream());
                returnStr = streamReader.ReadToEnd();
                returnData = returnStr.Split(new Char[] { '&' });

                int index;
                if (returnData.Length > 0)
                {
                    index = returnData[0].IndexOf("=");
                    string oauth_token = returnData[0].Substring(index + 1);
                    OauthToken = oauth_token;

                    index = returnData[1].IndexOf("=");
                    string oauth_token_secret = returnData[1].Substring(index + 1);
                    OauthTokenSecret = oauth_token_secret;
                    
                    index = returnData[3].IndexOf("=");
                    string oauth_session_handle = returnData[3].Substring(index + 1);
                    OauthSessionHandle = oauth_session_handle;
                    
                    index = returnData[5].IndexOf("=");
                    string xoauth_yahoo_guid = returnData[5].Substring(index + 1);
                    OauthYahooGuid = xoauth_yahoo_guid;
                }
            }
            catch (WebException ex)
            {
                LogHelper.Error("Yahoo import contact: " + ex.Message);
            }
        }
        public List<String> RetriveContacts()
        {
            OAuthBase oauth = new OAuthBase();
            Uri uri = new Uri("http://social.yahooapis.com/v1/user/" + OauthYahooGuid + "/contacts?format=XML");
            string nonce = oauth.GenerateNonce();
            string timeStamp = oauth.GenerateTimeStamp();
            string normalizedUrl;
            string normalizedRequestParameters;
            string sig = oauth.GenerateSignature(uri, ConsumerKey, ConsumerSecret, OauthToken, OauthTokenSecret, "GET", timeStamp, nonce, OAuthBase.SignatureTypes.HMACSHA1, out normalizedUrl, out normalizedRequestParameters);

            StringBuilder sbGetContacts = new StringBuilder(uri.ToString());

            try
            {
                string returnStr = string.Empty;
                HttpWebRequest req = (HttpWebRequest)WebRequest.Create(sbGetContacts.ToString());
                req.Method = "GET";

                string authHeader = "Authorization: OAuth " +
                "realm=\"yahooapis.com\"" +
                ",oauth_consumer_key=\"" + ConsumerKey + "\"" +
                ",oauth_nonce=\"" + nonce + "\"" +
                ",oauth_signature_method=\"HMAC-SHA1\"" +
                ",oauth_timestamp=\"" + timeStamp + "\"" +
                ",oauth_token=\"" + OauthToken + "\"" +
                ",oauth_version=\"1.0\"" +
                ",oauth_signature=\"" + HttpUtility.UrlEncode(sig) + "\"";

               req.Headers.Add(authHeader);

                HttpWebResponse res = (HttpWebResponse)req.GetResponse();
                StreamReader streamReader = new StreamReader(res.GetResponseStream());
                returnStr = streamReader.ReadToEnd();
                XmlDocument xmldoc = new XmlDocument();
                xmldoc.LoadXml(returnStr);
                XmlNodeList elemList = xmldoc.DocumentElement.GetElementsByTagName("fields");

                List<String> emails = new List<String>();
                for (int i = 0; i < elemList.Count; i++)
                {
                    if (elemList[i].ChildNodes[1].InnerText == "email")
                        emails.Add(elemList[i].ChildNodes[2].InnerText);
                    //Response.Write(elemList[i].ChildNodes[2].InnerText + "<br/>");
                }
                return emails;
            }
            catch (WebException ex)
            {
                LogHelper.Error("Yahoo import contact: " + ex.Message);
                return new List<string>();
            }
        }
    }
}