﻿using System;
using System.Web;
using System.Web.Mvc;
using System.Web.Routing;
using System.Web.Security;
using Social.DAL.Interface;
using Social.Entity.Tik;
using Social.Entity.TikFriend;
using Social.Service.Interface.Tik;
using Social.Service.Interface.TikActivity;
using Social.Service.Interface.TikApplication;
using Social.Service.Interface.TikCms;
using Social.Service.Interface.TikFriend;
using Social.Service.Interface.TikMessage;
using Social.Service.Interface.TikMusic;
using Social.Service.Interface.TikPhoto;
using Social.Web.Extends;
using Social.Web.Logging;
using StructureMap;
using Social.Lib;
using IAlbumService = Social.Service.Interface.TikPhoto.IAlbumService;
using Social.Service.TikMusic;

namespace Social.Web
{
    // Note: For instructions on enabling IIS6 or IIS7 classic mode, 
    // visit http://go.microsoft.com/?LinkId=9394801    
    public class MvcApplication : System.Web.HttpApplication
    {
        public static void RegisterGlobalFilters(GlobalFilterCollection filters)
        {
            filters.Add(new HandleErrorAttribute());
        }

        public static void RegisterRoutes(RouteCollection routes)
        {
            routes.IgnoreRoute("{resource}.axd/{*pathInfo}");
            routes.MapRoute(
                "Default", // Route name
                "{controller}/{action}/{id}", // URL with parameters
                new { controller = "Home", action = "Index", id = UrlParameter.Optional } // Parameter defaults
            );
        }

        protected void Session_Start(object sender, EventArgs e)
        {

            //Session["UserID"] = "536578af-73da-42b0-bb1f-4892581d5809";
            //SessionManager.Set("UserID", "536578af-73da-42b0-bb1f-4892581d5809");
            //Session["Email"] = "banhbonglan1000@yahoo.com";
            //Session["UserName"] = "banhbonglan1000";
            //Session["FullName"] = "Trương Đan Huy";

            //Session["FullName"] = "Tung Pro";

            //Session["UserID"] = "03cd37fb-a9ff-4f91-9b23-48188ddf7ce4";
            ////SessionManager.Set("UserID", "03CD37FB-A9FF-4F91-9B23-48188DDF7CE4");
            //Session["Email"] = "banhbonglan1000@yahoo.com";
            //Session["UserName"] = "banhbonglan1000";
            //Session["FullName"] = "Trương Đan Huy";

        }

        protected void Application_Start()
        {  
            AreaRegistration.RegisterAllAreas();
            RegisterGlobalFilters(GlobalFilters.Filters);
            RegisterRoutes(RouteTable.Routes);
            //Mapper
            AutoMapper.Mapper.CreateMap<FriendRequest, FriendRequestDTO>();
            //AutoMapper.Mapper.CreateMap<FriendRequest, FriendRequestDTO>().ToPagedList(pageIndex, pageSize);
            AutoMapper.Mapper.CreateMap<UserProfile, UserProfileAndCountUserFriend>();
            AutoMapper.Mapper.CreateMap<FriendList, FriendListJoinFriendInList>();
            //AutoMapper.Mapper.CreateMap<UserProfile, UserProfileRemoveVN>();
            AutoMapper.Mapper.CreateMap<FriendList, FriendListCountFriend>();
            AutoMapper.Mapper.CreateMap<FriendSearch, FriendSearchUserName>();
            //memcached
            Social.Lib.Memcached.MainCache = new Enyim.Caching.MemcachedClient();
            //Container Register
            IContainer container = new Container(x => {
                x.For<IControllerActivator>().Use<StructureMapControllerActivator>();
                x.For<ILogger>().Use<NLogLogger>();
                x.For<ITikRepository>().Use<Social.DAL.EF.TikRepository>();
                x.For<ITikActivityRepository>().Use<Social.DAL.EF.TikActivityRepository>();
                x.For<ITikCmsRepository>().Use<Social.DAL.EF.TikCmsRepository>();
                x.For<ITikFriendRepository>().Use<Social.DAL.EF.TikFriendRepository>();
                x.For<ITikApplicationRepository>().Use<Social.DAL.EF.TikApplicationRepository>();
                x.For<ITikMessageRepository>().Use<Social.DAL.EF.TikMessageRepository>();
                x.For<ITikPhotoRepository>().Use<Social.DAL.EF.TikPhotoRepository>();
                x.For<ITikMusicRepository>().Use<Social.DAL.EF.TikMusicRepository>();
                
                //
                x.For<IUniversityService>().Use<Social.Service.Tik.UniversityService>();
                x.For<ICompanyService>().Use<Social.Service.Tik.CompanyService>();
                x.For<IProvinceService>().Use<Social.Service.Tik.ProvinceService>();
                x.For<IUserSchoolService>().Use<Social.Service.Tik.UserSchoolService>();
                x.For<IStaticPageService>().Use<Social.Service.TikCms.StaticPageService>();
                x.For<IUserProfileService>().Use<Social.Service.Tik.UserProfileService>();
                x.For<IUserSearchService>().Use<Social.Service.Tik.UserSearchService>();
                x.For<IUserFamilyService>().Use<Social.Service.Tik.UserFamilyService>();
                x.For<IUserUniversityAndUserSearchService>().Use<Social.Service.Tik.UserUniversityAndUserSearchService>();
                x.For<IUserSchoolAndUserSearchService>().Use<Social.Service.Tik.UserSchoolAndUserSearchService>();
                x.For<IUserCompanyAndUserSearchService>().Use<Social.Service.Tik.UserCompanyAndUserSearchService>();
                x.For<IUserProfileAndUserSearchService>().Use<Social.Service.Tik.UserProfileAndUserSearchService>();
                
                
                //Photo
                x.For<IPhotoService>().Use<Social.Service.TikPhoto.PhotoService>();
                x.For<IAlbumService>().Use<Social.Service.TikPhoto.AlbumService>();
                x.For<IPhotoTagService>().Use<Social.Service.TikPhoto.PhotoTagService>();
                //Music
                x.For<ISongService>().Use<Social.Service.TikMusic.SongService>();
                x.For<Social.Service.Interface.TikMusic.IAlbumService>().Use<Social.Service.TikMusic.AlbumService>();
                x.For<ICategoryService>().Use<Social.Service.TikMusic.CategoryService>();
                x.For<ISongQueueService>().Use<Social.Service.TikMusic.SongQueueService>();
                
                x.For<IUserHobbyService>().Use<Social.Service.Tik.UserHobbyService>();
                //School
                x.For<ISchoolService>().Use<Social.Service.Tik.SchoolService>();
                x.For<IUserUniversityService>().Use<Social.Service.Tik.UserUniversityService>();
                x.For<IUserContactService>().Use<Social.Service.Tik.UserContactService>();
                x.For<IUserCompanyService>().Use<Social.Service.Tik.UserCompanyService>();
                x.For<IUserConfigService>().Use<Social.Service.Tik.UserConfigService>();
                //Friend
                x.For<IFriendRequestService>().Use<Social.Service.TikFriend.FriendRequestService>();
                x.For<IUserFriendService>().Use<Social.Service.TikFriend.UserFriendListService>();
                x.For<IFriendInListService>().Use<Social.Service.TikFriend.FriendInListService>();
                x.For<IFriendListService>().Use<Social.Service.TikFriend.FriendListService>();
                x.For<IFriendSearchService>().Use<Social.Service.TikFriend.FriendSearchService>();

                //TikActivity
                x.For<IUserNotificationService>().Use<Social.Service.TikActivity.UserNotificationService>();
                x.For<IUserActivityService>().Use<Social.Service.TikActivity.UserActivityService>();
                x.For<IUserFeedService>().Use<Social.Service.TikActivity.UserFeedService>();
                x.For<IUserCommentService>().Use<Social.Service.TikActivity.UserCommentService>();
                x.For<IUserLikeService>().Use<Social.Service.TikActivity.UserLikeService>();
                //TikApplication
                x.For<INoteService>().Use<Social.Service.TikApplication.NoteService>();
                //Tik Message
                x.For<IMessageService>().Use<Social.Service.TikMessage.MessageService>();
                x.For<IMessageCommentService>().Use<Social.Service.TikMessage.MessageCommentService>();
                x.For<IMessageRecipientService>().Use<Social.Service.TikMessage.MessageRecipientService>();
            });
            DependencyResolver.SetResolver(new StructureMapDependencyResolver(container));
        }

        //protected void Application_Error()
        //{
        //    var exception = Server.GetLastError();
        //    var httpException = exception as HttpException;

        //    Response.Clear();
        //    Server.ClearError();
        //    var routeData = new RouteData();
        //    routeData.Values["controller"] = "Error";
        //    routeData.Values["action"] = "General";
        //    routeData.Values["exception"] = exception;
        //    routeData.Values["fromAppErrorEvent"] = true;

        //    Response.StatusCode = 500;
        //    if (httpException != null)
        //    {
        //        Response.StatusCode = httpException.GetHttpCode();
        //        switch (Response.StatusCode)
        //        {
        //            case 403:
        //                routeData.Values["action"] = "AccessDenied";
        //                break;
        //            case 404:
        //                routeData.Values["action"] = "NotFound";
        //                break;
        //            case 500:
        //                routeData.Values["action"] = "ServerError";
        //                break;
        //        }
        //    }

        //    // Avoid IIS7 getting in the middle
        //    Response.TrySkipIisCustomErrors = true;
        //    IController errorsController = new ErrorController();
        //    errorsController.Execute(new RequestContext(new HttpContextWrapper(Context), routeData));
        //}


        void Application_BeginRequest(object sender, EventArgs e)
        {
            /* Fix for the Flash Player Cookie bug in Non-IE browsers.
             * Since Flash Player always sends the IE cookies even in FireFox
             * we have to bypass the cookies by sending the values as part of the POST or GET
             * and overwrite the cookies with the passed in values.
             * 
             * The theory is that at this point (BeginRequest) the cookies have not been read by
             * the Session and Authentication logic and if we update the cookies here we'll get our
             * Session and Authentication restored correctly
             */

            try
            {
                string session_param_name = "ASPSESSID";
                string session_cookie_name = "ASP.NET_SESSIONID";

                if (HttpContext.Current.Request.Form[session_param_name] != null)
                {
                    UpdateCookie(session_cookie_name, HttpContext.Current.Request.Form[session_param_name]);
                }
                else if (HttpContext.Current.Request.QueryString[session_param_name] != null)
                {
                    UpdateCookie(session_cookie_name, HttpContext.Current.Request.QueryString[session_param_name]);
                }
            }
            catch (Exception)
            {
                Response.StatusCode = 500;
                Response.Write("Error Initializing Session");
            }

            try
            {
                string auth_param_name = "AUTHID";
                string auth_cookie_name = FormsAuthentication.FormsCookieName;

                if (HttpContext.Current.Request.Form[auth_param_name] != null)
                {
                    UpdateCookie(auth_cookie_name, HttpContext.Current.Request.Form[auth_param_name]);
                }
                else if (HttpContext.Current.Request.QueryString[auth_param_name] != null)
                {
                    UpdateCookie(auth_cookie_name, HttpContext.Current.Request.QueryString[auth_param_name]);
                }

            }
            catch (Exception)
            {
                Response.StatusCode = 500;
                Response.Write("Error Initializing Forms Authentication");
            }
        }

        void UpdateCookie(string cookie_name, string cookie_value)
        {
            HttpCookie cookie = HttpContext.Current.Request.Cookies.Get(cookie_name);
            if (cookie == null)
            {
                cookie = new HttpCookie(cookie_name);
                HttpContext.Current.Request.Cookies.Add(cookie);
            }
            cookie.Value = cookie_value;
            HttpContext.Current.Request.Cookies.Set(cookie);
        }

    }
}