﻿var send_request = null;
$(document).ready(function () {
    var defaultColor = '#AAAAAA';
    var color = '#000000';
    $('#linkurl').live('focus', function () {
        $(this).css('color', color);
        var this_title = $(this).attr('title');
        if ($(this).val() == this_title) {
            $(this).val('');
        };
    });
    $('#linkurl').live('blur', function () {
        $(this).css('color', defaultColor);
        var this_title = $(this).attr('title');
        if ($(this).val() == '') {
            $(this).val(this_title);
        }
    });

    $('div.watermarkStream').live('paste', function (e) {
        var contentbox = '#' + $(this).attr('id');
        setTimeout(function () {
            $(contentbox).html(filterTag(contentbox));
            setCaretToEnd($(contentbox)[0]);
            var linkDetect = tikStream.detectLink(contentbox);
            if (linkDetect != '') {
                //setCaretToEnd($(contentbox)[0]);
                var status = filterTag(contentbox);
                $('a#tabLink').click();
                $('#stream-content-link').html(status);
                $('#stream-content-value').val(status);
                $('#linkurl').val(linkDetect);
                $('#btnlinkextract').click();
            }
        }, 0);
    });

    $('div.watermarkComment').live('paste', function (e) {
        var contentbox = '#' + $(this).attr('id');
        setTimeout(function () {
            $(contentbox).html(filterTag(contentbox));
            setCaretToEnd($(contentbox)[0]);
        }, 0);
    });

    function setCaretToEnd(el) {
        var sel, range;
        if (window.getSelection && document.createRange) {
            range = document.createRange();
            range.selectNodeContents(el);
            range.collapse(false);
            sel = window.getSelection();
            sel.removeAllRanges();
            sel.addRange(range);
        } else if (document.body.createTextRange) {
            range = document.body.createTextRange();
            range.moveToElementText(el);
            range.collapse(false);
            range.select();
        }
    }

    $('#btnlinkextract').live('click', function () {
        var linkurl = $('#linkurl').val();
        tikStream.extractLink(linkurl, '#linkCrawlResult', '#btnlinkextract');
    });

    $('#btnSendStatus').click(function () {
        tikStream.post('status');
    });
    $('#btnSendLink').click(function () {
        tikStream.post('link');
    });

    //    $('.liketooltip').live('mouseover', function () {        
    //            $(this).tipsy({
    //                title: function () {
    //                    //alert($(this).attr('id'));
    //                    var this_ = $(this);
    //                    var content = $(this).next();
    //                    if (content.html() == '') {
    //                        content.html('<img src="/Content/Images/loading1.gif" width="16" height="11" />');
    //                        $.post('ajax.html'
    //				, function (data) {
    //				    setTimeout(function () {
    //				        content.html(data);
    //				        this_.mouseover();
    //				    }, 2000);
    //				});
    //                    }
    //                    return content.html();
    //                },
    //                gravity: 'n'
    //            });
    //    });

    $('a[rel=videoAttachment]').live('click', function () {
        var hidden = $(this).attr('hidden');

        if (send_request != null) {
            return false;
        }
        var _this = $(this);
        var feedid = _this.attr('feedid');
        send_request = $.ajax({
            type: 'POST',
            url: '/Ajax/Feed/ViewVideo',
            dataType: 'json',
            data: ({ feedid: feedid }),
            success: function (response) {
                if (response.error == 0) {
                    if (hidden != 'hidden') {
                        _this.parents('.uiPhotoThumb').find('.uiAttachmentMedia, .UIImageBlock_Content').hide();
                    }
                    _this.parents('.uiPhotoThumb').find('#video_view').html(response.result);
                } else {
                    TikAlert(response.errorDescription, "Lỗi!");
                }
            },
            beforeSend: function () {
                _this.find('i').hide();
                _this.addClass('load');
            },
            complete: function () {
                _this.removeClass('load');
                setTimeout(function () {
                    send_request = null;
                }, 1000);
            }
        });
        return false;
    });

    $(window).scroll(function () {
        if ($(window).scrollTop() + 20 >= $(document).height() - $(window).height()) {
            tikStream.loadMore();
        }
    });

    makeToolTip();
});

function makeToolTip() {
    $('.liketooltip').tipsy({
        title: function () {
            //alert($(this).attr('id'));
            var _this = $(this);
            var type = _this.attr('object-type');
            var objectid = _this.attr('object-id');
            var content = $(this).next();
            if (content.html() == '') {
                content.html('<img src="/Content/Images/loading1.gif" width="16" height="11" />');
                $.ajax({
                    type: 'POST',
                    url: '/Ajax/Like/ShowLikeToolTip',
                    dataType: 'json',
                    data: ({
                        type: type,
                        objectid: objectid
                    }),
                    success: function (response) {
                        if (response.error == 0) {
                            setTimeout(function () {
                                content.html(response.result);
                                _this.mouseover();
                            }, 1000);                           
                        } else {
                            TikAlert(response.errorDescription, "Lỗi!");
                        }
                    }
                });
            }
            return content.html();
        },
        gravity: 'n'
    });
}

function removeNL(str, is_xhtml) {
    var breakTag = (is_xhtml || typeof is_xhtml === 'undefined') ? '' : '';
    return (str + '').replace(/([^>\r\n]?)(\r\n|\n\r|\r|\n)/g, '$1' + breakTag + '$2');
}

function countLengthMessage(message) {
    message = removeNL(message).replace(/<br[^>]*>/gi, '');
    var RE = new RegExp("<[^>]*>", "g");
    message = message.replace(RE, '');
    return $.trim(message).length;
}

var tikStream = {
    post: function (type) {
        if (type == 'status') {
            var message = removeBRend(removeNL($.trim($('#stream-content-value').val().replace(/&nbsp;/g, ' '))));
            //remove empty line
            var pattBegin = /^<br[^>]*>/i;
            var pattEnd = /<br[^>]*>$/i;

            while (pattBegin.test(message) || pattEnd.test(message)) {
                message = message.replace(pattBegin, '').trim();
                message = message.replace(pattEnd, '').trim();
            }
            var RE = new RegExp("<script[^>]*>.*?</script>", "g");
            message = message.replace(RE, '');

            var lengthMessage = countLengthMessage(message);

            if (lengthMessage == 0) {
                TikAlert("Nội dung không được để trống!", "Lỗi!");
                return false;
            }
            if (lengthMessage > 500) {
                $('#dialogNotifyToLongMessage').html('Độ dài trạng thái chỉ tối đa 500 ký tự. Bạn đã nhập ' + lengthMessage + ' ký tự. Bạn có muốn tạo một bài viết hay không?');
                $("#dialogNotifyToLongMessage").dialog({
                    buttons: {
                        "Có": function () {
                            window.location.href = '/Note/Detail';
                            $(this).dialog("close");
                        },
                        "Không": function () {
                            $(this).dialog("close");
                        }
                    }
                });
                return false;
            }
            try {
                if (send_request != null) {
                    return false;
                }
                send_request = $.ajax({
                    type: 'POST',
                    url: '/Ajax/Feed/PostStatus',
                    dataType: 'json',
                    data: ({
                        postid: VIEW_USERID,
                        message: TikEncode(message)
                    }),
                    success: function (response) {
                        if (response.error == 0) {
                            $('#stream-content-status').html('Bạn đang nghĩ gì?');
                            $('#stream-content-value').val('');
                            $('#stream_append_id li:first').before(response.result);
                            $('#stream_append_id li:first').hide();
                            $('#stream_append_id li:first').slideDown(600);
                        } else {
                            TikAlert(response.errorDescription, "Lỗi!");
                        }
                    },
                    beforeSend: function () {

                    },
                    complete: function () {
                        setTimeout(function () {
                            send_request = null;
                        }, 1000);
                    }
                });
            } catch (ex) { }
        }

        if (type == 'link') {
            var link_url = $('#linkCrawlerUrl').val();
            var link_title = removeNL($('#linkCrawlerTitle').val()).trim();
            var link_description = removeNL($('#linkCrawlerDescription').val()).trim();
            var link_image = $('#linkCrawlerImage').val();
            var link_video = $('#linkCrawlerVideoUrl').val();
            var message = removeBRend(removeNL($.trim($('#stream-content-value').val().replace(/&nbsp;/g, ' '))));

            //remove empty line
            var pattBegin = /^<br[^>]*>/i;
            var pattEnd = /<br[^>]*>$/i;

            while (pattBegin.test(message) || pattEnd.test(message)) {
                message = message.replace(pattBegin, '').trim();
                message = message.replace(pattEnd, '').trim();
            }
            var RE = new RegExp("<script[^>]*>.*?</script>", "g");
            message = message.replace(RE, '');
            var lengthMessage = $.trim(removeNL(message).replace(/<br[^>]*>/gi, '')).length;
            if (lengthMessage > 500) {
                TikAlert("Bạn chỉ được phép nhập tối đa 500 ký tự!", "Lỗi!");
                return false;
            }
            //            var lengthMessage = $.trim(removeNL(message).replace(/<br[^>]*>/gi, '')).length;

            //            if (lengthMessage == 0) {
            //                $("#dialogNotifyNotEmptyMessage").dialog({
            //                    buttons: {
            //                        "Đóng": function () {
            //                            $(this).dialog("close");
            //                        }
            //                    }
            //                });
            //                return false;
            //            }
            try {

                if (send_request != null) {
                    return false;
                }

                var link = {
                    Url: link_url,
                    Title: link_title,
                    Description: link_description,
                    Image: link_image
                };

                var video;
                if (link_video.trim() != '') {
                    video = {
                        Title: link_title,
                        Description: link_description,
                        Url: link_url,
                        EmbedUrl: link_video,
                        Image: link_image,
                        Type: $('#linkCrawlerVideoType').val(),
                        Width: $('#linkCrawlerVideoWidth').val(),
                        Height: $('#linkCrawlerVideoHeight').val()
                    };
                }

                send_request = $.ajax({
                    type: 'POST',
                    url: '/Ajax/Feed/PostLink',
                    dataType: 'json',
                    data: ({
                        postid: VIEW_USERID,
                        message: TikEncode(message),
                        link: TikEncode(JSON.stringify(link)),
                        video: TikEncode(JSON.stringify(video))
                    }),
                    success: function (response) {
                        if (response.error == 0) {
                            $('#stream-content-status').html('Bạn đang nghĩ gì?');
                            $('#stream-content-value').val('');
                            $('#vhTabs li.t a#tabStatus').click();
                            $('#stream_append_id li:first').before(response.result);
                            $('#stream_append_id li:first').hide();
                            $('#stream_append_id li:first').slideDown(600);
                        } else {
                            TikAlert(response.errorDescription, "Lỗi!");
                        }
                    },
                    beforeSend: function () {

                    },
                    complete: function () {
                        setTimeout(function () {
                            send_request = null;
                        }, 1000);
                    }
                });
            } catch (ex) { }

        }
        return false;
    },
    deletePost: function (feedid) {
        $("#dialogConfirmDeletePost").dialog({
            buttons: {
                "Có": function () {
                    var _this = $(this);
                    if (send_request != null) {
                        return false;
                    }
                    send_request = $.ajax({
                        type: 'POST',
                        url: '/Ajax/Feed/Delete',
                        dataType: 'json',
                        data: ({ feedid: feedid }),
                        success: function (response) {
                            if (response.error == 0) {
                                $('#stream-' + feedid).hide('slow', function () {
                                    $(this).remove();
                                });
                                _this.dialog("close");
                            } else {
                                TikAlert(response.errorDescription, "Lỗi!");
                            }
                        },
                        error: function () {
                        },
                        complete: function (req, txt) {
                            setTimeout(function () {
                                send_request = null;
                            }, 1000);
                        }
                    });

                },
                "Không": function () {
                    $(this).dialog("close");
                }
            }
        });
    },
    addFeed: function (feedid) {
        try {

            if (send_request != null) {
                return false;
            }

            send_request = $.ajax({
                type: 'POST',
                url: '/Ajax/Feed/GetFeed',
                dataType: 'json',
                data: ({
                    feedid: feedid
                }),
                success: function (response) {
                    if (response.error == 0) {
                        //$('#stream-content-status').html('Bạn đang nghĩ gì?');
                        $('#stream_append_id li:first').before(response.result);
                        $('#stream_append_id li:first').hide();
                        $('#stream_append_id li:first').slideDown(600);
                    } else {
                        TikAlert(response.errorDescription, "Lỗi!");
                    }
                },
                beforeSend: function () {

                },
                complete: function () {
                    setTimeout(function () {
                        send_request = null;
                    }, 1000);
                }
            });
        } catch (ex) { }
        return false;
    },
    like: function (type, objectid) {

        var like = ($('#like-value-' + objectid).val() == 1);
        if (send_request != null) {
            return false;
        }

        var url;
        var data;
        if (like) {
            url = "/Ajax/Like/DisLike";
            data = ({
                type: type,
                objectid: objectid
            });
        } else {
            url = "/Ajax/Like/Like";
            data = ({
                type: type,
                objectid: objectid
            });
        }
        send_request = $.ajax({
            url: url,
            dataType: 'json',
            data: data,
            type: "POST",
            cache: false,
            success: function (response) {
                if (response.error == 0) {
                    if (like) {
                        $('#like-value-' + objectid).val(0);
                        $('#like-button-' + objectid).html('Thích');

                        if (response.empty) {
                            $('#like-list-' + objectid).hide();
                        } else {
                            $('#like-list-content-' + objectid).html(response.result);
                            $('#like-list-' + objectid).show();
                        }

                    } else {
                        $('#like-value-' + objectid).val(1);
                        $('#like-button-' + objectid).html('Hết thích');

                        if (response.empty) {
                            $('#like-list-' + objectid).hide();
                        } else {
                            $('#like-list-content-' + objectid).html(response.result);
                            $('#like-list-' + objectid).show();
                        }
                    }

                } else {
                    TikAlert(response.errorDescription, "Lỗi!");
                }
            },
            complete: function () {
                setTimeout(function () {
                    send_request = null;
                }, 100);
            }
        });

    },
    showAllLike: function (type, objectid) {
        if (send_request != null) {
            return false;
        }
        $("#dialogShowAllLike").dialog("close");
        send_request = $.ajax({
            type: 'POST',
            url: '/Ajax/Like/GetLikes',
            dataType: 'json',
            data: ({ objectid: objectid }),
            success: function (response) {
                if (response.error == 0) {
                    $("#dialogShowAllLike").html(response.result);
                    if (!response.empty) {
                        $("#dialogShowAllLike").dialog({
                            buttons: {
                                "Đóng": function () {
                                    $(this).dialog("close");
                                }
                            },
                            width: 400
                        });
                    }
                } else {
                    TikAlert(response.errorDescription, "Lỗi!");
                }
            },
            error: function () {
            },
            complete: function (req, txt) {
                setTimeout(function () {
                    send_request = null;
                }, 1000);
            }
        });
        return false;
    },
    hideActivity: function (activityid) {
        $("#dialogConfirmHideActivity").dialog({
            buttons: {
                "Có": function () {
                    var _this = $(this);
                    if (send_request != null) {
                        return false;
                    }
                    send_request = $.ajax({
                        type: 'POST',
                        url: '/Ajax/Activity/Hide',
                        dataType: 'json',
                        data: ({ activityid: activityid }),
                        success: function (response) {
                            if (response.error == 0) {
                                $('#activity-' + activityid).hide('slow', function () {
                                    var _parent = $(this).parent();
                                    $(this).remove();
                                    if (_parent.find("li").length == 1) {
                                        _parent.parent().parent().remove();
                                    }
                                });
                                _this.dialog("close");

                            } else {
                                alert(response.errorDescription);
                            }
                        },
                        error: function () {
                        },
                        complete: function (req, txt) {
                            setTimeout(function () {
                                send_request = null;
                            }, 1000);
                        }
                    });

                },
                "Không": function () {
                    $(this).dialog("close");
                }
            }
        });
    },
    hideActivityTag: function (activityid) {
        $("#dialogConfirmHideActivity").dialog({
            buttons: {
                "Có": function () {
                    var _this = $(this);
                    if (send_request != null) {
                        return false;
                    }
                    send_request = $.ajax({
                        type: 'POST',
                        url: '/Ajax/Activity/HideTag',
                        dataType: 'json',
                        data: ({ activityid: activityid }),
                        success: function (response) {
                            if (response.error == 0) {
                                $('#activity-' + activityid).hide('slow', function () {
                                    $(this).remove();
                                });
                                _this.dialog("close");

                            } else {
                                TikAlert(response.errorDescription, "Lỗi!");
                            }
                        },
                        error: function () {
                        },
                        complete: function (req, txt) {
                            setTimeout(function () {
                                send_request = null;
                            }, 1000);
                        }
                    });

                },
                "Không": function () {
                    $(this).dialog("close");
                }
            }
        });
    },
    focusComment: function (feedid) {
        $('#comment-form-' + feedid).show();
        $('#comment-content-' + feedid).focus();
    },
    comment: function (type, objectid, content) {
        content = removeBRend(content).trim();
        if (content.length == 0) {
            return false;
        }
        if (send_request != null) {
            return false;
        }

        var reg = new RegExp("<script[^>]*>.*?</script>", "g");
        content = content.replace(reg, '');

        //var lengthMessage = $.trim(removeTagContent(removeNL(content).replace(/<br[^>]*>/gi, ''))).length;
        var lengthMessage = countLengthMessage(content);

        if (lengthMessage > 500) {
            TikAlert("Nội dung bình luận chỉ được tối đa 500 ký tự", "Lỗi!");
            return false;
        }
        send_request = $.ajax({
            type: 'POST',
            url: '/Ajax/Comment/Add',
            dataType: 'json',
            data: ({
                type: type,
                objectid: objectid,
                comment: TikEncode(content)
            }),
            success: function (response) {
                if (response.error == 0) {
                    $('#comment-content-' + objectid).html('');
                    $('#comment-list-' + objectid).append(response.result);
                    bindEventForCloseButton();
                    makeToolTip();
                }
                else {
                    TikAlert(response.errorDescription, "Lỗi!");
                }
            },
            complete: function () {
                setTimeout(function () {
                    send_request = null;
                }, 1000);
            }
        });
    },

    deleteComment: function (commentid) {
        if (send_request != null) {
            return false;
        }

        send_request = $.ajax({
            type: 'POST',
            url: '/Ajax/Comment/Delete',
            dataType: 'json',
            data: ({ commentid: commentid }),
            success: function (response) {
                if (response.error == 0) {
                    $('#comment-' + commentid).hide('slow', function () {
                        $(this).remove();
                    });
                } else {
                    TikAlert(response.errorDescription, "Lỗi!");
                }
            },
            error: function () {
            },
            complete: function (req, txt) {
                setTimeout(function () {
                    send_request = null;
                }, 1000);
            }
        });
    },
    confirmDeleteComment: function (commentid) {
        $("#dialogConfirmDeleteComment").dialog({
            buttons: {
                "Có": function () {
                    var _this = $(this);
                    //tikStream.deleteComment(commentid);
                    if (send_request != null) {
                        return false;
                    }

                    send_request = $.ajax({
                        type: 'POST',
                        url: '/Ajax/Comment/Delete',
                        dataType: 'json',
                        data: ({ commentid: commentid }),
                        success: function (response) {
                            if (response.error == 0) {
                                $('#comment-' + commentid).hide('slow', function () {
                                    $(this).remove();
                                });
                                _this.dialog("close");
                            } else {
                                TikAlert(response.errorDescription, "Lỗi!");
                            }
                        },
                        error: function () {
                        },
                        complete: function (req, txt) {
                            setTimeout(function () {
                                send_request = null;
                            }, 1000);
                        }
                    });

                },
                "Không": function () {
                    $(this).dialog("close");
                }
            }
        });
    },

    loadAllComment: function (type, objectid) {
        if (send_request != null) {
            return false;
        }
        $('#viewall-comment-load-' + objectid).show();
        send_request = $.ajax({
            type: 'POST',
            url: '/Ajax/Comment/LoadAll',
            dataType: 'json',
            data: ({
                type: type,
                objectid: objectid
            }),
            success: function (response) {
                if (response.error == 0) {
                    $('#viewall-comment-load-' + objectid).remove();
                    $('#viewall-comment-' + objectid).remove();
                    $('#comment-list-' + objectid).html(response.result);
                    bindEventForCloseButton();
                    makeToolTip();
                } else {
                    TikAlert(response.errorDescription, "Lỗi!");
                }
            },
            error: function () {

            },
            complete: function (req, txt) {
                setTimeout(function () {
                    send_request = null
                }, 1000);
            }
        });
    },

    detectLink: function (contentid) {
        var message = filterTag(contentid);
        var oldmessage = filterTag(contentid);
        message = message.replace('(&nbsp;)', ' ');
        message = message.replace(/\<br[^>]*>/ig, ' ');
        message = message.replace(/\<\\p>/ig, ' ');
        message = message.replace(/\<\div>/ig, ' ');
        message = strip_tags(message, '');
        var matches = message.match(/(http|https):\/\/(\w+:{0,1}\w*@@[^\<])?(\S+)(:[0-9]+)?(\/[^\<]|\/([\w#!:.?+=&%@@!\-\/])[^\<])?/);
        if (matches !== null && matches[0].length) {
            message = strip_tags(matches[0], '');
            var indexGif = message.indexOf('.gif');
            if (indexGif != -1) {
                message = message.substr(0, indexGif + 4);
            }
            var indexJpg = message.indexOf('.jpg');
            if (indexJpg != -1) {
                message = message.substr(0, indexJpg + 4);
            }
            var indexJpeg = message.indexOf('.jpeg');
            if (indexJpeg != -1) {
                message = message.substr(0, indexJpeg + 5);
            }
            var indexPng = message.indexOf('.png');
            if (indexPng != -1) {
                message = message.substr(0, indexPng + 4);
            }
            var indexJs = message.indexOf('.js');
            if (indexJs != -1) {
                message = message.substr(0, indexJs + 3);
            }
            return message;
        }
        return '';
    },

    extractLink: function (linkurl, resultid, btnclickid) {

        if (!isValidURL(linkurl)) {
            $("#dialogNotifyNotUrl").dialog({
                buttons: {
                    "Đóng": function () {
                        $(this).dialog("close");
                    }
                }
            });
            return false;
        }

        try {
            //            if (send_request != null) {
            //                return false;
            //            }

            //send_request = $.ajax({
            $.ajax({
                url: '/Ajax/Feed/ExtractLink',
                dataType: 'json',
                data: { link: linkurl },
                type: "POST",
                cache: true,
                success: function (response) {
                    if (response.error == 0) {
                        $('#linkFormUrl').hide();
                        $('#linkCrawlResult').html(response.result);
                        $('#linkCrawlResult').fadeIn('slow');
                        $('#linkFormContent').fadeIn('slow');
                        if (response.image) {
                            imageCrawnlerChange();
                        }
                    } else {
                        TikAlert(response.errorDescription, "Lỗi!");
                    }
                },
                error: function () {
                    //                    setTimeout(function () {
                    //                        send_request = null
                    //                    }, 1000);
                },
                beforeSend: function () {
                    $(btnclickid).parent().addClass('uiButtonDisabled');
                    $('#btnlinkextractload').show();
                    $('#linkCrawlResult').html('');
                    $('#linkCrawlResult').hide();
                },
                complete: function (req, txt) {
                    //                    setTimeout(function () {
                    //                        send_request = null
                    //                    }, 1000);
                }
            });

        } catch (ex) { };

    },
    loadMore: function () {
        var type = $('#load-more-type').val();
        var enddate = $('#load-more-enddate').val();
        if (enddate == '') {
            $('#load-more-content').hide();
            $('#load-more-enddate').val('');
            return false;
        }
        try {
            //            if (send_request != null) {
            //                return false;
            //            }
            $.ajax({
                url: '/Ajax/Activity/LoadMore',
                dataType: 'json',
                data: {
                    viewid: VIEW_USERID,
                    type: type,
                    enddate: enddate
                },
                type: "POST",
                cache: true,
                success: function (response) {
                    if (response.error == 0) {
                        $('#load-more-loading').hide();

                        if (!response.empty) {
                            $('#stream_append_id').append(response.result);
                            $('#load-more-enddate').val(response.dateend);
                            $('#load-more-type').val(response.type);
                            bindEventForCloseButton();
                            makeToolTip();
                        } else {
                            $('#load-more-loading').hide();
                            $('#load-more-enddate').val('');
                        }
                        if (response.isend) {
                            $('#load-more-content').hide();
                        }
                    } else {
                        TikAlert(response.errorDescription, "Lỗi!");
                    }
                },
                beforeSend: function () {
                    $('#load-more-content').show();
                    $('#load-more-loading').show();
                },
                complete: function (req, txt) {
                    //                    setTimeout(function () {
                    //                        send_request = null
                    //                    }, 1000);
                }
            });
        } catch (ex) { };
    },
    filterActivity: function (obj, type) {
        //        if (send_request != null) {
        //            return false;
        //        }
        var _this = $(obj);
        var ul = _this.parent().parent();
        ul.find('a.active').each(function (index) {
            if ($(this).hasClass('active')) {
                $(this).removeClass('active');
            }
        });
        _this.addClass('active');
        $('#load-more-enddate').val('');
        $('#load-more-type').val(type);
        $('#load-more-content').show();

        try {
            //            send_request = $.ajax({
            $.ajax({
                url: '/Ajax/Activity/LoadFeed',
                dataType: 'json',
                data: {
                    viewid: VIEW_USERID,
                    type: type
                },
                type: "POST",
                cache: true,
                success: function (response) {
                    if (response.error == 0) {
                        $('#filterLoading').hide();
                        $('#load-more-loading').hide();
                        if (!response.empty) {
                            $('#stream_append_id').html(response.result);
                            $('#load-more-enddate').val(response.dateend);
                            $('#load-more-type').val(response.type);
                            if (response.isend) {
                                $('#load-more-content').hide();
                            }
                            bindEventForCloseButton();
                            makeToolTip();
                        } else {
                            $('#stream_append_id').html('<li id="stream-0" style="display:none;"></li>');
                            $('#load-more-loading').hide();
                            $('#load-more-content').hide();
                            $('#load-more-enddate').val('');
                        }
                    } else {
                        TikAlert(response.errorDescription, "Lỗi!");
                    }
                },
                beforeSend: function () {
                    $('#filterLoading').show();
                    $('#load-more-loading').show();
                },
                complete: function (req, txt) {
                    //                    setTimeout(function () {
                    //                        send_request = null
                    //                    }, 1000);
                }
            });
        } catch (ex) { };
    },
    getCommentLike: function (type, objectid) {
        //GetCommentLike
        try {
            //            send_request = $.ajax({
            $('li#stream_image').html('');
            $.ajax({
                url: '/Ajax/Feed/GetCommentLike',
                dataType: 'json',
                data: {
                    type: type,
                    objectid: objectid
                },
                type: "POST",
                cache: true,
                success: function (response) {
                    if (response.error == 0) {
                        if (type == 2) {
                            $('li#stream_image').html(response.result);
                        }
                        if (type == 4) {
                            $('li#stream_music').html(response.result);
                        }
                        if (type == 5) {
                            $('li#stream_albummusic').html(response.result);
                        }
                        bindEventForCloseButton();
                        makeToolTip();
                    } else {
                        TikAlert(response.errorDescription, "Lỗi!");
                    }
                },
                complete: function (req, txt) {
                    //                    setTimeout(function () {
                    //                        send_request = null
                    //                    }, 1000);
                }
            });
        } catch (ex) { };
    },
    getListUser: function (objectid) {
        try {
            if (send_request != null) {
                return false;
            }
            var listfriend = $("#listFriends-" + objectid).val();
            $("#dialogShowUser").dialog("close");
            send_request = $.ajax({
                url: '/Ajax/User/ListUser',
                dataType: 'json',
                data: {
                    listuser: listfriend
                },
                type: "POST",
                cache: true,
                success: function (response) {
                    if (response.error == 0) {
                        if (!response.empty) {
                            $("#dialogShowUser").attr('title', 'Danh sách kết bạn');
                            $("#dialogShowUser").html(response.result);
                            $("#dialogShowUser").dialog({
                                buttons: {
                                    "Đóng": function () {
                                        $(this).dialog("close");
                                    }
                                },
                                width: 400
                            });
                        }
                    } else {
                        TikAlert(response.errorDescription, "Lỗi!");
                    }
                },
                complete: function (req, txt) {
                    setTimeout(function () {
                        send_request = null
                    }, 1000);
                }
            });
        } catch (ex) {
        }
    }
}

function isValidURL(url) {
    var RegExp = /(ftp|http|https):\/\/(\w+:{0,1}\w*@@)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%@@!\-\/]))?/;

    if (RegExp.test(url)) {
        return true;
    } else {
        return false;
    }
}

function filterTag(blastid) {
    var message = $(blastid).html();
    message = strip_tags(message, '<small><br><p>');
    var matches = message.match(/id=[\"|\']?[\d]{10}[\"|\']?/ig);
    var _ids = new Array();
    var count = 0;
    for (i in matches) {
        _ids[i] = matches[i].replace(/(\'*)/g, "");
        _ids[i] = _ids[i].replace(/(\"*)/g, "");
        _ids[i] = _ids[i].replace(/(id=)/g, "");
        count++;
    }
    /*check value duplicate*/
    var duplicate = new Array();
    var k = 0;
    for (var i = 0; i < (count - 1); i++) {
        for (var j = i + 1; j < count; j++) {
            if (_ids[i] == _ids[j])
                duplicate[k++] = j;
        }
    }
    /*revome duplicate*/
    var tmp = explodejs('</small>', message);
    for (v in duplicate) {
        tmp[duplicate[v]] = tmp[duplicate[v]].replace(/\<small[^>]*>/ig, "");
    }
    var new_str = '';
    for (v in tmp) {
        new_str += (strposjs(tmp[v], '<small') === false) ? tmp[v] : tmp[v] + '</small>';
    }
    return new_str;
}

function strip_tags(input, allowed) {
    allowed = (((allowed || "") + "").toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join('');
    var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi;
    var commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
    return input.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1) {
        return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
    });
}

function explodejs(delimiter, string, limit) {
    var emptyArray = {
        0: ''
    };
    if (arguments.length < 2 || typeof arguments[0] == 'undefined' || typeof arguments[1] == 'undefined') {
        return null;
    }
    if (delimiter === '' || delimiter === false || delimiter === null) {
        return false;
    }
    if (typeof delimiter == 'function' || typeof delimiter == 'object' || typeof string == 'function' || typeof string == 'object') {
        return emptyArray;
    }
    if (delimiter === true) {
        delimiter = '1';
    }
    if (!limit) {
        return string.toString().split(delimiter.toString());
    } else {
        var splitted = string.toString().split(delimiter.toString());
        var partA = splitted.splice(0, limit - 1);
        var partB = splitted.join(delimiter.toString());
        partA.push(partB);
        return partA;
    }
}

function strposjs(f_haystack, f_needle, f_offset) {
    var haystack = (f_haystack + '').toLowerCase();
    var needle = (f_needle + '').toLowerCase();
    var index = 0;
    if ((index = haystack.indexOf(needle, f_offset)) !== -1) {
        return index;
    }
    return false;
}