﻿
    var serverOffset = 0;

    Date.SetServerOffset = function (ts) {
        var server = new Date(ts);
        var client = new Date();
        serverOffset = server - client;
        
    };

    Date.getServerOffset = function () {
        return serverOffset;
    };

    Date.prototype.getISODay = function () {        
        var day = this.getDay() - 1;
        if (day < 0) day += 7;
        return day;
    }

    Date.prototype.getDOY = function() {
        var onejan = new Date(this.getFullYear(),0,1);
        return Math.ceil((this - onejan) / 86400000);
    }

    Date.prototype.getISOWeek = function () {
        var compare = new Date(this);
        compare.setMonth(1);
        compare.setDate(4);
        var startOfWeekYear = compare.getDOY() - compare.getISODay() - 1;
        return Math.ceil((this.getDOY() - startOfWeekYear) / 7);
    }

    Date.prototype.getFluentTimeSince = function () {
        var ref = this;
        var val;
        var now = new Date();

        var deltaNormal = (ref - now - serverOffset) / 1000;

        //var deltaNormal = (now - ref + serverOffset) / 1000;
        var delta = Math.abs(deltaNormal);
        var isPlus = (deltaNormal > 0);

//        if (delta < 1) {
//            if (isPlus) {
//                return 'vừa xong';
//            } else {
//                return 'vừa xong';
//            }
//        }

        // Less than a minute
        if (delta < 60) {
            val = Math.ceil(delta);
            if (isPlus) {
                return 'trong khoảng ' + val + ' giây';
            } else {
                return val + ' giây trước';
            }
        }

        // Less than an hour
        else if (delta < 60 * 60) {
            val = Math.floor(delta / 60);
            if (isPlus) {
                return 'trong khoảng ' + val + ' phút';
            } else {
                return val + ' phút trước';
            }
        }

        // less than 12 hours ago, or less than a day ago and same day
        else if (delta < (60 * 60 * 12) || (delta < 60 * 60 * 24 && ref.getDay == now.getDay)) {
            val = Math.floor(delta / (60 * 60));
            if (isPlus) {
                return 'trong khoảng ' + val + ' tiếng';
            } else {
                return val + ' tiếng trước';
            }
        }

        // less than a week and same week
        else if (delta < 60 * 60 * 24 * 7 && ref.getISOWeek() == now.getISOWeek()) {
            return ref.getWeekDayVN() + ' vào lúc ' + ref.getTimeVN();
        }

        // less than a year and same year
        else if (delta < 60 * 60 * 60 * 24 * 366 && ref.getYear() == now.getYear()) {
            return ref.getDateVN() + ' ' + ref.getMonthVN() + ' lúc ' + ref.getTimeVN();
        }

        // Otherwise use the full date
        else {
            return ref.getWeekDayVN() + ', ' + ref.getDateVN() + ' ' + ref.getMonthVN() + ' lúc ' + ref.getTimeVN();
        }
    }

    Date.prototype.getWeekDayVN = function() {
        var weekday = new Array("Chủ nhật","Thứ Hai","Thứ Ba","Thứ tư","Thứ năm","Thứ Sáu","Thứ bẩy");
        return weekday[this.getDay()].toString();
    }

    Date.prototype.getTimeVN = function () {
        var hoursValue = this.getHours();
        var hour = hoursValue;
        if (hour > 12) {
            hour = hour - 12;
        }
        var time = hour + ':' + this.getMinutes() + ' ';
        if (hoursValue >= 12) {
            time = time + 'chiều';
        } else {
            time = time + 'sáng';
        }
        return time;
    }

    Date.prototype.getMonthVN = function () {
        return 'tháng ' + (this.getMonth()+1);
    }

    Date.prototype.getDateVN = function () {
        return 'ngày ' + this.getDate();
    }


    var timeRefresh = 10000;
    var changeTime = null;

    function processChangeTime() {
        var now = new Date();
        $('.time-update').each(function () {
            var ref = new Date($(this).attr('date-data'));
            var newStamp = ref.getFluentTimeSince();
            if ($(this).html() != newStamp) {
                $(this).html(newStamp);
            }
        });

        changeTime = setTimeout(function () {
            processChangeTime();
        }, timeRefresh);
    };

    $(document).ready(function () {
        processChangeTime();
    });

