﻿
function ValidFrm(_string) {
    _string = _string.replace(/<!--/g, "");
    _string = _string.replace(/-->/g, "");

    return _string;
}

function Html2Text(strHtml) {
    try {
        strHtml = strHtml.replace(/<br\/>/g, "\n");
    } catch (ex) { }
    try {
        strHtml = strHtml.replace(/<br>/g, "\n");
    } catch (ex) { }
    return strHtml;
}

function StripTagHTML(input) {
    return input.replace(/<\/?[^>]+>/gi, '');
}

function TikEncode(_string, isSpecialchars) {
    if ((typeof (isSpecialchars) != "undefined") && isSpecialchars) {
        _string = htmlspecialchars(_string);        
    }
    _string = Base64.encode(_string);
    return _string;
}

function TikDecode(_string) {
    _string = Base64.decode(_string);
    return _string;
}

function htmlspecialchars(str) {
    if (typeof (str) == "string") {
        str = str.replace(/&/g, "&amp;"); /* must do &amp; first */
        str = str.replace(/"/g, "&quot;");
        str = str.replace(/'/g, "&#039;");
        str = str.replace(/</g, "&lt;");
        str = str.replace(/>/g, "&gt;");
    }
    return str;
}

var Base64 = {
    _keyStr: "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",

    encode: function (input) {
        if (typeof (input) == "undefined") var input = "";
        var output = "";
        var chr1, chr2, chr3, enc1, enc2, enc3, enc4;
        var i = 0;

        input = Base64._utf8_encode(input);

        while (i < input.length) {

            chr1 = input.charCodeAt(i++);
            chr2 = input.charCodeAt(i++);
            chr3 = input.charCodeAt(i++);

            enc1 = chr1 >> 2;
            enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
            enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
            enc4 = chr3 & 63;

            if (isNaN(chr2)) {
                enc3 = enc4 = 64;
            } else if (isNaN(chr3)) {
                enc4 = 64;
            }

            output = output +
			this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) +
			this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);

        }
        return output;
    },
    decode: function (input) {
        if (typeof (input) == "undefined") var input = "";
        var output = "";
        var chr1, chr2, chr3;
        var enc1, enc2, enc3, enc4;
        var i = 0;

        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");

        while (i < input.length) {

            enc1 = this._keyStr.indexOf(input.charAt(i++));
            enc2 = this._keyStr.indexOf(input.charAt(i++));
            enc3 = this._keyStr.indexOf(input.charAt(i++));
            enc4 = this._keyStr.indexOf(input.charAt(i++));

            chr1 = (enc1 << 2) | (enc2 >> 4);
            chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
            chr3 = ((enc3 & 3) << 6) | enc4;

            output = output + String.fromCharCode(chr1);

            if (enc3 != 64) {
                output = output + String.fromCharCode(chr2);
            }
            if (enc4 != 64) {
                output = output + String.fromCharCode(chr3);
            }

        }

        output = Base64._utf8_decode(output);

        return output;

    },
    _utf8_encode: function (string) {
        string = string.replace(/\r\n/g, "\n");
        var utftext = "";

        for (var n = 0; n < string.length; n++) {

            var c = string.charCodeAt(n);

            if (c < 128) {
                utftext += String.fromCharCode(c);
            }
            else if ((c > 127) && (c < 2048)) {
                utftext += String.fromCharCode((c >> 6) | 192);
                utftext += String.fromCharCode((c & 63) | 128);
            }
            else {
                utftext += String.fromCharCode((c >> 12) | 224);
                utftext += String.fromCharCode(((c >> 6) & 63) | 128);
                utftext += String.fromCharCode((c & 63) | 128);
            }

        }

        return utftext;
    },
    _utf8_decode: function (utftext) {
        var string = "";
        var i = 0;
        var c = c1 = c2 = 0;

        while (i < utftext.length) {

            c = utftext.charCodeAt(i);

            if (c < 128) {
                string += String.fromCharCode(c);
                i++;
            }
            else if ((c > 191) && (c < 224)) {
                c2 = utftext.charCodeAt(i + 1);
                string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
                i += 2;
            }
            else {
                c2 = utftext.charCodeAt(i + 1);
                c3 = utftext.charCodeAt(i + 2);
                string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
                i += 3;
            }

        }

        return string;
    }

}

function TikAlert(messenger, title) {
    var divF = "<div id='divAlert'></div>";
    if ($('#divAlert').length > 0) {
        $('#divAlert').remove();
    }
    $('body').append(divF);
    $("#divAlert").attr('title', title);
    $("#divAlert").append(messenger);
    $("#divAlert").dialog({
        modal: true,
        resizable: false,
        height: 100,
        width: 300,
        buttons: {
            "OK": function () {
                $(this).dialog("close");
                return false;
            }
        }
    });
    $("#divAlert").dialog('open');
}

function TikSetAcviteTab(action, controller, area) {
    switch (area) {
        case "feed":
            switch (controller) {
                case "wall":
                    if (action == "index") {
                        $("ul.toggle_tabs li:eq(0)").addClass('active');
                    }
                    return false;
                default:
                    return false;
            }

        case "profile":
            switch (controller) {
                case "info":
                    if (action == "index") {
                        $("ul.toggle_tabs li:eq(1)").addClass('active');
                    }
                    return false;
                case "update":
                    if ((action == "basic") ||
                        (action == "avatar") ||
                        (action == "relationship") ||
                        (action == "favorite") ||
                        (action == "university") ||
                        (action == "contact") ||
                        (action == "privacy")) {
                        $("ul.toggle_tabs li:eq(1)").addClass('active');
                    }
                    return false;
                default:
                    return false;
            }
        case "photo":
            switch (controller) {
                case "photo":
                    if ((action == "listphotoinalbum") ||
                        (action == "albumdetail") ||
                        (action == "uploadphotoalbum") ||
                        (action == "editalbum") ||
                        (action == "index") ||
                        (action == "listalbum")) {
                        $("ul.toggle_tabs li:eq(2)").addClass('active');
                    }
                    return false;
                default: return false;
            }

        case "music":
            switch (controller) {
                case "music":
                    if ((action == "albumdetail") ||
                        (action == "index") ||
                        (action == "editalbum") ||
                        (action == "uploadsong") ||
                        (action == "songdetail")) {
                        $("ul.toggle_tabs li:eq(3)").addClass('active');
                    }
                    return false;
                default: return false;
            }

        case "note":
            switch (controller) {
                case "view":
                    if (action == "index") {
                        $("ul.toggle_tabs li:eq(4)").addClass('active');
                    }
                    return false;
                case "detail":
                    if (action == "index") {
                        $("ul.toggle_tabs li:eq(4)").addClass('active');
                    }
                    return false;
                case "list":
                    if (action == "index" || action == "tagged") {
                        $("ul.toggle_tabs li:eq(4)").addClass('active');
                    }
                    return false;
                case "edit":
                    if (action == "index") {
                        $("ul.toggle_tabs li:eq(4)").addClass('active');
                    }
                    return false;
                default: return false;
            }

        default: return false;
    }
}