﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Service.Interface.Tik;
using Social.Web.Extends.Helper;
using Social.Lib;
using Social.Web.Extends.WebService;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for CheckEmailExist
    /// </summary>
    public class CheckEmailExist : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            try
            {
                if (ConfigManager.GetKey("UseTikID") != null && ConfigManager.GetKey("UseTikID") == "true")
                {
                    Social.Web.Extends.WebService.IDService.ServiceResult res= IDService.CheckEmailExist(context.Request.Form["email"]);
                    if (res.IsSuccess)
                        context.Response.Write("true");
                    else
                        context.Response.Write("false");
                }
                else
                {
                    var _userservice = DependencyResolver.Current.GetService<IUserProfileService>();
                    var user = _userservice.GetByEmail(context.Request.Form["email"]);
                    if (user != null)
                        context.Response.Write("true");
                    else
                        context.Response.Write("false");
                }
                
            }
            catch (Exception ex)
            {
                LogHelper.Error("Call check email exist service",ex.Message);
                context.Response.Write("false");
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}