﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.IO;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Service.Interface.TikPhoto;
using Social.Lib;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for DownloadPhoto
    /// </summary>
    public class DownloadPhoto : IHttpHandler
    {
        private readonly IPhotoService _photo = DependencyResolver.Current.GetService<IPhotoService>();
        public void ProcessRequest(HttpContext context)
        {
            var _imageId = !String.IsNullOrEmpty(context.Request.QueryString["pId"])
                              ? Guid.Parse(context.Request.QueryString["pId"].Trim())
                              : Guid.Empty;

            try
            {

                var photo = _photo.GetById(_imageId);
                var _filePath = ConfigManager.PathResourcePhoto + photo.SourceUrl + Lib.Photo.Constants.ImageInfo.NameOriginal;
                    var _physicalFile = new FileInfo(_filePath);
                    if (_physicalFile.Exists)
                    {
                        var _extension = Path.GetExtension(_filePath).Replace(".", String.Empty).Replace("jpg", "jpeg");
                        context.Response.ContentType = String.Format("image/{0}", _extension);
                        context.Response.AddHeader("Content-Disposition",
                                                    "attachment; filename=\"" + _physicalFile.Name + "\"");
                        context.Response.AddHeader("Content-Length", _physicalFile.Length.ToString());
                        context.Response.WriteFile(_physicalFile.FullName);
                        context.Response.End();
                    }
                    else
                    {
                        context.Response.Write("Image file is not exists.");
                    }
                 
            }
            catch (Exception ex)
            {
                context.Response.Write(ex.Message);
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}