﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Social.Service.Interface.TikFriend;
using System.Web.Mvc;
using Social.Entity.TikFriend;
using System.Configuration;
using Social.Web.Extends.Helper;
using Social.Entity.Tik;
using Social.Web.Areas.Friend.Controllers;
using Social.Service.Interface.Tik;
using System.Web.Script.Serialization;
using Social.Lib;
using System.Web.SessionState;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for FriendRequest
    /// </summary>
    public class FriendRequest : IHttpHandler, IReadOnlySessionState
    {
        
        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/plain";
            try
            {
                
                string ar = context.Request.Form["ar"].ToString();
                List<Guid> listromove = new List<Guid>();
                char[] separator = new char[] { ',' };

                string[] strSplitArr = ar.Split(separator);

                foreach (string arrStr in strSplitArr)
                {
                    Guid s = new Guid(arrStr);
                    listromove.Add(s);
                }



                string toUserID = context.Request.Form["friend"].ToString();
                string select = context.Request.Form["select"].ToString();
                string text = context.Request.Form["text"].ToString();
                if (select != "Thêm vào danh sách")
                {
                    FriendInList friendinlist = new FriendInList();
                    friendinlist.ID = Guid.NewGuid();
                    friendinlist.FriendListID = new Guid(select);
                    friendinlist.FriendID = new Guid(toUserID);
                    friendinlist.Status = false;
                    IFriendInListService _friendinlist = DependencyResolver.Current.GetService<IFriendInListService>();
                    _friendinlist.Add(friendinlist);

                }



                //string stt = context.Session["UserID"].ToString();
                int close = Convert.ToInt16(context.Request.Form["close"].ToString());
                //lấy session của user đăng nhập
                string fromUserID =Social.Lib.SessionManager.CurrentUserID().ToString();

                //nhóm bản ghi được đánh dấu
                string idgroup = context.Request.Form["idgroup"].ToString();



                //context.Response.Write("Hello World");
                IFriendRequestService _friend = DependencyResolver.Current.GetService<IFriendRequestService>();
                IUserFriendService _userfriend = DependencyResolver.Current.GetService<IUserFriendService>();
                DateTime CreatedDate = System.DateTime.Now;
                bool Status = false;
                string Message = text;
                Social.Entity.TikFriend.FriendRequest friendrequest = new Social.Entity.TikFriend.FriendRequest();
                friendrequest.ID = Guid.NewGuid();
                Guid guifromUserID;
                guifromUserID = new Guid(fromUserID);

                listromove.Add(guifromUserID);

                if (close == 1)
                {
                    
                    Guid guitoUserID;
                    guitoUserID = new Guid(toUserID);
                    friendrequest.FromUserID = guifromUserID;
                    friendrequest.ToUserID = guitoUserID;
                    if (_friend.GetCountByFromUserIDAndToUserID(guifromUserID, guitoUserID) > 0)
                    {
                        return;
                    }
                    friendrequest.CreatedDate = CreatedDate;
                    friendrequest.UpdatedDate = CreatedDate;
                    friendrequest.Status = Status;
                    friendrequest.Message = Message;
                    _friend.Add(friendrequest);
                }
                else
                {

                }

                //Lấy danh sách người đã có yêu cầu kết bạn rồi
                var friendRequested = _friend.GetAll().Where(x => x.FromUserID == guifromUserID).ToList().Select(x => x.ToUserID);
                //Lấy danh sách đã kết bạn
                var friends = _userfriend.GetAll().Where(o => o.OwnerID == guifromUserID).ToList().Select(p => p.FriendID);
                //
                //
                //lấy chuỗi trường học của thằng đăng nhập
                //
                //
                #region khai báo lấy các hàm từ lớp interface

                IUserSchoolService _userschoolservice = DependencyResolver.Current.GetService<IUserSchoolService>();
                IUserProfileService _user = DependencyResolver.Current.GetService<IUserProfileService>();
                IUserCompanyService _usercompanyservice = DependencyResolver.Current.GetService<IUserCompanyService>();
                IUserUniversityService _universityservice = DependencyResolver.Current.GetService<IUserUniversityService>();
                #endregion

                //json script object
                #region khai báo lấy đôi tượng json
                JavaScriptSerializer javascriptshool = new JavaScriptSerializer();
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                #endregion
                //lấy chuỗi các trường tiểu học của thằng đăng nhập

                #region lấy những thằng cùng trường tiêu học với nhau

                List<SchoolObject> listofshool = new List<SchoolObject>();
                string schoolstring = "";
                try
                {
                    schoolstring = _userschoolservice.GetByUserID(guifromUserID);
                }
                catch { }
                //XmlSerializer serializer = new XmlSerializer(typeof(listofshool)); 

                listofshool = serializer.Deserialize<List<SchoolObject>>("[" + schoolstring + "]");
                //cắt chuỗi ra từng thằng
                List<string> liststringpriority = new List<string>();
                foreach (var sc in listofshool)
                {
                    liststringpriority.Add(sc.name.ToString());
                }

                //lấy được thằng cùng trường tiểu học rồi hè hè
                var testschoolpriority = _userschoolservice.GetBySchool(liststringpriority);
                //int demcainhi = testschoolpriority.Count();

                // -- 1 -- cùng trường tiểu học
                var suggestFriendListschool = _user.GetUserProfileCountFriend().Where(x => testschoolpriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !listromove.Contains(x.ID)).Take(1).ToList();
                foreach (var suggestFriend in suggestFriendListschool)
                {
                    //Lấy danh sách bạn của thằng suggest
                    var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID).Distinct();
                    //Đếm số lượng bạn chung
                    int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                    ////Đếm
                    //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                    //var dem=from c in _userfriend.GetAll()
                    //        where c.OwnerID
                    if (dem > 0)
                    {
                        suggestFriend.UserCount = dem;
                    }

                }

                #endregion
                //context.Response.Write("đang chờ kết bạn");

                #region lấy những thằng cùng đại học với nhau
                ////lấy chuỗi các trường đại học của thằng đăng nhập
                string stringuseruniversity = _universityservice.GetStringByUserID(guifromUserID).ToString();
                List<UniversityObject> listofuniversity = new List<UniversityObject>();

                listofuniversity = serializer.Deserialize<List<UniversityObject>>("[" + stringuseruniversity + "]");
                //cắt chuỗi ra từng chuỗi tường trường
                List<string> listuniversitypriority = new List<string>();
                foreach (var sc in listofuniversity)
                {
                    listuniversitypriority.Add(sc.name.ToString());
                }

                //lấy được thằng cùng trường đại học rồi hè hè
                var testuniversitypriority = _universityservice.GetListByUniversity(listuniversitypriority);
                //int demcainhi = testschoolpriority.Count();

                // -- 2 -- cùng trường đại học

                    var suggestFriendListuniversity = _user.GetUserProfileCountFriend().Where(x => testuniversitypriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !listromove.Contains(x.ID)).Take(1).ToList();
                    foreach (var suggestFriend in suggestFriendListuniversity)
                    {
                        //Lấy danh sách bạn của thằng suggest
                        var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID).Distinct();
                        //Đếm số lượng bạn chung
                        int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                        ////Đếm
                        //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                        //var dem=from c in _userfriend.GetAll()
                        //        where c.OwnerID
                        if (dem > 0)
                        {
                            suggestFriend.UserCount = dem;
                        }

                    }
             

                #endregion


                #region lấy những thằng cùng công ty với nhau
                ////lấy chuỗi các công ty của thằng đăng nhập của thằng đăng nhập
                string stringusercompany = _usercompanyservice.GetByUserId(guifromUserID).ToString();
                List<CompanyObject> listofcompany = new List<CompanyObject>();

                listofcompany = serializer.Deserialize<List<CompanyObject>>("[" + stringusercompany + "]");
                //cắt chuỗi ra từng chuỗi tường công ty riêng biệt
                List<string> listcompanypriority = new List<string>();
                foreach (var sc in listofcompany)
                {
                    listcompanypriority.Add(sc.name.ToString());
                }

                //lấy được thằng cùng trường đại học rồi hè hè
                var testcompanypriority = _usercompanyservice.GetByCompany(listcompanypriority);
                //int demcainhi = testschoolpriority.Count();

                // -- 2 -- cùng trường đại học
                var suggestFriendListcompany = _user.GetUserProfileCountFriend().Where(x => testcompanypriority.Contains(x.ID) && !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !listromove.Contains(x.ID)).Take(1).ToList();
                foreach (var suggestFriend in suggestFriendListcompany)
                {
                    //Lấy danh sách bạn của thằng suggest
                    var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID).Distinct();
                    //Đếm số lượng bạn chung
                    int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                    ////Đếm
                    //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                    //var dem=from c in _userfriend.GetAll()
                    //        where c.OwnerID
                    if (dem > 0)
                    {
                        suggestFriend.UserCount = dem;
                    }

                }
                #endregion

                #region lấy chung các thằng có điểm chung với thằng đăng nhập

                List<UserProfileAndCountUserFriend> GetListFriendSuggest = new List<UserProfileAndCountUserFriend>();
                //add cùng trường tiểu học
                foreach (var school in suggestFriendListschool)
                {
                    GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = school.AboutMe, BirthDay = school.BirthDay, CurrentAddress = school.CurrentAddress, Email = school.Email, FirstName = school.FirstName, Gender = school.Gender, HomeAddress = school.HomeAddress, LastName = school.LastName, UserName = school.UserName, ID = school.ID,UserCount=school.UserCount,SmallAvatarUrl=school.SmallAvatarUrl });
                }
                //add những thằng cùng trường đại học
                foreach (var university in suggestFriendListuniversity)
                {
                    GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = university.AboutMe, BirthDay = university.BirthDay, CurrentAddress = university.CurrentAddress, Email = university.Email, FirstName = university.FirstName, Gender = university.Gender, HomeAddress = university.HomeAddress, LastName = university.LastName, UserName = university.UserName, ID = university.ID, UserCount = university.UserCount, SmallAvatarUrl = university.SmallAvatarUrl });
                }
                //add những thằng cùng công ty
                foreach (var company in suggestFriendListuniversity)
                {
                    GetListFriendSuggest.Add(new UserProfileAndCountUserFriend { AboutMe = company.AboutMe, BirthDay = company.BirthDay, CurrentAddress = company.CurrentAddress, Email = company.Email, FirstName = company.FirstName, Gender = company.Gender, HomeAddress = company.HomeAddress, LastName = company.LastName, UserName = company.UserName, ID = company.ID, UserCount = company.UserCount, SmallAvatarUrl = company.SmallAvatarUrl });
                }

                if (GetListFriendSuggest.Count() == 0)
                {
                    GetListFriendSuggest = _user.GetUserProfileCountFriend().Where(x => !friendRequested.Contains(x.ID) && !friends.Contains(x.ID) && !listromove.Contains(x.ID)).Take(1).ToList();
                    foreach (var suggestFriend in GetListFriendSuggest)
                    {
                        //Lấy danh sách bạn của thằng suggest
                        var friendListOfSuggest = _userfriend.GetAll(f => f.OwnerID == suggestFriend.ID).Select(f => f.FriendID).Distinct();
                        //Đếm số lượng bạn chung
                        int dem = friendListOfSuggest.Count(suggestPerson => friends.Contains(suggestPerson));
                        ////Đếm
                        //int dem = _userfriend.GetAll().Where(o => friends.Contains(o.OwnerID)).ToList().Select(p => p.FriendID).Count();
                        //var dem=from c in _userfriend.GetAll()
                        //        where c.OwnerID
                        if (dem > 0)
                        {
                            suggestFriend.UserCount = dem;
                        }

                    }
                }
                //lấy 1 thằng ra add vào thằng vừa kết bạn
                if (GetListFriendSuggest.Count() > 0)
                {
                    context.Response.Write("<a href=\"" + GetListFriendSuggest[0].ProfileLink + "\" class=\"fr closeBtn\" data=\"" + GetListFriendSuggest[0].ID + "\"  idgroup=\"" + idgroup + "\"></a><div id=\"hiden_" + idgroup + "\"><a href=\"" + GetListFriendSuggest[0].ProfileLink + "\">");
                    string stringimages = "/Content/Images/male.gif";
                    if (GetListFriendSuggest[0].SmallAvatarUrl != null)
                    {
                        stringimages = GetListFriendSuggest[0].SmallAvatarUrl;

                    }
                    else
                    {
                        if (GetListFriendSuggest[0].Gender == 1)
                        {
                            stringimages = "/Content/Images/male.gif";
                        }
                        else if(GetListFriendSuggest[0].Gender == 2)
                        {
                            stringimages = "/Content/Images/female.gif";
                        }
                    }
                    context.Response.Write("<img src=\"" + stringimages + "\" alt=\"\" width=\"50\" height=\"50\" border=\"0\" />");

                    context.Response.Write("<span class=\"profile\">" + GetListFriendSuggest[0].FirstName + " " + GetListFriendSuggest[0].LastName + "</span> </a>");
                    if (GetListFriendSuggest[0].UserCount != 0)
                    {
                        context.Response.Write("<a href=\"#\" class=\"asyncPost\" style=\"color:#004D8F\" data=\"" + GetListFriendSuggest[0].ID + "\"  title=\"" + GetListFriendSuggest[0].UserCount + " bạn chung\">" + GetListFriendSuggest[0].UserCount + " bạn chung</a>");
                    }
                    else {
                        context.Response.Write("<a href=\"#\" class=\"asyncPost\"></a>");
                    }
                    context.Response.Write("<div class=\"addFri\"><span class=\"fl icon01 ico14\"></span><a href=\"#\" id=\"addFriend\" data=\"" + GetListFriendSuggest[0].ID + "\" idgroup=\"" + idgroup + "\">Kết bạn</a> </div><div class=\"clr\"> </div></div>");
                }


                #endregion


            }
            catch
            {
                context.Response.Write("lỗi kết bạn");
            }


        }


        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}