﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.SessionState;
using Social.Service.Interface.TikFriend;
using System.Web.Mvc;
using Social.Lib;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for FriendRequestDialog
    /// </summary>
    public class FriendRequestDialog : IHttpHandler, IReadOnlySessionState
    {

        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/plain";
            try
            {
                string friendid = context.Request.Form["friend"].ToString();
                IFriendRequestService _friend = DependencyResolver.Current.GetService<IFriendRequestService>();
                Social.Entity.TikFriend.FriendRequest friendrequest = new Social.Entity.TikFriend.FriendRequest();
                
                friendrequest.CreatedDate = System.DateTime.Now;
                friendrequest.FromUserID = new Guid(SessionManager.Get("UserID").ToString());
                if ( _friend.GetCountByFromUserIDAndToUserID(friendrequest.FromUserID,new Guid(friendid)) == 0)
                {
                    if (_friend.GetCountByFromUserIDAndToUserID(SessionManager.CurrentUserID(),new Guid(friendid)) > 0)
                    {
                        return;
                    }
                    friendrequest.ToUserID = new Guid(friendid);
                    friendrequest.ID = Guid.NewGuid();
                    friendrequest.Status = false;
                    friendrequest.UpdatedDate = System.DateTime.Now;
                    _friend.Add(friendrequest);
                }
                context.Response.Write("true");
                
            }
            catch
            {
                context.Response.Write("false");
            }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}