﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Social.Lib;
using Social.Service.Interface.TikMusic;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for GenObjectPlayer
    /// </summary>
    public class GenObjectPlayer : IHttpHandler
    {
        private readonly ISongService _song = DependencyResolver.Current.GetService<ISongService>();
        public void ProcessRequest(HttpContext context)
        {
            var result = "";
            var type = context.Request.QueryString["type"];
            if (string.IsNullOrEmpty(type))
            {
                type = context.Request.Form["type"];
            }
            switch (type)
            {
                case "GetObjectPlayer":
                    result = GetObjectPlayer(context);
                    break;
                default:
                    result = "";
                    break;
            }
            context.Response.ContentType = "text/plain";
            context.Response.Write(result);
        }

        private string GetObjectPlayer(HttpContext context)
        {
            var retval = "({{ObjPlayer: \"{0}\", Return: {1}}})";
            var urlFile = ConfigManager.UrlDataMusic + Base64String.Decode(context.Request.Form["urlFile"]) + ".mp3";
            var songName = context.Request.Form["songName"];
            var singer = context.Request.Form["singer"];
            var duration = context.Request.Form["duration"];
            var urlXmlSong = ConfigManager.UrlXmlSongMusic + "?urlFile=" +Base64String.Encode(urlFile) + 
                                    "&songName=" + songName + 
                                    "&singer=" + singer + 
                                    "&duration=" + duration;
            var obj = Lib.Music.MusicUtil.GeneratePlayerSong(urlXmlSong, ConfigManager.MainDomain, true).Replace("\"", "&quot;").Replace("'", "&#039;");
            return string.Format(retval, obj, "1");
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}