﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Web;
using System.Web.Mvc;
using System.Web.Script.Serialization;
using Social.Lib.Photo;
using Social.Service.Interface.TikPhoto;
using Social.Web.Extends.Helper;
using Social.Lib;

namespace Social.Web.Service
{
    public class PhotoService
    {
        IPhotoService _photo = DependencyResolver.Current.GetService<IPhotoService>();
        IAlbumService _album = DependencyResolver.Current.GetService<IAlbumService>();
        //Up On wall
        public string UploadWall(byte[] bytes, Guid userId)
        {
            //var content = new Byte[file.ContentLength];
            //file.InputStream.Read(content, 0, file.ContentLength);
            if (bytes.Length <= 0)
            {
                return "-1";// chưa chọn file
            }

            try
            {
                var filename = DateTime.Now.Ticks.ToString();
                var pathCreate = "";
                var pathSave = "";

                pathCreate = DateTime.Now.ToString("yyyyMM") + "/" + DateTime.Now.ToString("ddHH") + "/";
                pathSave = ConfigManager.PathResourcePhoto + pathCreate;
                var WxH = "0x0";

                var ms = new MemoryStream();
                ms.Write(bytes, 0, bytes.Length);
                ms.Seek(0, SeekOrigin.Begin);
                if (ms.Length > 0)
                {
                    var imagefullsize = System.Drawing.Image.FromStream(ms);
                    var oldW = imagefullsize.Width;
                    var oldH = imagefullsize.Height;

                    int thumMainW;
                    int thumMainH;
                    if (oldW > Constants.ImageInfo.SizeThumMainW)
                    {
                        double dblCoef = Constants.ImageInfo.SizeThumMainW/(double) oldW;
                        thumMainW = Convert.ToInt32(dblCoef*oldW);
                        thumMainH = Convert.ToInt32(dblCoef*oldH);
                    }
                    else
                    {
                        thumMainW = oldW;
                        thumMainH = oldH;
                    }
                    if (thumMainH > 600)
                    {
                        double dblCoef = 600 / (double)thumMainH;
                        thumMainW = Convert.ToInt32(dblCoef * thumMainW);
                        thumMainH = Convert.ToInt32(dblCoef * thumMainH);
                    }

                    int thumZoomW;
                    int thumZoomH;
                    if (oldW > Constants.ImageInfo.SizeThumbZoomW)
                    {
                        double dblCoef = Constants.ImageInfo.SizeThumbZoomW / (double)oldW;
                        thumZoomW = Convert.ToInt32(dblCoef * oldW);
                        thumZoomH = Convert.ToInt32(dblCoef * oldH);
                    }
                    else
                    {
                        thumZoomW = oldW;
                        thumZoomH = oldH;
                    }
                    WxH = thumZoomW + "x" + thumZoomH;
                    ms.Seek(0, SeekOrigin.Begin);
                    var data = ms.GetBuffer();

                    var w = new[] { oldW, thumZoomW, thumMainW, Constants.ImageInfo.SizeThumbW, Constants.ImageInfo.SizeThumbAlbumSlideW };
                    var h = new[] { oldH, thumZoomH, thumMainH, Constants.ImageInfo.SizeThumbH, Constants.ImageInfo.SizeThumbAlbumSlideH };
                    var nameFiles = new[]
                                        {
                                            filename + Constants.ImageInfo.NameOriginal,
                                            filename + Constants.ImageInfo.NameThumbZoom,
                                            filename + Constants.ImageInfo.NameThumMain,
                                            filename + Constants.ImageInfo.NameThumb,
                                            filename + Constants.ImageInfo.NameThumbAlbumSline
                                        };
                    var crop = new[] {false,false, false, true, true};
                    try
                    {
                        if (Directory.Exists(pathSave) == false)
                        {
                            Directory.CreateDirectory(pathSave);
                        }
                    }
                    catch{}

                    var quality = ResizeImage.Quality(bytes.Length);

                    var multi = new MultiUpload[5];
                    for (var j = 0; j < 5; j++)
                    {
                        multi[j] = new MultiUpload(data, pathSave + nameFiles[j], w[j], h[j],
                                                    quality[j], crop[j]);
                        multi[j].Start();
                    }

                    for (var j = 0; j < 5; j++)
                    {
                        multi[j].Join();
                    }

                    var _pathSaveDB = pathCreate + filename;
                    var info = new Entity.TikPhoto.Photo();
                    info.ID = Guid.NewGuid();
                    info.Caption = "";
                    var abRv = _album.GetByUserIdTypeAlbum(userId, 2);
                    Entity.TikPhoto.Album abWall;
                    abWall = abRv.Count <= 0 ? null : abRv[0];
                    if (abWall != null)
                    {
                        info.AlbumID = abWall.ID;
                        if (string.IsNullOrEmpty(abWall.SourceUrlCoverPhoto))
                        {
                            abWall.CoverPhotoID = info.ID;
                            abWall.SourceUrlCoverPhoto = _pathSaveDB;
                        }
                        abWall.PhotoCount = abWall.PhotoCount + 1;
                        _album.Update(abWall);
                    }
                    else
                    {
                        var abW = new Entity.TikPhoto.Album
                                      {
                                          AlbumName = "Ảnh chia sẻ",
                                          CoverPhotoID = info.ID,
                                          SourceUrlCoverPhoto = _pathSaveDB,
                                          ID = Guid.NewGuid(),
                                          UserID = userId,
                                          Description = "Ảnh chia sẻ",
                                          Location = "",
                                          PrivacyType = 1,
                                          Type = 2,
                                          PhotoCount = 1,
                                          CreatedDate = DateTime.Now,
                                          ModifiedDate = DateTime.Now
                                      };
                        _album.Add(abW);
                        info.AlbumID = abW.ID;
                    }
                    info.SourceUrl = _pathSaveDB;
                    info.UserID = userId;
                    info.WxH = WxH;
                    info.CreatedDate = DateTime.Now;
                    info.ModifiedDate = DateTime.Now;
                    _photo.Add(info);

                    var jss = new JavaScriptSerializer();
                    var sbControls = new StringBuilder();
                    jss.Serialize(info, sbControls);
                    return sbControls.ToString();
                }
                return "-2";
            }
            catch { return "-3"; }//Lỗi ko upload được
        }
        //Up Avatar
        public string UploadAvatar(byte[] bytes, Guid userId)
        {
            if (bytes.Length <= 0)
            {
                return "-1";// chưa chọn file
            }

            try
            {
                var filename = DateTime.Now.Ticks.ToString();
                var pathCreate = "";
                var pathSave = "";

                pathCreate = DateTime.Now.ToString("yyyyMM") + "/" + DateTime.Now.ToString("ddHH") + "/";
                pathSave = ConfigManager.PathResourcePhoto + pathCreate;
                var WxH = "0x0";
                var ms = new MemoryStream();
                ms.Write(bytes, 0, bytes.Length);
                ms.Seek(0, SeekOrigin.Begin);
                if (ms.Length > 0)
                {
                    var imagefullsize = System.Drawing.Image.FromStream(ms);
                    var oldW = imagefullsize.Width;
                    var oldH = imagefullsize.Height;

                    int thumMainW;
                    int thumMainH;
                    if (oldW > Constants.ImageInfo.SizeThumMainW)
                    {
                        double dblCoef = Constants.ImageInfo.SizeThumMainW / (double)oldW;
                        thumMainW = Convert.ToInt32(dblCoef * oldW);
                        thumMainH = Convert.ToInt32(dblCoef * oldH);
                    }
                    else
                    {
                        thumMainW = oldW;
                        thumMainH = oldH;
                    }
                    if (thumMainH > 600)
                    {
                        double dblCoef = 600 / (double)thumMainH;
                        thumMainW = Convert.ToInt32(dblCoef * thumMainW);
                        thumMainH = Convert.ToInt32(dblCoef * thumMainH);
                    }

                    int thumZoomW;
                    int thumZoomH;
                    if (oldW > Constants.ImageInfo.SizeThumbZoomW)
                    {
                        double dblCoef = Constants.ImageInfo.SizeThumbZoomW / (double)oldW;
                        thumZoomW = Convert.ToInt32(dblCoef * oldW);
                        thumZoomH = Convert.ToInt32(dblCoef * oldH);
                    }
                    else
                    {
                        thumZoomW = oldW;
                        thumZoomH = oldH;
                    }
                    WxH = thumZoomW + "x" + thumZoomH;
                    ms.Seek(0, SeekOrigin.Begin);
                    var data = ms.GetBuffer();

                    var w = new[] { oldW, thumZoomW, thumMainW, Constants.ImageInfo.SizeThumbW, Constants.ImageInfo.SizeThumbAlbumSlideW };
                    var h = new[] { oldH, thumZoomH, thumMainH, Constants.ImageInfo.SizeThumbH, Constants.ImageInfo.SizeThumbAlbumSlideH };
                    var nameFiles = new[]
                                        {
                                            filename + Constants.ImageInfo.NameOriginal,
                                            filename + Constants.ImageInfo.NameThumbZoom,
                                            filename + Constants.ImageInfo.NameThumMain,
                                            filename + Constants.ImageInfo.NameThumb,
                                            filename + Constants.ImageInfo.NameThumbAlbumSline
                                        };
                    var crop = new[] { false, false, false, true, true };
                    try
                    {
                        if (Directory.Exists(pathSave) == false)
                        {
                            Directory.CreateDirectory(pathSave);
                        }
                    }
                    catch { }

                    var quality = ResizeImage.Quality(bytes.Length);

                    var multi = new MultiUpload[5];
                    for (var j = 0; j < 5; j++)
                    {
                        multi[j] = new MultiUpload(data, pathSave + nameFiles[j], w[j], h[j],
                                                    quality[j], crop[j]);
                        multi[j].Start();
                    }

                    for (var j = 0; j < 5; j++)
                    {
                        multi[j].Join();
                    }

                    var _pathSaveDB = pathCreate + filename;
                    var info = new Entity.TikPhoto.Photo();
                    info.ID = Guid.NewGuid();
                    info.Caption = "";
                    var abRv = _album.GetByUserIdTypeAlbum(userId, 1);
                    Entity.TikPhoto.Album abProfile;
                    abProfile = abRv.Count <= 0 ? null : abRv[0];
                    if (abProfile != null)
                    {
                        abProfile.CoverPhotoID = info.ID;
                        abProfile.SourceUrlCoverPhoto = _pathSaveDB;
                        abProfile.PhotoCount = abProfile.PhotoCount + 1;
                        _album.Update(abProfile);
                        info.AlbumID = abProfile.ID;
                    }
                    else
                    {
                        var abP = new Entity.TikPhoto.Album
                                      {
                                          AlbumName = "Ảnh đại diện",
                                          CoverPhotoID = info.ID,
                                          SourceUrlCoverPhoto = _pathSaveDB,
                                          ID = Guid.NewGuid(),
                                          UserID = userId,
                                          Description = "Ảnh đại diện",
                                          Location = "",
                                          PrivacyType = 1,
                                          PhotoCount = 1,
                                          Type = 1,
                                          CreatedDate = DateTime.Now,
                                          ModifiedDate = DateTime.Now
                                      };
                        _album.Add(abP);
                        info.AlbumID = abP.ID;
                    }
                    info.SourceUrl = _pathSaveDB;
                    info.UserID = userId;
                    info.WxH = WxH;
                    info.CreatedDate = DateTime.Now;
                    info.ModifiedDate = DateTime.Now;
                    _photo.Add(info);

                    var jss = new JavaScriptSerializer();
                    var sbControls = new StringBuilder();
                    jss.Serialize(info, sbControls);
                    return sbControls.ToString();
                }
                return "-2";
            }
            catch { return "-3"; }//Lỗi ko upload được
        }
        //Up On _Note
        public string UploadNote(byte[] bytes, Guid userId)
        {
            //var content = new Byte[file.ContentLength];
            //file.InputStream.Read(content, 0, file.ContentLength);
            if (bytes.Length <= 0)
            {
                return "-1";// chưa chọn file
            }

            try
            {
                var filename = DateTime.Now.Ticks.ToString();
                var pathCreate = "";
                var pathSave = "";

                pathCreate = DateTime.Now.ToString("yyyyMM") + "/" + DateTime.Now.ToString("ddHH") + "/";
                pathSave = ConfigManager.PathResourcePhoto + pathCreate;
                var WxH = "0x0";

                var ms = new MemoryStream();
                ms.Write(bytes, 0, bytes.Length);
                ms.Seek(0, SeekOrigin.Begin);
                if (ms.Length > 0)
                {
                    var imagefullsize = System.Drawing.Image.FromStream(ms);
                    var oldW = imagefullsize.Width;
                    var oldH = imagefullsize.Height;

                    int thumMainW;
                    int thumMainH;
                    if (oldW > Constants.ImageInfo.SizeThumMainW)
                    {
                        double dblCoef = Constants.ImageInfo.SizeThumMainW / (double)oldW;
                        thumMainW = Convert.ToInt32(dblCoef * oldW);
                        thumMainH = Convert.ToInt32(dblCoef * oldH);
                    }
                    else
                    {
                        thumMainW = oldW;
                        thumMainH = oldH;
                    }
                    if (thumMainH > 600)
                    {
                        double dblCoef = 600 / (double)thumMainH;
                        thumMainW = Convert.ToInt32(dblCoef * thumMainW);
                        thumMainH = Convert.ToInt32(dblCoef * thumMainH);
                    }

                    int thumZoomW;
                    int thumZoomH;
                    if (oldW > Constants.ImageInfo.SizeThumbZoomW)
                    {
                        double dblCoef = Constants.ImageInfo.SizeThumbZoomW / (double)oldW;
                        thumZoomW = Convert.ToInt32(dblCoef * oldW);
                        thumZoomH = Convert.ToInt32(dblCoef * oldH);
                    }
                    else
                    {
                        thumZoomW = oldW;
                        thumZoomH = oldH;
                    }
                    WxH = thumZoomW + "x" + thumZoomH;
                    ms.Seek(0, SeekOrigin.Begin);
                    var data = ms.GetBuffer();

                    var w = new[] { oldW, thumZoomW, thumMainW, Constants.ImageInfo.SizeThumbW, Constants.ImageInfo.SizeThumbAlbumSlideW };
                    var h = new[] { oldH, thumZoomH, thumMainH, Constants.ImageInfo.SizeThumbH, Constants.ImageInfo.SizeThumbAlbumSlideH };
                    var nameFiles = new[]
                                        {
                                            filename + Constants.ImageInfo.NameOriginal,
                                            filename + Constants.ImageInfo.NameThumbZoom,
                                            filename + Constants.ImageInfo.NameThumMain,
                                            filename + Constants.ImageInfo.NameThumb,
                                            filename + Constants.ImageInfo.NameThumbAlbumSline
                                        };
                    var crop = new[] { false, false, false, true, true };
                    try
                    {
                        if (Directory.Exists(pathSave) == false)
                        {
                            Directory.CreateDirectory(pathSave);
                        }
                    }
                    catch { }

                    var quality = ResizeImage.Quality(bytes.Length);

                    var multi = new MultiUpload[5];
                    for (var j = 0; j < 5; j++)
                    {
                        multi[j] = new MultiUpload(data, pathSave + nameFiles[j], w[j], h[j],
                                                    quality[j], crop[j]);
                        multi[j].Start();
                    }

                    for (var j = 0; j < 5; j++)
                    {
                        multi[j].Join();
                    }

                    var _pathSaveDB = pathCreate + filename;
                    var info = new Entity.TikPhoto.Photo();
                    info.ID = Guid.NewGuid();
                    info.Caption = "";
                    var abRv = _album.GetByUserIdTypeAlbum(userId, 4);
                    Entity.TikPhoto.Album abNote;
                    abNote = abRv.Count <= 0 ? null : abRv[0];
                    if (abNote != null)
                    {
                        info.AlbumID = abNote.ID;
                        if (string.IsNullOrEmpty(abNote.SourceUrlCoverPhoto))
                        {
                            abNote.CoverPhotoID = info.ID;
                            abNote.SourceUrlCoverPhoto = _pathSaveDB;
                        }
                        abNote.PhotoCount = abNote.PhotoCount + 1;
                        _album.Update(abNote);
                    }
                    else
                    {
                        var abW = new Entity.TikPhoto.Album
                                      {
                                          AlbumName = "Ảnh trong bài viết",
                                          CoverPhotoID = info.ID,
                                          SourceUrlCoverPhoto = _pathSaveDB,
                                          ID = Guid.NewGuid(),
                                          UserID = userId,
                                          Description = "Ảnh trong bài viết",
                                          Location = "",
                                          PrivacyType = 1,
                                          Type = 4,
                                          PhotoCount = 1,
                                          CreatedDate = DateTime.Now,
                                          ModifiedDate = DateTime.Now
                                      };
                        _album.Add(abW);
                        info.AlbumID = abW.ID;
                    }
                    info.SourceUrl = _pathSaveDB;
                    info.UserID = userId;
                    info.WxH = WxH;
                    info.CreatedDate = DateTime.Now;
                    info.ModifiedDate = DateTime.Now;
                    _photo.Add(info);

                    var jss = new JavaScriptSerializer();
                    var sbControls = new StringBuilder();
                    jss.Serialize(info, sbControls);
                    return sbControls.ToString();
                }
                return "-2";
            }
            catch { return "-3"; }//Lỗi ko upload được
        }
    }
}