﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Social.Service.Interface.TikFriend;
using System.Web.Mvc;
using Social.Entity.TikFriend;
using Social.Service.Interface.Tik;
using Social.Lib;
using System.Web.SessionState;
using Social.Service.Interface.TikActivity;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for RequestListFriend
    /// </summary>
    public class RequestListFriend : IHttpHandler, IReadOnlySessionState
    {

        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/plain";
            try
            {


                string cId = context.Request.Form["friend"].ToString();
                //string cId = context.Request.Form["friend"].ToString();
                string cImg = context.Request.Form["img"].ToString();
                string cFullName = context.Request.Form["fullname"].ToString();
                string cToId = context.Request.Form["toid"].ToString();

                Guid guid = new Guid(SessionManager.Get("UserID").ToString());
                Guid cGuid = new Guid(cToId);
                Guid guid_Id = new Guid(cId);

                IUserFriendService _user = DependencyResolver.Current.GetService<IUserFriendService>();
                IUserProfileService _userprofile = DependencyResolver.Current.GetService<IUserProfileService>();
                IFriendSearchService _friensearchservice = DependencyResolver.Current.GetService<IFriendSearchService>();
                IFriendListService _friendlistservice = DependencyResolver.Current.GetService<IFriendListService>();
                IFriendInListService _friendinlistservice = DependencyResolver.Current.GetService<IFriendInListService>();
                IUserActivityService _userActivity = DependencyResolver.Current.GetService<IUserActivityService>();
                IFriendRequestService _friendrequest = DependencyResolver.Current.GetService<IFriendRequestService>();
                try
                {
                    var friendlist0 = _friendlistservice.GetStringFriendList(cGuid);
                    foreach (var _friend in friendlist0)
                    {
                        var editFriendinlist = _friendinlistservice.GetByFriendListAndFriendId(_friend.ID, guid).Single();
                        editFriendinlist.Status = true;
                        _friendinlistservice.Update(editFriendinlist);
                    }
                }
                catch { }


                UserFriend userfriend = new UserFriend();
                //UserFriend userfriend1 = new UserFriend();

                var friendprofile0 = _userprofile.Single(c => c.ID == cGuid);
                userfriend.ID = Guid.NewGuid();
                userfriend.FriendUserName = friendprofile0.UserName;
                userfriend.FriendFullName = cFullName;
                //userfriend.FriendUserName = userfriend;
                userfriend.OwnerID = guid;
                userfriend.Status = true;
                userfriend.UpdatedDate = System.DateTime.Now;
                try
                {
                    userfriend.FriendSmallAvatarUrl = friendprofile0.SmallAvatarUrl;
                }
                catch { }
                userfriend.FriendID = cGuid;
                userfriend.CreatedDate = System.DateTime.Now;

                // enity friendsearch
                
                FriendSearch _friendsearch = new FriendSearch();
                //FriendSearch _friendsearch1 = new FriendSearch();
                _friendsearch.FriendFullName = cFullName;
                _friendsearch.FriendID = cGuid;
                try
                {
                    _friendsearch.FriendSmallAvatarUrl = friendprofile0.SmallAvatarUrl;
                }
                catch { }
                _friendsearch.FullTextName = Social.Lib.Utility.Utility.RemoveSign4VietnameseString(cFullName) + " , " + cFullName;
                //bỏ dấu tiếng việt cho fullname cho vào fulltextsearch
                
                string removevietnamese = Social.Lib.Utility.Utility.RemoveSign4VietnameseString(cFullName);
                _friendsearch.FullText = removevietnamese + ", " + cFullName + ", " + friendprofile0.Email + ", " + friendprofile0.UserName;
                
                _friendsearch.OwnerID = guid;
                _friendsearch.ID = Guid.NewGuid();
                _friendsearch.UserName = friendprofile0.UserName;

                if (_user.GetCountByUserFriend(guid, cGuid) > 0)
                {
                    _friendrequest.Delete(c => (c.FromUserID == cGuid && c.ToUserID == guid) || ((c.FromUserID == guid && c.ToUserID == cGuid)));
                    return;
                }
                // gửi để tìm kiếm theo bạn
                _friensearchservice.Add(_friendsearch);
                _user.Add(userfriend);


                // thêm mới vào danh sách bạn

                var friendprofile2 = _userprofile.Single(c => c.ID == guid);
                UserFriend userfriend1 = new UserFriend();
                userfriend1.ID = Guid.NewGuid();
                userfriend1.FriendFullName = friendprofile2.FullName;
                userfriend1.OwnerID = cGuid;
                userfriend1.Status = true;
                userfriend1.UpdatedDate = System.DateTime.Now;
                userfriend1.FriendSmallAvatarUrl = friendprofile2.SmallAvatarUrl;
                userfriend1.FriendID = guid;
                userfriend1.CreatedDate = System.DateTime.Now;
                userfriend1.FriendUserName = friendprofile2.UserName;

                // enity friendsearch
                FriendSearch _friendsearch1 = new FriendSearch();
                //FriendSearch _friendsearch1 = new FriendSearch();

                var friendprofile1 = _userprofile.Single(c => c.ID == guid);

                _friendsearch1.FriendFullName = friendprofile1.FullName;
                _friendsearch1.FriendID = guid;
                _friendsearch1.UserName = friendprofile1.UserName;
                _friendsearch1.FriendSmallAvatarUrl = friendprofile1.SmallAvatarUrl;
                _friendsearch1.FullTextName = Social.Lib.Utility.Utility.RemoveSign4VietnameseString(friendprofile1.FullName) + " , " + friendprofile1.FullName;
                //bỏ dấu tiếng việt cho fullname cho vào fulltextsearch

                string removevietnamese1 = Social.Lib.Utility.Utility.RemoveSign4VietnameseString(friendprofile1.FullName);
                _friendsearch1.FullText = removevietnamese1 + ", " + friendprofile1.FullName + ", " + friendprofile1.Email + ", " + friendprofile1.UserName;
                _friendsearch1.OwnerID = cGuid;
                _friendsearch1.ID = Guid.NewGuid();

                // gửi để tìm kiếm theo bạn
                _friensearchservice.Add(_friendsearch1);
                _user.Add(userfriend1);

                _friendrequest.Delete(c => (c.FromUserID == cGuid && c.ToUserID == guid) || ((c.FromUserID == guid && c.ToUserID == cGuid)));

                _userActivity.MakeFriend(cGuid, guid, DateTime.Now);
                context.Response.Write("<div class=\"rp_list_sub\"><div class=\"ipe_friend_ico\"><span class=\"icon01 ico14 left\">&nbsp;</span></div><div class=\"ipe_friend_suggest\"><div>Bạn và <a href=\"" + friendprofile0.ProfileLink + "\">" + cFullName + "</a> đã là bạn của nhau. Hãy sang thăm <a href=\"" + friendprofile0.ProfileLink + "\">trang cá nhân của bạn ấy</a>!</div></div><div class=\"clear\"></div></div>");

            }
            catch {
                string friendcancel = context.Request.Form["friendcancel"].ToString();
                Guid id = new Guid(friendcancel);
                
                IFriendRequestService _friendrequest = DependencyResolver.Current.GetService<IFriendRequestService>();
                var guiddelete = _friendrequest.Single(c => c.ID == id);
                Guid _id = guiddelete.FromUserID;
                Guid _toid = guiddelete.ToUserID;

                _friendrequest.Delete(it => it.FromUserID == _id && it.ToUserID == _toid);
                _friendrequest.Delete(it => it.FromUserID == _toid && it.ToUserID == _id);
                long dem = _friendrequest.GetAll().Count;
                context.Response.Write(dem);
            }

        }



        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}