﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using Social.Service.Interface.Tik;
using System.Web.Mvc;
using Social.Lib.Photo;
using Social.Service.Interface.TikFriend;
using System.Web.SessionState;
using Social.Lib;
using Social.Entity.Tik;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for SearchFullText
    /// </summary>
    public class SearchFullText : IHttpHandler, IReadOnlySessionState
    {

        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/plain";
            string key = context.Request.Form["searchword"].Trim().ToUpper();

            //khai báo mấy lớp Inteface cái nhỉ
            IUserProfileService _user = DependencyResolver.Current.GetService<IUserProfileService>();
            IUserFriendService _userfrienservice = DependencyResolver.Current.GetService<IUserFriendService>();
            IFriendSearchService _friendsearchservice = DependencyResolver.Current.GetService<IFriendSearchService>();
            IUserSearchService _usersearchserivce = DependencyResolver.Current.GetService<IUserSearchService>();




            //lấy guid của thằng đăng nhập
            Guid ownerID=new Guid(SessionManager.Get("UserID").ToString());


            //lấy ra top 5 các thằng có trong danh sách bạn của thằng đăng nhập
            var friendlistfriend= _friendsearchservice.GetByOwnerIDAndKeyWord(ownerID, key, 5);
            List<UserSearch> ListFriend = new List<UserSearch>();
            if (friendlistfriend.Count() > 0)
            {
                foreach (var friend in friendlistfriend)
                {
                    string usfriend = _user.GetByID(friend.FriendID).UserName.ToString();
                    ListFriend.Add(new UserSearch { FullName= friend.FriendFullName,SmallAvatar = friend.FriendSmallAvatarUrl, UserID = friend.FriendID,Username=usfriend });
                }
            }
            //var listusersearch = _usersearchserivce.GetByFullText(key, 5);
            int dem = ListFriend.Count();
            if (dem < 5)
            {
                try
                {
                    var listusersearch = _usersearchserivce.GetByFullText(key, 5 - dem,ListFriend.Select(f=>f.UserID).ToArray());
                    foreach (var _fr in listusersearch)
                    {                        
                        ListFriend.Add(new UserSearch { FullName = _fr.FullName, SmallAvatar = _fr.SmallAvatar, UserID = _fr.UserID, Username = _fr.Username });
                    }
                }
                catch { }

            }
            
            if (ListFriend.Count > 0)
            {
                context.Response.Write("<div style='background: none repeat scroll 0 0 #F0F6FB;color: #666666 !important;font-weight: bold; height: 20px;padding-top:5px;'>Bạn có thể quen</div>");
                foreach (var c in ListFriend)
                {

                    context.Response.Write("<a href=\""+ ConfigManager.MainDomain + "/" + c.Username + "\"><div class='display_box'><table><tr><td>");
                    context.Response.Write("<img src='" + c.SmallAvatar + "' class='image' style='width:50px;height:50px;' /></td>");
                    context.Response.Write("<td valign=\"top\"><a href='" + ConfigManager.MainDomain + "/" + c.Username + "' class='addname' title='" + c.FullName + "'>");
                    context.Response.Write(c.FullName + "</a></td></tr>");
                    context.Response.Write("</table></div></a>");
                }
                if (ListFriend.Count > 4)
                {
                    context.Response.Write("<div class='moresearch btnaddmoresearch' ><a>Xem thêm</a></div>");
                }
            }
            else {
                context.Response.Write("<div style='background: none repeat scroll 0 0 #F0F6FB;color: #666666 !important;font-weight: bold; height: 20px;padding-top:5px;'>Không tìm thấy dữ liệu</div>");
            }
            
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}