﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Text;
using System.Web.Mvc;
using Social.Lib;
using Social.Service.Interface.TikFriend;
using System.Web.Script.Serialization;
using Social.Web.Extends.Helper;
using System.Web.SessionState;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for SelectFriend
    /// </summary>
    public class SelectFriend : IHttpHandler,IReadOnlySessionState
    {

        public void ProcessRequest(HttpContext context)
        {
            try
            {
                context.Response.ContentType = "application/json";
                context.Response.ContentEncoding = Encoding.UTF8;

                if (context.Request.UrlReferrer == null) return;
                if (!context.Request.UrlReferrer.Host.Equals(context.Request.Url.Host)) return;

                string query = context.Request.Form["query"];
                int top = string.IsNullOrEmpty(context.Request.Form["limit"]) ? 0 : Convert.ToInt32(context.Request.Form["limit"]);
                if (string.IsNullOrEmpty(query))
                {
                    context.Response.Write(" ");
                    return;
                }
                top = top > 0 ? 5 : top;
                var _friendsearchService = DependencyResolver.Current.GetService<IFriendSearchService>();
                var listFriend = _friendsearchService.GetByOwnerIDAndKeyWord_FullTextName(SessionManager.CurrentUserID(), query, top);  
                //add my self
                string currentName=SessionManager.CurrentUserFullName();
                string search=currentName+","+Lib.Utility.Utility.RemoveSign4VietnameseString(currentName);
                if (search.ToLower().Contains(query.ToLower()))
                    listFriend.Insert(0,new Entity.TikFriend.FriendSearch { FriendFullName = currentName, UserName = SessionManager.CurrentUserUserName(), FriendID = SessionManager.CurrentUserID(), FriendSmallAvatarUrl = SessionManager.CurrentSmallAvatar(),FullTextName=search });
                //
                JavaScriptSerializer serializer = new JavaScriptSerializer();
                var output = serializer.Serialize(listFriend);
                context.Response.Write(output);
            }
            catch (Exception ex) { context.Response.Write("Error"); LogHelper.Error("Select Friend Error: " + ex.Message); }
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}

