﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Web;
using System.Web.Mvc;
using Social.Entity.TikMusic;
using Social.Lib;
using Social.Service.Interface.TikMusic;
namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for XmlAlbum
    /// </summary>
    public class XmlAlbum : IHttpHandler
    {
        private readonly IAlbumService _album = DependencyResolver.Current.GetService<IAlbumService>();
        private readonly ISongService _song= DependencyResolver.Current.GetService<ISongService>();
        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/xml";
            context.Response.ContentEncoding = Encoding.UTF8;
            var abId = context.Request.QueryString["abId"];
            if (string.IsNullOrEmpty(abId)) abId = "0";
            var _abId = Guid.Empty;
            if (abId != "0") _abId = Guid.Parse(abId);
            var sb = new StringBuilder();
            if(_abId!=Guid.Empty)
            {
                List<Song> lstSong; 
                var key = Lib.Music.Constants.MemcacheKey.LIST_MUSIC_ALBUM + _abId;
                var obj = Memcached.MainCache.Get(key);
                if (obj != null)
                {
                    lstSong = (List<Song>)obj;
                }
                else
                {
                    lstSong = _song.GetByAlbumId(_abId);
                    Memcached.MainCache.Store(Enyim.Caching.Memcached.StoreMode.Set, key, lstSong,
                                              TimeSpan.FromMinutes(Lib.Music.Constants.MemcacheKey.TIME_CACHE_LMA));
                }
                var albumName = context.Request.QueryString["abName"];
                sb.Append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
                sb.Append("<rss version=\"2.0\" xmlns:media=\"http://search.yahoo.com/mrss/\" xmlns:jwplayer=\"http://developer.longtailvideo.com/trac/\">");
                sb.Append("<channel>");
                sb.AppendFormat("<title><![CDATA[{0}]]></title>", albumName);
                var urlFile = "";
                foreach (var song in lstSong)
                {
                    urlFile = ConfigManager.UrlDataMusic + song.SourceUrl + ".mp3";
                    sb.Append("<item>"); 
                    sb.AppendFormat("<title><![CDATA[{0}]]></title>", song.SongName);
                    sb.AppendFormat("<media:content url=\"{0}\" />", urlFile);
                    sb.Append("<media:thumbnail url=\"\"/>");
                    sb.AppendFormat("<description><![CDATA[{0}]]></description>", song.Singer);
                    sb.AppendFormat("<jwplayer:duration>{0}</jwplayer:duration>", song.Duration);
                    sb.Append("</item>");
                }
                sb.Append("</channel>");
                sb.Append("</rss>");
            }
            context.Response.Write(sb.ToString());
        }
        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}