﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using Social.Lib;

namespace Social.Web.Service
{
    /// <summary>
    /// Summary description for XmlSong
    /// </summary>
    public class XmlSong : IHttpHandler
    {

        public void ProcessRequest(HttpContext context)
        {
            context.Response.ContentType = "text/xml";
            context.Response.ContentEncoding = Encoding.UTF8;
            var sb = new StringBuilder();
            var urlFile = Base64String.Decode(context.Request.QueryString["urlFile"]);
            var songName = Base64String.Decode(context.Request.QueryString["songName"]);
            var singer = Base64String.Decode(context.Request.QueryString["singer"]);
            var duration = context.Request.QueryString["duration"];

            sb.Append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
            sb.Append("<rss version=\"2.0\" xmlns:media=\"http://search.yahoo.com/mrss/\" xmlns:jwplayer=\"http://developer.longtailvideo.com/trac/\">");
            sb.Append("<channel>");
            sb.AppendFormat("<title><![CDATA[{0}]]></title>", "SiglerSong");
            sb.Append("<item>");
            sb.AppendFormat("<title><![CDATA[{0}]]></title>", songName);
            sb.AppendFormat("<media:content url=\"{0}\" />", urlFile);
            sb.Append("<media:thumbnail url=\"\"/>");
            sb.AppendFormat("<description><![CDATA[{0}]]></description>", singer);
            sb.AppendFormat("<jwplayer:duration>{0}</jwplayer:duration>", duration);
            sb.Append("</item>");
             
            sb.Append("</channel>");
            sb.Append("</rss>");
             
            context.Response.Write(sb.ToString());
        }

        public bool IsReusable
        {
            get
            {
                return false;
            }
        }
    }
}